/*
 * akahukuplus
 *	   for Opera Browser (10 or later, userjs required),
 *		   Google Chrome (extension system required),
 *		   Microsoft InternetExplorer (7 or later, Proxomitron required)
 *
 *	   $Revision: 223 $
 *	   $Date: 2010-11-24 22:57:16 +0900 (水, 24 11 2010) $
 *
 * Opera での使い方（ユーザスクリプト）
 *
 *   1. 適当なふたば上のサイトで右クリックし「サイトごとの設定を編集...」を選択
 *   2. サイトを 2chan.net に書き換え、スクリプトタブのユーザー Javascript 
 *      フォルダに akahukuplus.js を置いたフォルダを指定する
 *   3. OK を押し、リロードする。ページの左下端にリンクが追加されてるので押して
 *      設定する
 *
 * Opera での使い方（experimental: Extension system required）
 *
 *   Opera で akahukuplus.oex をインストールします
 *
 * Google Chrome での使い方
 *
 *   Chrome で akahukuplus.crx をインストールします
 *
 * IE での使い方
 *
 *   Proxomitron が必要です。
 *   詳しくはドキュメントを見るべし
 */

/**
 * content loader via iframe 
 */

if (window && window.opera && parent != self && document && typeof(Akahuku) == 'undefined' &&
	/^[^.]+\.2chan\.net$/.test(location.host) && /[?&]akahuku-bogo-get=i\d+_\d+/.test(location.search)) {
	document.documentElement.appendChild(
		(function(){var s=document.createElement('style');s.type="text/css";return s;})())
		.appendChild(document.createTextNode('body,img,iframe,object,embed{display:none !important}'));
	document.addEventListener('DOMContentLoaded', function(){
		var html = document.documentElement.outerHTML;
		var origin = location.protocol+'//'+location.host;
		try{window.parent.postMessage(html, origin);return;}catch(e){}
	}, false);
}

/**
 * check whether the page should be install akahukuplus
 */

else if (window && document && document.documentElement.nodeName.toLowerCase() == 'html' && 
		document.compatMode && typeof(Akahuku) == 'undefined' &&
		/* fix for html restructuring on may (2010.2) */
		 (window.opera/* && /^(?:BackCompat|QuirksMode)$/.test(document.compatMode)*/ ||
		  window.ActiveXObject && document.compatMode == 'CSS1Compat' ||
		  window.chrome && chrome.extension /*&& document.compatMode == 'BackCompat'*/) &&
		 (/^http:\/\/(?:cgi|dat|img|jun|may|nov|orz|tmp|up|zip|dec)\.2chan\.net(?::\d+)?\/[^\/]+\//.test(location.href) ||
		  /^http:\/\/www\.2chan\.net(?::\d+)?\/(?:h|oe|junbi)\//.test(location.href))) {

/**
 * akahukuplus installer set
 */

(function (window, document) {

/** empty function */
var emptyfunc = function(){};

/** getElementById wrapper, bind, $bind shortcut of bindAsEventListener - from prototype.js */
var $ = function (arg) { return typeof arg == 'string' ? document.getElementById(arg) : arg; },
	$T = function (tagName, element) { return ($(element) || document).getElementsByTagName(tagName); },
	$N = function (name, element) { return ($(element) || document).getElementsByName(name); };

Function.prototype.bind = function (object) {
	var __method = this;
	return function () {
		try {return __method.apply(object, arguments)} 
		catch (e) {Akahuku.log(e.toString().replace(/[\r\n]/g, ' ') + '\n' + __method.toString())}
	}
};
Function.prototype.$bind = function (object) {
	var __method = this;
	return function (e) {
		try {return __method.call(object, new EventWrapperClass(e))} 
		catch (e) {Akahuku.log(e.toString().replace(/[\r\n]/g, ' ') + '\n' + __method.toString())}
	}
};

/** html special chars converter */
new function () {
	var enkeys = {'&':'&amp;', '"':'&quot;', "'":'&#x27;', '<':'&lt;', '>':'&gt;'},
		dekeys = {'&amp;':'&', '&quot;':'"', '&lt;':'<', '&gt;':'>'};

	String.prototype.$he = function () {return this.replace(/[&"'<>]/g, function(a){return enkeys[a]});};
	String.prototype.$hd = function () {return this.replace(/&(?:amp|quot|lt|gt);/g, function(a){return dekeys[a]});};
};

/** cross platform'ed event binder */
var __eventHandlers = [];
window.$Unevent = function () {
	for (var i = 0; i < __eventHandlers.length; i++) {
		var element = __eventHandlers[i][0],
			eventName = __eventHandlers[i][1],
			handler = __eventHandlers[i][2],
			flag = __eventHandlers[i][3];
		try {
			if (element.removeEventListener)
				element.removeEventListener(eventName, handler, flag);
			else if (element.detachEvent)
				element.detachEvent('on' + eventName, handler);
		}
		catch (e) {}
	}
	__eventHandlers = [];
};
(window.$Event = function (element, eventName, handler, flag) {
	element = $(element);
	flag = flag || false;
	if (!element) return false;
	__eventHandlers.push([element, eventName, handler, flag]);
	if (element.addEventListener) {
		element.addEventListener(eventName, handler, flag);
		return true;
	}
	else if (element.attachEvent)
		return element.attachEvent('on' + eventName, handler);
})(window, 'unload', $Unevent, false);

/** HTMLAnchorElement.click() emulator */
var $click = function (ele) {
	ele = $(ele);
	if (!ele) return;
	if (ele.click) ele.click();
	else if (ele.dispatchEvent) {
		var e = document.createEvent('MouseEvents');
		e.initMouseEvent(
			'click', 
			true, 	// bubbles
			true,	// cancelable
			window, // window object
			0, 		// detail
			0,		// screen coord x
			0,		//              y
			0,		// client coord x
			0,		//              y
			false,	// ctrl
			false,	// alt
			false,	// shift
			false,	// meta
			0,		// button
			null);	// related target
		ele.dispatchEvent(e);
	}
};

/** element generator */
var $C = function (t) {return document.createElement(t)},
	$E = function (parentElement, tagName, attributes, nextSibling) {
	var result = null, innerHTML = null, style = null;

	if (attributes && attributes.innerHTML) {
		innerHTML = attributes.innerHTML;
		delete attributes.innerHTML;
	}

	if (attributes && attributes.style) {
		style = attributes.style;
		delete attributes.style;
	}

	if (window.ActiveXObject) {
		var a = [];
		if (attributes) for (var i in attributes) a.push(i + '="' + attributes[i].toString().replace('"', '&quot;') + '"');
		result = $C('<' + tagName + (a.length ? ' ' + a.join(' ') : '') + '>');
		if (!result) return null;
	}
	else {
		result = $C(tagName);
		if (!result) return null;
		if (attributes) for (var i in attributes) result.setAttribute(i, attributes[i]);
	}

	if (parentElement)
		parentElement.insertBefore(result, nextSibling || null);

	if (style) {
		if (Akahuku.cap.stylePropertyPrefix == 'style')
			for (var i in style) result.style[i] = style[i];
		else 
			for (var i in style) result.style[i.replace(/^style/, 'css')] = style[i];
	}

	if (innerHTML)
		result.innerHTML = innerHTML;

	return result;
};

/** text node generator */
var $TX = function (pa, tx, next) {
	var result = null;
	pa && pa.insertBefore(result = document.createTextNode(tx), next || null);
	return result;
};

/** parent getter */
function $P (elm, pattern, foundCallback) {
	function doCallback (node) {
		if (typeof foundCallback == 'function') 
			return foundCallback(node, node.nodeName.toLowerCase());

		if (foundCallback instanceof Array && foundCallback.length >= 2 &&
			typeof foundCallback[0] == 'object' &&
			typeof foundCallback[1] == 'function') 
			return foundCallback[1].call(foundCallback[0], node, node.nodeName.toLowerCase());

		return null;
	}

	var mode = 0;

	if (!elm) return null;

	if (typeof pattern == 'string') {
		mode = 1;
		pattern = pattern.toLowerCase();
	}
	else if (pattern instanceof RegExp) {
		pattern.ignoreCase = true;
		mode = 2;
	}
	else if (typeof pattern == 'function') 
		mode = 3;

	for (var tmp = elm.parentNode; tmp; tmp = tmp.parentNode) {
		if (tmp.nodeType != 1) continue;
		if (mode == 1 && tmp.nodeName.toLowerCase() == pattern ||
			mode == 2 && pattern.test(tmp.nodeName) ||
			mode == 3 && pattern(tmp, tmp.nodeName.toLowerCase())) {
			if (doCallback(tmp) !== true) return tmp;
		}
	}
	return null;
}

/** window scroll information holder */
var windowScrollInfo = (function () {
	function std_sw(){return document.documentElement.scrollWidth}
	function std_sh(){return document.documentElement.scrollHeight}
	function std_cw(){return document.documentElement.clientWidth}
	function std_ch(){return document.documentElement.clientHeight}
	function std_st(){return document.documentElement.scrollTop}
	function std_sl(){return document.documentElement.scrollLeft}
	function qks_sw(){return document.body.scrollWidth}
	function qks_sh(){return document.body.scrollHeight}
	function qks_cw(){return document.body.clientWidth}
	function qks_ch(){return document.body.clientHeight}
	function qks_st(){return document.body.scrollTop}
	function qks_sl(){return document.body.scrollLeft}
	switch ((window.opera ? 8 : 0) | (window.chrome ? 4 : 0) | (document.compatMode == 'CSS1Compat' ? 2 : 0)) {
	// backward compatible
	case 0: // ie
	case 4: // chrome
	case 8: // opera
		return {
			scrollWidth: qks_sw, scrollHeight: qks_sh,
			clientWidth: qks_cw, clientHeight: qks_ch,
			scrollTop:   qks_st, scrollLeft:   qks_sl};

	// css 1 compatible
	case 6:	 // chrome
		return {
			scrollWidth: std_sw, scrollHeight: std_sh,
			clientWidth: std_cw, clientHeight: std_ch,
			scrollTop:   qks_st, scrollLeft:   qks_sl};// maybe a bug, tested on 2.0.181.1
	case 2:  // ie
	case 10: // opera
		return {
			scrollWidth: std_sw, scrollHeight: std_sh,
			clientWidth: std_cw, clientHeight: std_ch,
			scrollTop:   std_st, scrollLeft:   std_sl};
	default:
		return {};
	}
})();

/** network (xhr, jsonp) wrapper */
var net = (function () {
	var _statusArray = ['UNSENT, 0/4', 'OPENED, 1/4', 'HEADERS_SENT, 2/4', 'LOADING, 3/4', 'DONE, 4/4'];

	function _getXhr () {
		try {if (window.XMLHttpRequest) return new XMLHttpRequest()} catch (e) {}
		try {if (window.ActiveXObject) return new ActiveXObject('Msxml2.XMLHTTP')} catch (e) {}
		try {if (window.ActiveXObject) return new ActiveXObject('Microsoft.XMLHTTP')} catch (e) {}
		return null;
	}
	function _mergeParam (url) {
		for (var i = 1; i < arguments.length; i++) {
			var data = arguments[i];
			if (typeof data == 'object') {
				var tmp = [];
				for (var j in data) tmp.push(j + '=' + encodeURIComponent(data[j]));
				url = tmp.length ? (url + (url.indexOf('?') >= 0 ? '&' : '?') + tmp.join('&')) : url;
			}
			else if (typeof data == 'string' && data != '') 
				url += (url.indexOf('?') >= 0 ? '&' : '?') + data.replace(/^[?&]/, '');
		}
		return url;
	}
	function _isSameOrigin (url) {
		var re = /^([^:]+:)\/\/([^\/]+)\//.exec(url);
		return re &&
			re[1] == location.protocol &&
			re[2] == location.host + (location.port == '' ? '' : ':' + location.port);
	}
	function NetClass (t, url, opt) { 
		var _type, _opt, _xhr, _script, _scriptImg, _port, _iframe;

		function _handleXhrRsc () {
			if (!_xhr) return;
			if (_xhr.readyState != 4) 
				try { _opt.step && _opt.step(_statusArray[_xhr.readyState]); } catch (e) {}
			else {
				switch (_xhr.status) {
				case 200: case 206:
					try {_opt.loaded && _opt.loaded(_xhr);} catch (e) {}
					break;
				default:
					try {_opt.failed && _opt.failed(_xhr);} catch (e) {}
					break;
				}
				try {_opt.finished && _opt.finished(_xhr);} catch (e) {}
				_xhr.onreadystatechange = emptyfunc;
				_xhr = _opt = null;
			}
		}
		function _handleChromeExtXhr (r) {
			if (r && r.status && r.result) {
				switch (r.status) {
					case 200: case 206:
						try {_opt.loaded && _opt.loaded(r.result);} catch (e) {}
						break;
					default:
						try {_opt.failed && _opt.failed(r.result);} catch (e) {}
						break;
				}
				try {_opt.finished && _opt.finished(r.result);} catch (e) {}
			}
		}
		function _doHttpGetReq (url) {
			var re;

			if (re = url.match(/^akahuku:\/\/([^\/]+)\/(.*)$/)) {
				if (window.opera)
					;
				else if (window.chrome)
					chrome.extension.sendRequest(
						{command:re[1], param:re[2], origin:location.href},
						_handleChromeExtXhr);
			}
			else if (_isSameOrigin(url)) {
				_xhr = _getXhr();
				if (!_xhr) return;
				_xhr.open('GET', url, true);
				try {_opt.prepare && _opt.prepare(_xhr);} catch (e) {}
				_opt.mimeType && _xhr.overrideMimeType && _xhr.overrideMimeType(_opt.mimeType);
				_opt.noCache && _xhr.setRequestHeader('If-Modified-Since', 'Fri, 01 Jan 2010 00:00:00 GMT');
				_xhr.onreadystatechange = _handleXhrRsc;
				_xhr.send(null);
			}
		}
		function _doHttpPostReq (url) {
			// fill me!
		}
		function _doJsonp (url) {
			var id = _opt.id || 'jsonp_' + $T('script').length;
			var receiver_id = id + '_receiver';
			var param = {};

			if (_opt.noImageHack) {
				var _script = $T('head')[0].appendChild($C('script'));
				_script.type = 'text/javascript';
				if (_opt.charset) _script.charset = _opt.charset;

				var handler = function (obj) {
					_script.parentNode.removeChild(_script);
					_script = null;
					if (window.chrome && window.contentWindow) {
						contentWindow[receiver_id] = emptyfunc;
						try {delete contentWindow[receiver_id];} catch (e) {}
					}
					else {
						window[receiver_id] = emptyfunc;
						try {delete window[receiver_id];} catch (e) {}
					}
					try{_opt.loaded(obj);}catch(e){}
				};

				if (window.chrome && window.contentWindow)
					contentWindow[receiver_id] = handler;
				else
					window[receiver_id] = handler;

				param[_opt.callbackName || 'callback'] = receiver_id;
				_script.src = _mergeParam(url, param);
			}
			else {
				_scriptImg = $E(document.body, 'img', {width:1, height:1, style:{position:'absolute', left:0, top:0}});
				_scriptImg.onerror = function () {
					var _script = $T('head')[0].appendChild($C('script'));
					_script.type = 'text/javascript';
					if (_opt.charset) _script.charset = _opt.charset;

					var handler = function (obj) {
						_script.parentNode.removeChild(_script);
						_script = null;
						try {_opt.loaded(obj);} catch (e) {}
						if (window.chrome && window.contentWindow) {
							contentWindow[receiver_id] = emptyfunc;
							try {delete contentWindow[receiver_id];} catch (e) {}
						}
						else {
							window[receiver_id] = emptyfunc;
							try {delete window[receiver_id];} catch (e) {}
						}
					};

					if (window.chrome && window.contentWindow)
						contentWindow[receiver_id] = handler;
					else
						window[receiver_id] = handler;

					this.onerror = emptyfunc;
					this.parentNode.removeChild(this);
					_script.src = this.src;
				}

				param[_opt.callbackName || 'callback'] = receiver_id;
				_scriptImg.src = _mergeParam(url, param);
			}
		}
		function _doScript (url) {
			_script = $T('head')[0].appendChild($C('script'));
			_script.type = 'text/javascript';
			if (_opt.charset) _script.charset = _opt.charset;
			if (_opt.onload) _script.onload = _opt.onload;
			_script.src = url;
		}
		function _doBogoGet (url) {
			var id = _opt.id || 'i' + $T('iframe').length;

			_iframe = $E(document.body, 'iframe', 
				{id:id, width:1, height:1, frameBorder:0, scrolling:'no', style:{position:'absolute', left:0, top:0}});

			if (!window.akahukuBogoGetHandler) window.akahukuBogoGetHandler = {};

			window.akahukuBogoGetHandler[id] = function (result) {
				_iframe.parentNode.removeChild(_iframe);
				_iframe = null;
				try {_opt.loaded && _opt.loaded(result);} catch (e) {}
				try {_opt.finished && _opt.finished(result);} catch (e) {}
			};

			try {_opt.prepare && _opt.prepare(_iframe);} catch (e) {}
			_iframe.src = _mergeParam(url, {'akahuku-bogo-get':id + '_' + new Date().getTime()});
		}
		function _doAbort () {
			if ((_type == 'get' || _type == 'post') && _xhr) {
				_xhr.abort();
				_xhr.onreadystatechange = emptyfunc;
				try { _opt.failed && _opt.failed(_xhr); } catch (e) {}
				_xhr = _opt = null;
			}
			else if (_type == 'jsonp' || _type == 'script') {
				if (_scriptImg) {
					_scriptImg.onerror = emptyfunc;
					_scriptImg.parentNode.removeChild(_scriptImg);
					_scriptImg = null;
				}
				if (_script) {
					_script.parentNode.removeChild(_script);
					_script = null;
				}
				try { _opt.failed && _opt.failed(); } catch (e) {}
				_opt = null;
			}
			else if (_type = 'bogoGet') {
				_iframe && _iframe.contentWindow && _iframe.contentWindow.stop && _iframe.contentWindow.stop();
				try { _opt.failed && _opt.failed(); } catch (e) {}
				_opt = null;
				_iframe = null;
			}
		}

		this.abort = _doAbort;

		switch (t) {
		case 'get':
			_opt = opt || {}; _type = t; _doHttpGetReq(_mergeParam(url, _opt.data));
			break;
		case 'post':
			_opt = opt || {}; _type = t; _doHttpPostReq(url);
			break;
		case 'jsonp':
			_opt = opt || {}; _type = t; _doJsonp(_mergeParam(url, _opt.data));
			break;
		case 'script':
			_opt = opt || {}; _type = t; _doScript(_mergeParam(url, _opt.data));
			break;
		case 'bogoGet':
			_opt = opt || {}; _type = t; _doBogoGet(_mergeParam(url, _opt.data));
			break;
		};
	}

	$Event(window, 'message', function (e) {
		if (e.origin == location.protocol + '//' + location.host && /[?&]akahuku-bogo-get=(i\d+)_\d+/.exec(e.source.location.search) && window.akahukuBogoGetHandler[RegExp.$1]) {
			window.akahukuBogoGetHandler[RegExp.$1](e.data || '');
			delete window.akahukuBogoGetHandler[RegExp.$1];
		}
	});

	return {
		get: function (url, opt) { return new NetClass('get', url, opt); },
		post: function (url, opt) { return new NetClass('post', url, opt); },
		jsonp: function (url, opt) { return new NetClass('jsonp', url, opt); },
		script: function (url, opt) { return new NetClass('script', url, opt); },
		bogoGet: function (url, opt) { return new NetClass('bogoGet', url, opt); }
	};
})();

/** DOM construction watcher class */
var DOMWatcherClass = function (id, watchFunction, intervalMSecs, timeoutSecs) {
	this.id = id;
	this.enabled = true;
	this.__watchIntervalMSecs = isNaN(intervalMSecs) ? 200 : parseInt(intervalMSecs);
	this.__watchTimeoutSecs = isNaN(timeoutSecs) ? 60 : parseInt(timeoutSecs);
	this.__eventHandlers = [];
	this.__domWatchTimer = 0;
	this.__domWatchCounter = 0;
	this.__watchTimeoutCount = parseInt(this.__watchTimeoutSecs * (1000 / this.__watchIntervalMSecs));
	this.__currentHandler = 0;
	this.__run = function () {
		if (!this.enabled) return;

		// execute event handler in 0.2 seconds only to do
		//Akahuku.log('*** start: ' + this.id + ' ***');
		for (var st = new Date().getTime(); this.enabled && this.__currentHandler < this.__eventHandlers.length;) {
			//Akahuku.log(this.__currentHandler + '/' + this.__eventHandlers[this.__currentHandler].toString().replace(/\s+|\n/g, ' ').substring(0, 100));
			try {
				this.__eventHandlers[this.__currentHandler]();
			}
			catch (e) {
				Akahuku.log('error in ' + this.id + ':' + this.__currentHandler);
				Akahuku.log(e);
				Akahuku.log(this.__eventHandlers[this.__currentHandler].toString().substring(0, 100));
			}
			this.__currentHandler++;

			if (new Date().getTime() - st > 200) break;
		}

		// if the event handler that has not been executed yet remains,
		// register the next running loop with the timer, and return a browser the control
		if (this.__currentHandler < this.__eventHandlers.length)
			setTimeout(arguments.callee.bind(this), 10);
		else {
			// everything was completed. release all handlers
			this.__eventHandlers.length = this.__currentHandler = 0;
			this.__structChecker = this.__watchFunction = emptyfunc;
		}
	};
	this.__defaultWatcher = function () {
		try {
			document.documentElement.doScroll('left');
		}
		catch (e) {
			return false;
		}
		return true;
	};
	this.__structChecker = emptyfunc;
	this.__watchFunction = watchFunction ? watchFunction : this.__defaultWatcher;
	this.__handleDomWatchTimer = function () {
		try {
			this.__domWatchCounter++;
			if (this.__structChecker() && this.__watchFunction()) {
				clearInterval(this.__domWatchTimer);
				this.__run();
			}
			else if (this.__domWatchCounter >= this.__watchTimeoutCount)
				clearInterval(this.__domWatchTimer);
		}
		catch (e) {
			clearInterval(this.__domWatchTimer);
		}
	};
	this.add = function (handler) {
		this.__eventHandlers.push(handler);
		return this;
	};
	this.start = function (watchTarget) {
		switch (isNaN(watchTarget) ? -1 : watchTarget) {
		case 0:
			this.__structChecker = function(){return !!$T('head').length;}
			break;
		default:
			this.__structChecker = function(){return !!$T('body').length || !!document.body;}
			break;
		}

		this.__domWatchTimer = setInterval(
			this.__handleDomWatchTimer.bind(this),
			this.__watchIntervalMSecs);
	};
};

/** event object wrapper class */
if (window.ActiveXObject) {
	var EventWrapperClass = function (e) {
		this.nativeEvent = e = window.event;
		this.t = this.target = e.srcElement;
		this.leftPress = e.button == 1;
		this.rightPress = e.button == 2;
		this.pageX = windowScrollInfo.scrollLeft() + e.clientX;
		this.pageY = windowScrollInfo.scrollTop() + e.clientY;
		this.clientX = e.clientX;
		this.clientY = e.clientY;
		this.keyCode = e.keyCode;
		this.wheelDelta = e.wheelDelta;
		this.ctrlKey = e.ctrlKey;
		this.shiftKey = e.shiftKey;
	};
	EventWrapperClass.prototype = {
		p: function(){this.nativeEvent.returnValue = false; return true;},
		s: function(){this.nativeEvent.cancelBubble = true; return true;},
		preventDefault: function(){this.p()},
		stopPropagation: function(){this.s()}
	};
}
else {
	var EventWrapperClass = function (e) {
		this.nativeEvent = e;
		this.t = this.target = e.target;
		this.leftPress = e.button == 0;
		this.rightPress = e.button == 2;
		this.pageX = e.pageX;
		this.pageY = e.pageY;
		this.clientX = e.clientX;
		this.clientY = e.clientY;
		this.keyCode = e.keyCode;
		this.wheelDelta = e.wheelDelta;
		this.ctrlKey = e.ctrlKey;
		this.shiftKey = e.shiftKey;
	};
	EventWrapperClass.prototype = {
		p: function(){this.nativeEvent.preventDefault(); return true;},
		s: function(){this.nativeEvent.stopPropagation(); return true;},
		preventDefault: function(){this.p()},
		stopPropagation: function(){this.s()}
	};
}

/** style object wrapper class */
var StyleWrapperClass = function () {
	this.rules = {};
};
StyleWrapperClass.prototype = {
	a: function (selector, value) {
		this.rules[selector] = value;
		return this;
	},
	addRule: function (selector, value) {
		return this.a(selector, value);
	},
	apply: function () {
		var parent = $T('head')[0] || document.documentElement;
		if (!parent) return;

		var style = $('akahuku_additional_styles') || $E(parent, 'style', {type:'text/css', id:'akahuku_additional_styles'}), s = '';

		// IE
		if (window.ActiveXObject) {
			var sheet = style.styleSheet;
			for (var selector in this.rules) sheet.addRule(selector, this.rules[selector]);
		}

		// standard DOM CSS
		else {
			var sheet = style.sheet;
			//for (var selector in this.rules) sheet.insertRule(selector + '{' + this.rules[selector] + '}', sheet.cssRules.length);
			for (var selector in this.rules) style.innerHTML += selector + '{' + this.rules[selector] + "}\n";
		}
	}
};

/** PopupManagerClass
	animation effected popup object management class */
var PopupManagerClass = function (interval) {
	this.popups = {};
	this.effectors = {};
	this.effectorsLength = 0;
	this.effectorsTimerID = null;
	this.enabled = true;
	this.interval = isNaN(interval) ? 20 : parseInt(interval);
};
PopupManagerClass.prototype = {
	cacheImages: {
		caches: [],
		exists: function (key) {
			for (var i = this.caches.length - 1; i >= 0; i--)
				if (this.caches[i][0] == key)
					return true;
			return false;
		},
		getCache: function (key) {
			for (var i = this.caches.length - 1; i >= 0; i--) {
				if (this.caches[i][0] == key) {
					var result = this.caches[i];
					this.caches.splice(i, 1);
					this.caches.push(result);
					return result[1];
				}
			}
			return undefined;
		},
		register: function (key, image) {
			if (!this.exists(key)) {
				this.caches.push([key, image]);
				while (this.caches.length > 16) {
					this.caches[0][1] = null;
					this.caches.shift();
				}
			}
		}
	},
	addEffector: function (popup, func) {
		if (!this.effectors[popup.key])
			this.effectorsLength++;

		this.effectors[popup.key] = [popup, func];

		if (!this.effectorsTimerID) {
			var self = this;
			this.effectorsTimerID = setInterval(function () {
				for (var i in self.effectors)
					self.effectors[i][1].apply(self.effectors[i][0]);
			},
			this.interval);
		}
	},
	removeEffector: function (popup) {
		if (!this.effectors[popup.key]) return;
		this.effectors[popup.key][0] = null;
		this.effectors[popup.key][1] = null;
		this.effectors[popup.key] = null;
		delete this.effectors[popup.key];
		this.effectorsLength--;
		if (this.effectorsLength == 0 && this.effectorsTimerID) {
			clearInterval(this.effectorsTimerID);
			this.effectorsTimerID = null;
		}
	},
	addPopup: function (key, popup) {
		this.removeActivePopups();
		key = '_' + key;
		if (this.popups[key] || !this.enabled) return;
		this.popups[key] = popup;
		popup.manager = this;
		popup.key = key;
		// popup object must implement 'run' method.
		// and when 0 is passed as an argument, popup needs to initialize itself.
		popup.run(0);
	},
	removeActivePopups: function () {
		var needDeletes = {};
		for (var i in this.popups) {
			// popup object must implement 'queryPurge' method.
			// and popup needs to return true when itself can be deleted.
			if (this.popups[i].queryPurge())
				needDeletes[i] = this.popups[i];
		}
		for (var i in needDeletes) {
			this.popups[i] = null;
			delete this.popups[i];
		}
	}
};

/** Akahuku404Work: not found page enhancement */
var Akahuku404Work = function () {
	return {
		signature: 'notFound',
		initialize: function () {
			var style;
			if (window.ActiveXObject) {
				style = [];
				style.push('body{background-color:#ffffee;color:#800000}');
				Akahuku.allowDelBanner && style.push('img,iframe,object,embed{display:none}');
				document.write('<style type="text/css">' + style.join('') + '</style>');
			}
			else {
				style = new StyleWrapperClass();
				style.a('body', 'background-color:#ffffee;color:#800000');
				Akahuku.allowDelBanner && style.a('img,iframe,object,embed', 'display:none');
				style.apply();
			}
		},
		start: function () {
			var hrs = $T('hr');
			if (hrs.length) {
				var div = $E(hrs[0].parentNode, 'div', {
					innerHTML:
						'[<a href="http://' + Akahuku.serverName +
						'.2chan.net/' + Akahuku.directoryName +
						'/futaba.htm">\u63B2\u793A\u677F\u306B\u623B\u308B</a>]'}, hrs[0]);
				if (Akahuku.allowDelBanner) {
					div.innerHTML += ' [<a href="#disp_banners" id="akahuku_banner_showlink">\u5E83\u544A\u3092\u898B\u3066\u307F\u308B</a>]';
					$Event('akahuku_banner_showlink', 'click', this.handleBannerShow.$bind(this));
				}
			}
		},
		handleBannerShow: function (e) {
			e.p();
			for (var i = 0,nodes = $T('img'); i < nodes.length; i++) nodes[i].style.display = 'inline';
			for (var i = 0,nodes = $T('iframe'); i < nodes.length; i++) nodes[i].style.display = 'inline';
		}
	}
};

/** opera object helper */
if (window.opera) {
	opera._verMatch = function (min, max) {
		var ver = this.version ? parseFloat(this.version()) : 0;
		if (min != undefined) {
			if (/^\[([0-9.]+)$/.exec(min) && ver < parseFloat(RegExp.$1)) return false;
			if (/^\(([0-9.]+)$/.exec(min) && ver <= parseFloat(RegExp.$1)) return false;
			if (ver < parseFloat(min)) return false;
		}
		if (max != undefined) {
			if (/^([0-9.]+)\]$/.exec(max) && ver > parseFloat(RegExp.$1)) return false;
			if (/^([0-9.]+)\)$/.exec(max) && ver >= parseFloat(RegExp.$1)) return false;
			if (ver > parseFloat(max)) return false;
		}
		return true;
	};
	opera.defineMagicFunction('ddrefl', function (fn, t) {
		if (document.querySelectorAll) {
			var nodes = document.querySelectorAll('table.deleted');
			var style = (window.dispdel != undefined ? window.dispdel : true) ? 'table' : 'none';
			for (var i = 0, goal = nodes.length; i < goal; i++) 
				nodes[i].style.display = style;
			if (nodes.length) {
				$('ddel') && ($('ddel').style.display = 'inline');
				$('ddnum') && ($('ddnum').textContent = nodes.length);
			}
		}
		else 
			fn.apply(t, arguments.slice(2));
	});
}

/** unite helper */
if (window.opera) {
	var UniteHelper = function () {
		/* THE LINE BELOW WILL BE UPDATED AUTOMATICALLY BY FUTANITE. */
		var unitePrefix = '';
		/* THE LINE ABOVE WILL BE UPDATED AUTOMATICALLY BY FUTANITE. */

		var _self = this;
		var _origin = '';
		var _iframe = null;
		var _initialized = false;
		var _initialQueue = [];
		var _initCount = 5;
		
		function _init () {
			if (!Akahuku.allowUseUniteCache) return;

			_iframe = $('akahuku_unite_interface');
			if (!_iframe) {
				var re = /^([^:]+:\/\/[^\/]+)\//.exec(unitePrefix);

				if (re) _origin = re[1];

				$Event(window, 'message', _handleMessage);
				_initTimer();
			}
		}

		function _initTimer () {
			if (_initialized) return;
			if (_initCount-- <= 0) {
				alert([
					'futanite \u304c\u53cd\u5fdc\u3057\u307e\u305b\u3093\u3002',
					'futanite \u304c\u8d77\u52d5\u3057\u3066\u3044\u306a\u3044\u304b\u3001\u307e\u305f\u306f\u30d0\u30fc\u30b8\u30e7\u30f3 0.3 \u672a\u6e80\u306e\u3088\u3046\u3067\u3059\u3002',
					'\u6700\u65b0\u30d0\u30fc\u30b8\u30e7\u30f3\u306f http://appsweets.net/ \u3067\u5165\u624b\u3067\u304d\u307e\u3059\u3002'
				].join('\n'));
			}
			else {
				_iframe && _iframe.parentNode.removeChild(_iframe);
				_iframe = $E($('akahuku_additional_elements'), 'iframe', {
					'id':'akahuku_unite_interface',
					'style':{display:'block', border:'none', overflow:'hidden', position:'absolute', left:'-2px', top:'0', width:'2px', height:'2px'},
					'src':_getPrefix('scripts_/interface.html?uri=' + encodeURIComponent(location.href)),
					'scrolling':'no'
				});
				setTimeout(arguments.callee, 5000);
			}
		}

		function _postMessage (obj) {
			if (!Akahuku.allowUseUniteCache) return;

			if (_initialized) 
				_iframe && _origin != '' && _iframe.contentWindow.postMessage(JSON.stringify(obj), _origin);
			else
				_initialQueue.push(obj);
		}

		function _handleMessage (e) {
			if (!window.opera || e.origin + '/futanite/' != Akahuku.getUnitePrefix() || !window.JSON) return;

			var obj;
			try {obj = JSON.parse(e.data);} catch (ex) {obj = null;}
			if (!obj) return;

			_applyFavicon(obj.icon);

			switch (obj.appendix || '') {
			case 'get-info':
				obj.replies && obj.replies > 0 && _setIcon('star', true);

				var last = Akahuku.getLastReply();
				if ($T('blockquote', 'threadsbox').length < 100 && last && obj.lastComment && (last.name - 0) > (obj.lastComment - 0)) {
					var re = new RegExp('<input.+?name=[\'"]?' + obj.lastComment + '[\'"]?.+?>(.+</blockquote>.*?</table>)', 'i')
						.exec($('threadsbox').innerHTML.replace(/(?:\r\n|\r|\n)/g, ' '));
					setTimeout(function(){re && re[1] && _notifyReplies(re[1]);}, 1000);
				}
				break;

			case 'initialized':
				_initialized = true;
				_initialQueue.forEach(function (obj) { _postMessage(obj); });
				_initialQueue = null;
				break;

			default:
				_setIcon('star', true);
			}
		}

		function _notifyReplies (replies) {
			if (!Akahuku.isReply || !Akahuku.allowUseUniteCache) return;

			_postMessage({
				'type': 'notify',
				'entries': replies
			});
		}

		function _getInfo () {
			if (!Akahuku.isReply || !Akahuku.allowUseUniteCache) return;

			_postMessage({
				'type': 'getinfo'
			});
		}

		function _getPrefix (path) {
			return unitePrefix + (path || '');
		}

		function _applyFavicon (url) {
			if (!url || !Akahuku.allowUseUniteCache) return;
			var favicon = $('akahuku_favicon');
			favicon && favicon.parentNode.removeChild(favicon);
			$E($T('head')[0], 'link', {rel:'icon', id:'akahuku_favicon', type:'image/png', href:_getPrefix(url)});
		}

		function _setIcon (name, state) {
			if (!Akahuku.allowUseUniteCache) return;

			var c = $('akahuku_throp_uniteicons'), url = Akahuku.getUnitePrefix('images_/' + name + '.png'), found = false;

			for (var i = 0, imgs = $T('img', c); i < imgs.length; i++) {
				if (imgs[i].src == url) {
					!state && imgs[i].parentNode.removeChild(imgs[i]);
					found = true;
					break;
				}
			}

			state && !found && $E(c, 'img', {width:16, height:16, src:url});
		}

		_init();

		return {
			'iframe': _iframe,
			'notifyReplies': _notifyReplies,
			'getInfo': _getInfo,
			'getPrefix': _getPrefix,
			'applyFavicon': _applyFavicon,
			'setIcon': _setIcon
		};
	};
}

/** Akahuku: central object */
(window.Akahuku = {
	version: '2.60beta',
	revision: '$Revision: 223 $',
	date: '$Date: 2010-11-24 22:57:16 +0900 (水, 24 11 2010) $',
	baseURLs: ['http://akahuku.s278.xrea.com/akahukuplus/'],
	futasukePrefixDefault: 'http://127.0.0.1:8028/',

	// define order of configurable parameters. on IE, enumeration order of object
	// properties seems to be does not same as definition order on the source
	// (i dont know when it is).
	propOrder: [
		'allowServerTitle','allowDelBanner','allowSageButton','allowExtendMailBox','allowCommentStatus',
		'allowNumbering','allowBottomStatus','allowReplyNew','allowCuteFont','allowShowMail',
		'allowAutoLink','allowAutoLinkF','allowAutoLinkS','allowAutoLinkFutalog',
		'allowSorrowVipper','allowQuickQuote','allowInlineImage','allowCatalogFullClickable',
		// flags version 1.3 or later
		'allowGoTopOnReload',
		// flags version 1.4 or later
		'allowSubtitle','allowLimitReplyWidth','allowWidenReplyHeight',
		// flags version 1.5 or later
		'allowHidePostForm','allowAlterThread','allowThreadNew','allowCatalogReorder',
		// flags version 1.7 or later
		'allowMarkTextOnlyThread','allowHideTextOnlyThread','allowCatalogHilightVisited',
		'allowPopupQuote','allowWindowNaming',
		// flags version 1.8 or later
		'allowFloatPostForm','allowHideReplyPostForm','allowGoCurrentOnReply','allowMinimizePostForm',
		'allowBackgroundReload','allowUseRangeHeader','allowRuleOnReply','allowRuleOnBackgroundReload',
		'allowBackgroundPostReply','allowUseSJISEncoder','allowBackgroundLoadThreadInfo','allowBackgroundLoadCatalog',
		'allowReplyNumberDelta',
		// flags version 1.9 or later
		'allowDispThreadInfoOnTitle','allowDispThreadInfoOnThrop','allowControlCommentHeight',
		'allowDelTextAd','allowFloatThumbnail','allowFloatThumbnailAlpha',
		// flags version 2.0 or later
		'allowMarkVipper','allowUseFutasukeImage','allowCatalogZoom',
		// flags version 2.2 or later
		'allowThreadOperator','allowImageInPopupQuote','allowBackOnBottom',
		'allowIgnoreDefaultStyle','allowUseFontSize','allowCatalogNew','allowDecoratePopupPointer',
		// flags version 2.3 or later
		'allowReloadByBottomScroll','allowActivateIMEonComment',
		// flags version 2.4 or later
		'allowFloatPostFormAlpha','allowReloadByBottomScrollReply','allowReloadByBottomScrollCatalog',
		'allowReportRefererOnQuickQuote',
		// flags version 2.6 or later
		'allowExpirationDate','allowQuickImage','allowQuickImageF','allowQuickImageS','allowIframeReload',
		'allowDispViewersOnThrop','allowInvertWheelDirection','allowFloatReplyPostForm',
		// flags rev.188 or later
		'allowUseUniteCache', 'allowUseUniteLink', 'allowUIAnimation',

		// numbers and strings
		'numberFloatFormPosition','numberFloatFormOffsetX','numberFloatFormOffsetY','numberThreadInfoLoadInterval',
		'numberVipperMode','numberReplyNumberMax','numberThropThumbnailSize','numberCatalogZoomTimeout',
		'numberCatalogZoomSize','stringVipperReplacement','numberFontSizePt','numberBottomScrollThreshold',
		'numberFloatFormWidthPercent',
		// rev. 188 or later
		'stringFutasukePrefix', 'stringFontFamily'
	],

	/* [AUTOMATIC UPDATED REGION START] */
	allowUseCookie: true,						/// 設定を cookie/localStorage に持つか.
	stringFutasukePrefix: '',					/// 双助のアドレス. 
	stringFontFamily: '',						/// ページ全体のフォント名.

	// flags
	allowServerTitle: true,						/// ページのタイトルを変更.
	allowDelBanner: true,						/// バナーを削除.
	allowSageButton: true,						/// sage ボタン.
	allowExtendMailBox: false,					/// メール欄の幅を拡大.
	allowCommentStatus: true,					/// コメントの行数・バイト数を監視.
	allowNumbering: true,						/// レス番号.
	allowBottomStatus: true,					/// 最終レス直下にステータス.
	allowReplyNew: true,						/// [返信] リンクを新しいウィンドウで開く.
	allowCuteFont: false,						/// レス部分のフォントを変更.
	allowShowMail: true,						/// メール欄を展開.
	allowAutoLink: true,						/// URL をオートリンク.
	allowAutoLinkF: true,						/// あぷ子をオートリンク.
	allowAutoLinkS: true,						/// 塩１、塩３をオートリンク.
	allowAutoLinkFutalog: true,					/// ふたログをオートリンク.
	allowSorrowVipper: true,					/// うはｗｗｗおｋｗｗｗを変換.
	allowQuickQuote: true,						/// 引用メニューを使う.
	allowInlineImage: true,						/// 画像の URL をその場で表示.
	allowCatalogFullClickable: true,			/// [カタログ] クリックできないスレをクリックできるようにする.
	allowGoTopOnReload: false,					/// リロード時にページ先頭へ.
	allowSubtitle: true,						/// ページの概要を表示/ウィンドウのタイトルにスレ本文を付加.
	allowLimitReplyWidth: false,				/// レス幅を制限する.
	allowWidenReplyHeight: true,				/// レスの上下にマージン.
	allowHidePostForm: true,					/// 送信フォームを隠す.
	allowAlterThread: false,					/// レス送信モードからもスレを立てる.
	allowThreadNew: true,						/// スレを立てたとき新しいウィンドウで開く.
	allowCatalogReorder: true,					/// [カタログ] ソートできるようにする.
	allowMarkTextOnlyThread: false,				/// 文字スレをマーク.
	allowHideTextOnlyThread: false,				/// 文字スレを隠す.
	allowCatalogHilightVisited: true,			/// [カタログ] 一度見たスレをマーク.
	allowPopupQuote: true,						/// レス中の引用から引用元をポップアップ.
	allowWindowNaming: true,					/// ウィンドウの再利用.
	allowFloatPostForm: true,					/// 送信フォームを固定（通常モード）.
	allowHideReplyPostForm: true,				/// [レス] 送信フォームを隠す.
	allowGoCurrentOnReply: true,				/// [レス] レス送信時にページ末尾へスクロール.
	allowMinimizePostForm: false,				/// 送信フォーム固定時、できるだけ小さくする.
	allowBackgroundReload: true,				/// 続きを読む.
	allowUseRangeHeader: true,					/// 読み込みを最小にする.
	allowRuleOnReply: true,						/// レス送信時、新着レスとの間に区切り.
	allowRuleOnBackgroundReload: true,			/// 続きを読んだ時、新着レスとの間に区切り.
	allowBackgroundPostReply: true,				/// レス送信と続きを読む機能を連携.
	allowUseSJISEncoder: false,					// obsolete from version 2.10.
	allowBackgroundLoadThreadInfo: false,		/// 続きを読む時、スレの消滅情報も時々更新.
	allowBackgroundLoadCatalog: true,			/// [カタログ] 最新に更新.
	allowReplyNumberDelta: true,				/// [カタログ] スレの増加分を表示.
	allowDispThreadInfoOnTitle: true,			/// ウィンドウのタイトルにスレの消滅情報を表示.
	allowDispThreadInfoOnThrop: true,			/// スレッド操作パネルにスレの消滅情報を表示.
	allowControlCommentHeight: false,			/// コメントの高さを制御する.
	allowDelTextAd: false,						/// テキスト広告を削除.
	allowFloatThumbnail: true,					/// サムネを固定する.
	allowFloatThumbnailAlpha: false,			/// 固定したサムネを半透明にする.
	allowMarkVipper: true,						/// うはｗｗｗおｋｗｗｗを赤くする.
	allowUseFutasukeImage: false,				/// 画像を双助を通して取得.
	allowUseUniteCache: false,					/// レスや画像を futanite にキャッシュする
	allowUseUniteLink: false,					/// ハイパーリンクを futanite を通して開く
	allowCatalogZoom: false,					/// [カタログ] サムネイルのズーム.
	allowThreadOperator: true,					/// スレッド操作パネル.
	allowImageInPopupQuote: true,				/// 引用のポップアップ内に画像も含める.
	allowBackOnBottom: false,					/// 「掲示板に戻る」リンクをページ末尾に追加.
	allowIgnoreDefaultStyle: false,				/// 文字サイズを変更できるようにする.
	allowUseFontSize: false,					/// 文字サイズを強制指定する.
	allowCatalogNew: false,						/// カタログへのリンクを新しいウィンドウで開く.
	allowDecoratePopupPointer: false,			/// 引用できそうな No. に下線.
	allowReloadByBottomScroll: false,			/// ホイールリロード.
	allowActivateIMEonComment: false,			/// コメント欄フォーカス時に IME をオン.
	allowFloatPostFormAlpha: false,				/// 固定した送信フォームを半透明に.
	allowReloadByBottomScrollReply: false,		/// ホイールリロードをレス送信モードでも有効.
	allowReloadByBottomScrollCatalog: false,	/// ホイールリロードをカタログでも有効.
	allowReportRefererOnQuickQuote: false,		/// 引用メニューからの外部へのリンクでリファラを出す.
	allowExpirationDate: false,					/// 消える時刻が 0 時をまたいでいたら日付も表示.
	allowQuickImage: false,						/// 元画像を同一のページ内に表示.
	allowQuickImageF: false,					/// 元画像を同一のページ内に表示（あぷ小）.
	allowQuickImageS: false,					/// 元画像を同一のページ内に表示（塩1・3・小瓶・塩粒）.
	allowIframeReload: false,					/// 続きを読むと文字化けするのでなんとかしてくだしあ.
	allowDispViewersOnThrop: false,				/// スレッド操作パネルに見ている人数を表示.
	allowInvertWheelDirection: false,			/// ホイールリロードの回転方向を逆に認識する.
	allowFloatReplyPostForm: false,				/// 送信フォームを固定（レス送信モード）.
	allowUIAnimation: true,						/// 一部の要素の変化をアニメーションで表現する.
	numberFloatFormPosition: 0,					/// 固定した送信フォームの位置 (0:右下 1:左下 2:右上 3:左上).
	numberFloatFormOffsetX: 0,					/// 固定した送信フォームの横の間隔 (px).
	numberFloatFormOffsetY: 0,					/// 固定した送信フォームの縦の間隔 (px).
	numberThreadInfoLoadInterval: 0,			/// スレ消滅情報を読むの最低限の間隔 (sec).
	numberVipperMode: 2,						/// うはｗｗｗおｋｗｗｗの処理 (0:...... 1:隠す 2:任意の文字列に置換).
	numberReplyNumberMax: 0,					/// レス番号を振る最大値.
	numberThropThumbnailSize: 0,				/// 固定したサムネのサイズ (0:フルサイズ 1:ハーフサイズ).
	numberCatalogZoomTimeout: 0,				/// [カタログ] サムネをズームするまでの間隔 (msec).
	numberCatalogZoomSize: 0,					/// [カタログ] サムネをズームするサイズ (px).
	stringVipperReplacement: '',				/// うはｗｗｗおｋｗｗｗを置換する文字列.
	numberFontSizePt: 0,						/// ユーザー指定のページの文字サイズ (pt).
	numberBottomScrollThreshold: 0,				/// ホイールリロードの閾値.
	numberFloatFormWidthPercent: 70,			/// 固定した送信フォームの幅 (%)
	/* [AUTOMATIC UPDATED REGION END] */

	// location informations
	isValidPage: false,
	isNijiura: false,
	isTraditionalNijiura: false,
	isNormal: false,
	isCatalog: false,
	isReply: false,
	isDrawingBoard: false,
	threadNumber: 0,
	normalPageNumber: 0,
	serverName: '',
	directoryName: '',
	replyDirectoryName: '',

	// initializers
	initialize: function () {
		if (location.href.match(/^http:\/\/(cgi|dat|img|jun|may|nov|orz|tmp|up|zip|dec)\.2chan\.net(:\d+)?\/([^\/]+)\/(.*)$/) ||
			location.href.match(/^http:\/\/(www)\.2chan\.net(:\d+)?\/(h|oe|junbi)\/(.*)$/)) {
			this.serverName = RegExp.$1;
			this.directoryName = RegExp.$3;
			var here = RegExp.$4;

			if (this.serverName == 'may' && this.directoryName == 'layout') return;

			this.getConfigurationFromCookie();

			// traditional nijiura ?
			if (this.serverName.match(/^(dat|img|cgi|zip)$/) && this.directoryName == 'b') {
				this.isNijiura = true;
				this.isTraditionalNijiura = true;
			}

			// urban nijiura ?
			else if (this.serverName.match(/^(may|nov|jun|dec)$/) && this.directoryName == 'b')
				this.isNijiura = true;

			// catalog mode page ?
			if (here.match(/^futaba\.php\?mode=cat/))
				this.isCatalog = true;

			// reply mode page ?
			else if (here.match(/^([^\/]+)\/(\d+)\.htm/)) {
				this.isReply = true;
				this.replyDirectoryName = RegExp.$1;
				this.threadNumber = RegExp.$2;
			}
			else if (here.match(/^futaba\.php\?res=(\d+)/)) {
				this.isReply = true;
				this.threadNumber = RegExp.$1;
			}

			// normal mode page ?
			else if (here.match(/^(futaba|\d+)\.htm/) || here.match(/^($|[#?])/)) {
				this.isNormal = true;
				this.normalPageNumber = parseInt(RegExp.$1) ? parseInt(RegExp.$1) : 0;
			}
		}

		this.isValidPage = this.isNormal || this.isReply || this.isCatalog;
		this.isDrawingBoard = /^(?:\u304A\u7D75\u304B\u304D|\u843D\u66F8\u304D|\u843D\u66F8\u304D\u88CF)/.test(document.title);
		this.cap = {
			isOlderIE: window.ActiveXObject && typeof document.documentMode == 'undefined',
			css2_1Compat: window.opera || !!window.chrome || window.ActiveXObject && document.documentMode && document.documentMode >= 8,
			dataSchemeEnabled: window.opera || window.chrome || window.ActiveXObject && document.documentMode && document.documentMode >= 8,
			cssCounterEnabled: window.opera || window.chrome,
			DOMContentLoadedEnabled: window.opera && opera._verMatch(9) || window.chrome,
			xpathEnabled: document.evaluate,
			selectorEnabled: document.querySelector,
			stylePropertyPrefix: window.chrome ? 'css' : 'style',
			quirksEFP: window.ActiveXObject || 
				window.opera && opera._verMatch(10.5) || 
				window.chrome,
			messagingEnabled: typeof window.postMessage == 'function',
			canvasEnabled: window.opera && opera._verMatch(9) || window.chrome,
			jsJitEnabled: window.opera && opera._verMatch(10.5) || window.chrome || 
				window.ActiveXObject && parseFloat((navigator.userAgent.match(/MSIE\s+([\d.]+)/) || ['', '0'])[1]) >= 9
		};
		this.revision = this.revision.match(/\$Revision: (\d+)/) && RegExp.$1 || '?';
		this.date = this.date.match(/\$Date: (.+) \(/) && RegExp.$1 || '?';
	},
	start: function () {
		if (!this.isValidPage) return;

		var box = $E(document.body, 'div', {id:'akahuku_additional_elements', style:{fontSize:'80%', clear:'both', margin:'32px 0 0 0'}}),
			configbox = $E(document.body, 'div', {id:'akahuku_configbox', style:{display:'none'}}),
			box2 = $E(box, 'div');

		if (this.numberFloatFormPosition == 0 || this.numberFloatFormPosition == 2) {
			$E(box2, 'font', {
				id:'akahuku_ver_info',
				title:this.getConfiguratorURL(),
				innerHTML:['[akahukuplus ', this.version, ', rev.', this.revision, ']'].join(''),
				style:{cursor:'pointer'}});
			$E(box2, 'font', {id:'akahuku_wheel_status', style:{marginLeft:'4px'}});
		}
		else {
			box2.style.textAlign = 'right';
			$E(box2, 'font', {id:'akahuku_wheel_status'});
			$E(box2, 'font', {
				id:'akahuku_ver_info',
				title:this.getConfiguratorURL(),
				innerHTML:['[akahukuplus', this.version, ', rev.', this.revision, ']'].join(''),
				style:{cursor:'pointer', marginLeft:'4px'}});
		}

		if (typeof UniteHelper != 'undefined' && (this.allowUseUniteCache || this.allowUseUniteLink)) {
			this.uniteHelper = new UniteHelper();
		}

		$Event('akahuku_ver_info', 'click', this.handleConfigLinkClick.$bind(this));
		$Event(document.body, 'mousemove', this.handleBodyMousemove.$bind(this));
	},

	// cookie handling methods
	getData: function (key, opt) {
		var re = (opt || {}).session ?
			(window.sessionStorage ? [0, sessionStorage.getItem(key)] : (new RegExp(key + '=([^;]+)')).exec(document.cookie)) :
			(window.localStorage   ? [0, localStorage.getItem(key)] :   (new RegExp(key + '=([^;]+)')).exec(document.cookie));
		var val = re && re[1] ? unescape(re[1]) : '';

		return key == 'akahukusettings' && val == '' ?
			'1943781117.954390931.2790_0_4_4_0_0_0_1_0_100__0_3_60__' : val;
	},
	setData: function (key, value, opt) {
		if ((opt || {}).session) {
			if (window.sessionStorage)
				sessionStorage.setItem(key, unescape(value));
			else
				document.cookie =
					key + '=' + escape(value) +
					';path=' + location.pathname.replace(/\/[^\/]+$/, '/').replace(new RegExp(this.replyDirectoryName + '/$'), '');
		}
		else {
			if (window.localStorage) 
				localStorage.setItem(key, unescape(value));
			else
				document.cookie =
					key + '=' + escape(value) +
					';path=' + location.pathname.replace(/\/[^\/]+$/, '/').replace(new RegExp(this.replyDirectoryName + '/$'), '') +
					';expires=Tue, 1-Jan-2030 00:00:00 GMT;';
		}
	},
	removeData: function (key, opt) {
		if ((opt || {}).session) {
			if (window.sessionStorage) {
				sessionStorage.removeItem(key);
				return;
			}
		}
		else {
			if (window.localStorage) {
				localStorage.removeItem(key);
				return;
			}
		}

		var d = new Date();
		d.setYear(d.getYear() - 1);
		document.cookie =
			key + '=0' +
			';path=' + location.pathname.replace(/\/[^\/]+$/, '/').replace(new RegExp(this.replyDirectoryName + '/$'), '') +
			';expires=' + d.toGMTString() + ';';
	},
	getConfigurationObject: function () {
		return new (function () {
			this.target = Akahuku;
			this.apply = function () {
				for (var i = 0; i < this.target.propOrder.length; i++) {
					var name = this.target.propOrder[i];
					this.target[name] = this[name];
				}
				return this;
			};
			this.toString = function () {
				var numbers = [],
					flags = [],
					flagindex = 0,
					shiftfactor = 0;

				flags[flagindex] = 0;

				for (var i = 0; i < this.target.propOrder.length; i++) {
					var name = this.target.propOrder[i];
					if (/^allow/.test(name)) {
						flags[flagindex] |= this[name] ? (1 << shiftfactor) : 0;
						if (++shiftfactor >= 31) {
							shiftfactor = 0;
							flags[++flagindex] = 0;
						}
					}
					else if (/^number/.test(name))
						numbers.push(this[name]);
					else if (/^string/.test(name))
						numbers.push(this[name]
							.replace(/./g, function(){return arguments[0].charCodeAt(0) + '.'})
							.replace(/\.$/, ''));
				}

				numbers.unshift(flags.join('.'));
				return numbers.join('_');
			};
			this.setString = function (config) {
				var configvalues = config.split(/[:_]/),
					flags = configvalues[0].split(/[.,]/),
					flagbits = parseInt(flags[0]),
					flagindex = 0,
					numberindex = 0,
					shiftfactor = 0;

				for (var i = 0; i < this.target.propOrder.length; i++) {
					var name = this.target.propOrder[i];
					if (/^allow/.test(name)) {
						this[name] = !!(flagbits & (1 << shiftfactor));
						if (++shiftfactor >= 31) {
							shiftfactor = 0;
							flagbits = parseInt(flags[++flagindex]);
						}
					}
					else if (/^number/.test(name))
						this[name] = parseInt('0' + configvalues[++numberindex], 10);
					else if (/^string/.test(name)) {
						var s = configvalues[++numberindex];
						if (s)
							this[name] = s.replace(
								/([0-9]+)[,.]?/g,
								function(){return String.fromCharCode(arguments[1])});
						else
							this[name] = '';
					}
				}
				return this;
			};

			for (var i = 0; i < this.target.propOrder.length; i++) {
				var name = this.target.propOrder[i];
				this[name] = this.target[name];
			}
		});
	},
	getConfigurationFromCookie: function () {
		if (this.allowUseCookie) 
			this.getConfigurationObject().setString(this.getData('akahukusettings')).apply();
	},
	setConfigurationToCookie: function (configurations) {
		if (this.allowUseCookie) {
			this.deleteConfiguration();
			this.setData('akahukusettings', configurations.toString());
		}
	},
	deleteConfiguration: function () {
		if (this.allowUseCookie) 
			this.removeData('akahukusettings');
	},
	setCurrentReplyToCookie: function () {
		if (this.allowGoCurrentOnReply && !this.allowBackgroundPostReply && this.allowUseCookie && this.isReply) {
			var node = this.getLastReply();
			node && this.setData('akahukulasttop', node.name, {session:true});
		}
	},

	// event handlers
	pageX: 0, pageY: 0,
	handleBodyMousemove: function (e) {
		this.pageX = e.pageX;
		this.pageY = e.pageY;
	},
	handleConfigLinkClick: function (e) {
		var configlink = $('akahuku_additional_elements'), configbox = $('akahuku_configbox');

		if (window.AkahukuConfigWork) {
			if (configbox.style.display == 'none') 
				AkahukuConfigWork.notifyActivate && AkahukuConfigWork.notifyActivate();
			else
				AkahukuConfigWork.notifyDeactivate && AkahukuConfigWork.notifyDeactivate();
		}
		else {
			$E(e.t, 'font', {
				id:'akahuku_loading_notifier',
				innerHTML:'\u8AAD\u307F\u8FBC\u307F\u4E2D...',
				style:{backgroundColor:'#800000', color:'white', fontWeight:'bold', fontSize:'100%', padding:'2px', margin:'0 0 0 8px'}});
			net.script(this.getConfiguratorURL() + '?' + new Date().getTime(), {charset:'UTF-8'});
		}
	},
	getConfiguratorURL: function () {
		if (window.chrome) return '#configuration';
		return this.apiURL('config/akahukuplus_config.1.js');
	},

	// factory methods
	createStyle: function () {
		return new StyleWrapperClass();
	},
	createNewReplyHeader: function () {
		return $E(null, 'div', {
			id:'akahuku_new_reply_header',
			style:
				{fontSize:'80%', borderTop:'1px solid #eeaa88', margin:'8px 0 0 0', padding:'4px 0 4px 0',
				 display:this.allowRuleOnBackgroundReload ? 'block' : 'none'},
			innerHTML:
				'\u3053\u3053\u304B\u3089<font id="akahuku_new_reply_header_number"></font>\u7121\u8077\u7AE5\u8C9E' +
				'<font id="akahuku_new_reply_header_status"></font>'});
	},
	createStatusIndicator: function () {
		var args = arguments;
		return function (message, permanent) {
			for (var i = 0; i < args.length; i++) {
				var a = $(args[i]);
				if (a) a.innerHTML = message;
			}

			!permanent && setTimeout(function () {
				for (var i = 0; i < args.length; i++) {
					var a = $(args[i]);
					if (a) a.innerHTML = '';
				}
			}, parseInt(1000 * 2));
		}
	},

	// getters
	getLastReply: function (needTableFlag) {
		var nodes = $T('input');
		for (var i = nodes.length - 1; i >= 0; i--) {
			if (nodes[i].type.toLowerCase() == 'checkbox' &&
				nodes[i].value == 'delete' &&
				/^\d+$/.test(nodes[i].name)) {
				if (nodes[i].name == '0') 
					nodes[i].setAttribute('name', nodes[i].parentNode.innerHTML.match(/No\.(\d+)/)[1]); 
				if (needTableFlag) {
					var table = null, td = null;
					$P(nodes[i], function (node, name) {
						if (name == 'td' && !td) 
							td = node;
						else if (name == 'table' && !table) {
							table = node; 
							return true;
						}
					});
					return {
						tableElement: table,
						tdElement: td,
						inputElement: nodes[i]
					};
				}
				return nodes[i];
			}
		}
		return null;
	},
	getFixedStyle: function (position, baseDesc) {
		var leftDesc = '', topDesc = '';

		baseDesc = baseDesc || '';

		if (Akahuku.cap.css2_1Compat) {
			baseDesc = 'position:fixed;' + baseDesc;
			leftDesc = (position == 0 || position == 2) ? 'right:0px' : 'left:0px';
			topDesc = (position == 0 || position == 1) ? 'bottom:0px' : 'top:0px';
		}
		else {
			baseDesc = 'position:absolute;' + baseDesc;
			leftDesc = (position == 0 || position == 2) ?
				'left:expression(eval(document.documentElement.scrollLeft+document.documentElement.clientWidth-this.offsetWidth-0))' :
				'left:expression(eval(document.documentElement.scrollLeft+0))';
			topDesc = (position == 0 || position == 1) ?
				'top:expression(eval(document.documentElement.scrollTop+document.documentElement.clientHeight-this.offsetHeight-0))' :
				'top:expression(eval(document.documentElement.scrollTop+0))';
		}
		return baseDesc.replace(/;$/, '') +
			';' + leftDesc.replace('0', this.numberFloatFormOffsetX) +
			';' + topDesc.replace('0', this.numberFloatFormOffsetY);
	},
	getSelection: function () {
		var result = '';
		if (document.selection)
			result = document.selection.createRange().text;
		else if (document.getSelection)
			result = document.getSelection().toString();
		return result
			.replace(/(?:\r\n|\r|\n)/g, '\n')
			.replace(/\n/g, '\r\n')
			.replace(/(\.(?:jpg|gif|png))\[(?:\u898B\u308B|\u9589\u3058\u308B)\]/ig, '$1')
			.replace(/([!#$%&'()*+,\-.\/0-9:;=?@A-Z\\_a-z~]+)\[\u306a\u3093\u306e\u52d5\u753b\uff1f\]/ig, '$1');
	},
	getElementFromPoint: function (pageX, pageY) {
		return this.cap.quirksEFP ? 
			document.elementFromPoint(
				pageX - windowScrollInfo.scrollLeft(),
				pageY - windowScrollInfo.scrollTop()) :
			document.elementFromPoint(pageX, pageY);
	},
	getRegalizedComment: function (s) {
		return s
			.replace(/(&#[0-9]+)(?![;0-9])/ig, '$1;')
			.replace(/(&#x[0-9a-f]+)(?![;0-9a-f])/ig, '$1;')
			.replace(/[ \t\u3000]+(\r?\n|$)/g, '$1');
	},
	getWindowName: function (url, defaultTarget) {
		var result = defaultTarget || '_blank';
		if (this.allowWindowNaming) {
			var re = /^http:\/\/([^.]+)\.2chan\.net(?::\d+)?\/([^\/]+)\/([^\/]+\/(\d+)\.htm|.*res=(\d+))/.exec(url);
			if (re)
				// ex. may_b_9999999999
				result = [re[1], re[2], re[4] || re[5]].join('_');
		}
		return result;
	},
	getExpirationDate: function (expiration) {
		if (this.allowExpirationDate) {
			var re = expiration.match(/^\s*(\d+):(\d+)/);
			if (re) {
				var now = new Date;
				if ((re[1] - 0) < now.getHours()) {
					now.setMilliseconds(now.getMilliseconds() + (1000 * 60 * 60 * 24));
					expiration = now.getDate() + '\u65E5' + expiration;
				}
			}
		}
		return expiration;
	},
	getElementPosition: function (element) {
		var x = 0, y = 0;
		for (var tmp = $(element); tmp; tmp = tmp.offsetParent) {
			x += tmp.offsetLeft;
			y += tmp.offsetTop;
		}
		return {x:x, y:y};
	},
	getFutasukePrefix: function (path) {
		return (this.stringFutasukePrefix || this.futasukePrefixDefault) + (path || '');
	},
	getUnitePrefix: function (path) {
		return this.uniteHelper ? this.uniteHelper.getPrefix(path) : '';
	},

	_baseURLIndex: 0,
	apiURL: function (path) {
		this._baseURLIndex = (this._baseURLIndex + 1) % this.baseURLs.length;
		return this.baseURLs[this._baseURLIndex] + (path || '');
	},

	_resources: {},
	getResource: function (key) {
		if (this._resources[key]) return this._resources[key];

		switch (key) {
		case 'futaba':
			this._resources[key] = Akahuku.cap.dataSchemeEnabled ?
				'data:image/gif;base64,' +
				'R0lGODlhGwAWALP/AP////zEzPy8zPTMzOzUzOTczOTUzNzkzNTkzMz0xMzsxMT8xMT0xAAAAAAAAAAAACwAAAAAGwAWAEAEe1DISau9cqzNV+rgFmDWsZGUSYTLMU7fx6ISswx0rlfEgSAHAiowGCBi' +
				'hEBgpWAtEEQnR1ghDgocBlG5u2yo3YppAQ6bKSvW4TKQgdZPZ2IClC6UWDfno8l2gAMvAiNNdgsMCgiBOyMnZxYbBo8UASKTMIeXEgcJkppnEQA7' :
				'http://local.ptron/futaba.png';
			break;
		case 'throp1':
			this._resources[key] = Akahuku.cap.dataSchemeEnabled ?
				'data:image/gif;base64,' +
				'R0lGODlhEAAQAJH/AMDAwP//7oAAAAAAACH5BAEAAAAALAAAAAAQABAAQAIzhC2ph+EPoQBChirbVepNHXlgGCXlFX4UJqmHWbos6UxYV+Mwvu1zTbJ5hqJRivHiuAAFADs=' :
				'http://local.ptron/throp1.png';
			break;

		case 'loading':
			this._resources[key] = Akahuku.cap.dataSchemeEnabled ?
				'data:image/gif;base64,' +
				'R0lGODlhEAAQAPQAAIAAAP///4EEBLNoaJ9AQMCCgrhycooWFpYuLrx6eqNISKdQUIYODpo2No4eHq9gYKtYWAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH+FU1h' +
				'ZGUgYnkgQWpheExvYWQuaW5mbwAh+QQACgAAACH/C05FVFNDQVBFMi4wAwEAAAAsAAAAABAAEAAABVAgII5kaZ6lMBRsISqEYKqtmBTGkRo1gPAG2YiAW40EPAJphVCREIUBiYWijqwpLIBJWviiJGLw' +
				'ukiSkDiEqDUmHXiJNWsgPBMU8nkdxe+PQgAh+QQACgABACwAAAAAEAAQAAAFaCAgikfSjGgqGsXgqKhAJEV9wMDB1sUCCIyUgGVoFBIMwcAgQBEKTMCA8GNRR4MCQrTltlA1mCA8qjVVZFG2K+givqNn' +
				'lDCoFq6ioY9BaxDPI0EACzxQNzAHPAkEgDAOWQY4Kg0JhyMhACH5BAAKAAIALAAAAAAQABAAAAVgICCOI/OQKNoUSCoKxFAUCS2khzHvM4EKOkPLMUu0SISC4QZILpgk2bF5AAgQvtHMBdhqCy6BV0RA' +
				'3A5ZAKIwSAkWhSwwjkLUCo5rEErm7QxVPzV3AwR8JGsNXCkPDIshACH5BAAKAAMALAAAAAAQABAAAAVSICCOZGmegCCUAjEUxUCog0MeBqwXxmuLgpwBIULkYD8AgbcCvpAjRYI4ekJRWIBju22idgsS' +
				'IqEg6cKjYIFghg1VRqYZctwZDqVw6ynzZv+AIQAh+QQACgAEACwAAAAAEAAQAAAFYCAgjmRpnqhADEUxEMLJGG1dGMe5GEiM0IbYKAcQigQ0AiDnKCwYpkYhYUgAWFOYCIFtNaS1AWJESLQGAKq5YWIs' +
				'Co4lgHAzFmPEI7An+A3sIgc0NjdQJipYL4AojI0kIQAh+QQACgAFACwAAAAAEAAQAAAFXyAgjmRpnqhIFMVACKZANADCssZBIkmRCLCaoWAIPm6FBUkwJIgYjR5LN7INSCwHwYktdIMqgoNFGhQQpMMt' +
				'0WCoiGDAAvkQMYkIGLCXQI8OQzdoCC8xBGYFXCmLjCYhADsAAAAAAAAAAAA=' :
				'http://local.ptron/loading.gif';
			break;

		case 'gridbg':
			this._resources[key] = Akahuku.cap.dataSchemeEnabled ?
				'url(data:image/png;base64,' +
				'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAAlwSFlzAAALEwAACxMBAJqcGAAAAAd0SU1FB9kFEAkjBaAOh8kAAAArSURBVCjPY3zw4AEDNiAvL49VnImBRDCq' +
				'gRjA+P//f6wSDx8+HA0l+mkAAJ4dCLzVvF8ZAAAAAElFTkSuQmCC) left top repeat white' :
				'none white';
		}

		return this._resources[key] || '';
	},
	createIcon: function (image, size, factor) {
		var canvas = $C('canvas');

		factor = factor || 1;
		canvas.width = canvas.height = size * factor;

		var ctx = canvas.getContext('2d');
		ctx.fillStyle = '#000000';
		ctx.fillRect(0, 0, canvas.width, canvas.height);

		var clipSize = Math.min(image.width, image.height);
		ctx.drawImage(image, image.width / 2 - clipSize / 2, image.height / 2 - clipSize / 2, clipSize, clipSize, 0, 0, canvas.width, canvas.height);

		var ps = ctx.getImageData(0, 0, size * factor, size * factor);
		var pd = ctx.createImageData ? ctx.createImageData(size, size) : new ImageData(size, size);
		var factorPower = Math.pow(factor, 2);
		for (var i = 0; i < size; i++) {
			for (var j = 0; j < size; j++) {
				var avg = [0, 0, 0, 0];

				for (var k = 0; k < factor; k++) {
					for (var l = 0; l < factor; l++) {
						avg[0] += ps.data[((i * factor + k) * size * factor + (j * factor + l)) * 4 + 0];
						avg[1] += ps.data[((i * factor + k) * size * factor + (j * factor + l)) * 4 + 1];
						avg[2] += ps.data[((i * factor + k) * size * factor + (j * factor + l)) * 4 + 2];
						avg[3] += ps.data[((i * factor + k) * size * factor + (j * factor + l)) * 4 + 3];
					}
				}

				for (var k = 0; k < 4; k++) {
					avg[k] = Math.floor(avg[k] / factorPower);
					avg[k] += (255 - avg[k]) / 8;
					pd.data[(i * size + j) * 4 + k] = Math.min(255, avg[k]);
				}
			}
		}

		canvas.width = canvas.height = size;
		canvas.getContext('2d').putImageData(pd, 0, 0);
		return canvas.toDataURL('image/png');
	},

	replyPrefix: '',
	updateReplyPrefix: function (table) {
		if (this.replyPrefix != '') return;
		var cells = $T('td', table);
		this.replyPrefix = cells[0] ? cells[0].innerText: '\u2026';

		var tbc = $('akahuku_thread_bottom_container');
		if (tbc)
			$T('td', tbc)[0].innerHTML = this.replyPrefix;
	},

	// hookable methods
	doQuote: function (selection, addQuotePrefix, focusTextArea) {
		var	target = $('ftxa'),
			newline = window.chrome ? '\n' : '\r\n',
			quotedRegex = window.chrome ? /^[^>]|\n[^>]/ : /^[^>]|\r\n[^>]/,
			eolRegex = window.chrome ? /\n$/ : /\r\n$/,
			addPrefix = function (txt) {
				if (addQuotePrefix && quotedRegex.test(txt)) {
					var ary = txt.split(newline);
					for (var i = 0; i < ary.length; i++)
						ary[i] = '>' + ary[i].replace(/^(.+)\s*/, '$1');	// change prefix if you want
					return ary.join(newline);
				}
				else
					return txt;
			};

		if (!target) return;
		if (!selection) selection = this.getSelection();
		if (parseInt(target.rows) == 4) target.rows = '8';

		var s = addPrefix(selection);
		target.value = target.value == '' ? s.replace(eolRegex, '') : target.value.replace(eolRegex, '') + newline + s;
		target.value += newline;

		if (focusTextArea) {
			this.ensureDispPostForm();

			if (target.setSelectionRange)
				target.setSelectionRange(target.value.length, target.value.length);
			else
				with (target.createTextRange()) {
					collapse(false);
					select();
				}
			target.focus();
			!$('akahuku_floatpostform_container') && scrollTo(0, 0);
		}
	},
	doQuoteToMailBox: function (selection, focusMailBox) {
		var target = $('email');
		if (!target) return;

		if (!selection)
			selection = this.getSelection();

		this.ensureDispPostForm();
		target.value += selection.replace(/[\r\n]/g, '');

		if (focusMailBox) {
			if (target.setSelectionRange)
				target.setSelectionRange(target.value.length, target.value.length);
			else
				with (target.createTextRange()) {
					collapse(false);
					select();
				}
			target.focus();
			!$('akahuku_floatpostform_container') && scrollTo(0, 0);
		}
	},

	_submitterLockingTimerID: null,
	doLockSubmitter: function () {
		var submitter = $('submitter');
		if (!submitter) return;
		submitter.disabled = 'disabled';
		this._submitterLockingTimerID = setTimeout(this.doUnlockSubmitter.bind(this), 1000 * 5);
	},
	doUnlockSubmitter: function () {
		var submitter = $('submitter');
		if (submitter)
			submitter.removeAttribute('disabled');
		if (this._submitterLockingTimerID) {
			clearTimeout(this._submitterLockingTimerID);
			this._submitterLockingTimerID = null;
		}
	},
	doCopyToClipboard: function (data) {
		window.clipboardData && window.clipboardData.setData('text', data);
	},
	getAbsoluteUrl: function (url) {
		if (!/^[^:]+:\/\//.test(url)) {
			var a = $C('a');
			a.href = url;
			url = a.href;
		}
		return url;
	},
	getLocalProxiedUrl: function (url) {
		if (this.allowUseFutasukeImage) 
			url = this.getFutasukePrefix('$' + this.getAbsoluteUrl(url).replace(/^http:\/\//, ''));

		if (this.allowUseUniteCache) 
			url = this.getUnitePrefix('$' + this.getAbsoluteUrl(url).replace(/^http:\/\//, '')); 

		return url;
	},
	doLink: function (anchor) {
		function createIndirectHtml (url) {
			return '<html><head>' +
				'<title>' + url.$he() + '</title></head>' +
				'<body onload="var u=document.getElementById(\'url\');location.replace(u.innerText||u.textContent)">' +
				'<b>now loading <span id="url" style="color:red">' + url.$he() + '</span>...</b></body></html>';
		}
		function openWithWindow (anchor, url) {
			if (window.ActiveXObject) {
				var w = window.open('', anchor.target);
				w.document.open();
				w.document.write(createIndirectHtml(url));
				w.document.close();
				return true;
			}
			else if (window.chrome) {
				net.get('akahuku://open/' + url);
				return true;
			}
			else if (window.opera && this.allowUseUniteLink) {
				net.jsonp(this.getUnitePrefix('$open'), 
					{data:{src:url, tick:new Date().getTime()}, noImageHack:true});
				return true;
			}
			else if (Akahuku.cap.dataSchemeEnabled) {
				window.open('data:text/html;charset=UTF-8,' + encodeURIComponent(createIndirectHtml(url)), anchor.target);
				return true;
			}

			return false;
		}
		if (typeof(anchor) == 'string')
			anchor = {target: '_blank', innerText: '', href: anchor, getAttribute: function(){return this.href}};

		return /^(?:|_(?:self|parent|top))$/.test(anchor.target) ?  false : 
			openWithWindow.call(this, anchor, this.getAbsoluteUrl(anchor.getAttribute('href')));
	},

	// misc methods
	isFloating: function () {
		return this.isNormal && this.allowFloatPostForm || this.isReply && this.allowFloatReplyPostForm;
	},
	setOpacity: function (element, ratio) {
		if (!element || !element.style) return;
		if (window.ActiveXObject && typeof element.style.filter != 'undefined')
			element.style.filter = 'alpha(opacity=' + parseInt(ratio * 100) + ')';
		else if (typeof element.style.opacity != 'undefined')
			element.style.opacity = ratio;
	},
	ensureDispPostForm: function () {
		var postboxContainer = $('postbox_container'),
			postbox = $('postbox'),
			anchor = $('akahuku_postform_opener'),
			container = $('akahuku_floatpostform_container');

		if (postboxContainer && postboxContainer.style.display != 'block')
			postboxContainer.style.display = 'block';

		if (anchor && postbox && postbox.style.display != 'block')
			$click(anchor);
		else if (this.isFloating() && this.fn.postForm &&
			container && container.style.display != 'block')
			this.fn.postForm.handleFloatPostFormOpenerClick();
		else
			$('ftxa').focus();
	},
	ensureRender: function () {
		if (window.opera) {
			scrollBy(0, -1);
			scrollBy(0, 1);
		}
	},
	ensureDispLastReply: function () {
		var last = this.getLastReply(true).tableElement;
		if (!last) return;

		var lastPos = Akahuku.getElementPosition(last);
		var tbcHeight = ($('akahuku_thread_bottom_container') ? $('akahuku_thread_bottom_container').offsetHeight : 0) + 8;

		if (lastPos.y + last.offsetHeight < windowScrollInfo.scrollTop()) 
			scrollTo(0, lastPos.y);

		else if (lastPos.y + last.offsetHeight > windowScrollInfo.scrollTop() + windowScrollInfo.clientHeight() - tbcHeight) 
			scrollTo(0, lastPos.y + last.offsetHeight - windowScrollInfo.clientHeight() + tbcHeight);
	},
	updateViewers: function (viewers) {
		if (viewers instanceof Array && viewers.length >= 2)
			viewers = viewers[1];
		if (typeof viewers == 'string') {
			this.fn.postForm && this.fn.postForm.updateViewers(viewers);
			this.fn.throp && this.fn.throp.updateViewers(viewers);
			this.fn.thread && this.fn.thread.updateViewers(viewers);
		}
	},
	updateExpiration: function (expiration) {
		if (expiration instanceof Array && expiration.length >= 2)
			expiration = expiration[1];
		if (typeof expiration == 'string') {
			expiration = this.getExpirationDate(expiration);
			this.fn.window && this.fn.window.updateExpiration(expiration);
			this.fn.throp && this.fn.throp.updateExpiration(expiration);
			this.fn.thread && this.fn.thread.updateExpiration(expiration);
		}
	},
	updateWarning: function (warning) {
		if (warning instanceof Array && warning.length >= 2)
			warning = warning[1];
		if (typeof warning == 'string') {
			this.fn.window && this.fn.window.updateWarning(warning);
			this.fn.throp && this.fn.throp.updateWarning(warning);
			this.fn.thread && this.fn.thread.updateWarning(warning);
		}
	},
	updateReplyNumber: function (number, deleted) {
		number = number || $T('blockquote', 'threadsbox').length - 1;
		deleted = deleted || (document.querySelectorAll ? document.querySelectorAll('table.deleted').length : 0);
		this.fn.throp && this.fn.throp.updateReplyNumber(number, deleted);
		this.fn.thread && this.fn.thread.updateReplyNumber(number, deleted);
	},
	isTextInput: function (element) {
		if (!element) return false;
		return (element.nodeName.toLowerCase() == 'input' && /^(?:text|password)$/i.test(element.type)) ||
				element.nodeName.toLowerCase() == 'textarea';
	},
	xpath: function (expr, target, type) {
		var result = null;

		try {
			if (this.cap.xpathEnabled) result = document.evaluate(expr, target, null, type || XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
		}
		catch (e) {}

		return result;
	},
	$Event: function (element, eventName, handler, flag) {
		return $Event(element, eventName, handler, flag);
	},
	isRelationalImage: function (url) {
		var re;

		// up
		if (re = /http:\/\/(dec\.2chan\.net|219\.94\.194\.39)(?::\d+)?\/(up)\/src\/(f\d+\.(?:gif|jpg|png))$/i.exec(url))
			// returning array structure: 0:thumbnail url, 1:server, 2:board, 3:file name
			return [url, re[1], re[2], re[3]];

		// up (small)
		if (re = /http:\/\/(dec\.2chan\.net|219\.94\.194\.39)(?::\d+)?\/(up2)\/src\/(fu\d+\.(?:gif|jpg|png))$/i.exec(url)) 
			return [url, re[1], re[2], re[3]];

		// image server: ex. http://feb.2chan.net/may/b/src/0000000000000.jpg
		if ((re = /http:\/\/(?:(?:apr|feb|dec|jan|mar|jul|aug|sep|oct|rr[a-z])\.2chan\.net|112\.78\.198\.230|112\.78\.201\.90|112\.78\.200\.214)(?::\d+)?\/([^\/]+)\/([^\/]+)\/src\/([0-9a-f]+\.(?:gif|jpg|png))$/i.exec(url))) 
			return [url.replace('/src/', '/thumb/').replace(/(\.[^\.]+)$/, 's.jpg'), re[1], re[2], re[3]];

		// upped image source ex. http://may.2chan.net/b/src/0000000000000.jpg but not up(small), up
		if ((re = /http:\/\/([^.]+)\.2chan\.net(?::\d+)?\/([^\/]+)\/src\/([0-9a-f]+\.(?:gif|jpg|png))$/i.exec(url)))
			return [url.replace('/src/', '/thumb/').replace(/(\.[^\.]+)$/, 's.jpg'), re[1], re[2], re[3]];

		// html redirector ex. http://may.2chan.net/b/red/0000000000000.htm
		if ((re = /http:\/\/([^.]+)\.2chan\.net(?::\d+)?\/([^\/]+)\/red\/(\d+\.htm)$/i.exec(url)))
			return [url.replace('/red/', '/thumb/').replace(/(\.[^\.]+)$/, 's.jpg'), re[1], re[2], re[3]];

		// siobin 3ml
		if ((re = /http:\/\/www\.(nijibox)2\.com\/futabafiles\/(003)\/src\/(.+\d+\.(?:gif|jpg|png))$/i.exec(url)) ||
			(re = /http:\/\/(nijibox)\.ohflip\.com\/futabafiles\/(003)\/src\/(.+\d+\.(?:gif|jpg|png))$/i.exec(url)))
			return [url.replace('/src/', '/misc/').replace(/\.[^\.]+$/, '.thumb.jpg'), re[1], re[2], re[3]];

		// siobin karabin does not generate thumbnail.

		// siobin kobin/siotubu
		if ((re = /http:\/\/www\.(nijibox)5\.com\/futabafiles\/(kobin|tubu)\/src\/(.+\d+\.(?:gif|jpg|png))$/i.exec(url)))
			return [url.replace('/src/', '/misc/').replace(/\.[^\.]+$/, '.thumb.jpg'), re[1], re[2], re[3]];

		return null;
	},

	q: function (o) {
		var s = [];
		for (var i in o) 
			try {
				switch (typeof o[i]) {
				case 'boolean': s.push(i + ' (boolean): ' + o[i]); break;
				case 'number': s.push(i + ' (number): ' + o[i]); break;
				case 'string': s.push(i + ' (string): "' + o[i] + '"'); break;
				case 'object': 
					if (o[i] == null) s.push(i + ' (null)');
					else if (p[i] == undefined) s.push(i + ' (undefined)');
					else s.push(i + ' (object): ' + (o[i].toString ? o[i].toString() : '').replace(/[\r\n]/g, ' ').substring(0, 100)); 
					break;
				case 'function': s.push(i + ' (function)'); break;
				default: s.push(i + ': ' + (typeof o[i])); break;
				}
			} catch (e) {
				s.push(i + ': ' + (typeof o[i]) + ' *** Exception ***');
			}
		return s.sort().join('\n');
	},
	s: function (s) {
		return s.replace(/./g, function(a){return a[0].charCodeAt(0) >= 256 ? '\\u' + a[0].charCodeAt(0).toString(16) : a[0]});
	},
	__logs: [],
	log: function (message) {
		this.__logs.push(message instanceof Object ? this.q(message) : message.toString());
		while (this.__logs.length > 100) this.__logs.unshift();
		window.console && !window.opera && console.log(this.__logs[this.__logs.length - 1]);
		window.opera && opera.postError(this.__logs[this.__logs.length - 1]);
	},

	// materializers
	fn: {},
	materialized: false,
	add: function (o) {
		if (o.signature) this.fn[o.signature] = o;
		if (o.initialize) try {o.initialize();} catch (e) {alert(e.name + ':' + e.message)}
	},
	materialize2: function () {
		if (this.materialized) return;

		// override if NotFound page
		if (document.title.match(/404/)) {
			this.isNormal = this.isReply = this.isCatalog = false;
			this.fn = {};
			this.add(new Akahuku404Work());
		}

		this.materialized = true;
		this.start();
		var o = null;
		for (var i in this.fn) {
			if ((o = this.fn[i]) && o.start) try {o.start();} catch (e) {alert('signature:' + o.signature + '\n' + e.name + ':' + e.message)}
		}
	}
}).add(Akahuku);

/**
 * work objects
 */

/** AkahukuWindowWork: window enhancement */
Akahuku.isValidPage && Akahuku.add({
	loadTime: 0,
	delta: 0,
	lastReload: 0,
	isUnloadByWheel: false,
	causesUnloadAnchorClicked: false,
	hotkeyPressed: false,
	signature: 'window',
	initialize: function () {
		var style = new StyleWrapperClass();

		window.opera && $E($T('head')[0], 'meta', {name:'viewport', content:'width=device-width'});
		this.stripDefaultStyles();

		if (Akahuku.allowUseFontSize) {
			var fontsize = Akahuku.numberFontSizePt;
			if (fontsize < 10) fontsize = 10;
			if (fontsize > 24) fontsize = 24;
			style.a('*', 'font-size:' + fontsize + 'pt');
		}

		if (Akahuku.allowDelBanner) {
			style.a('center img', 'display:none')
				.a('center iframe', 'display:none')
				.a('center object', 'display:none');
			style.a('div.akahuku_banner_container div', 'height:auto !important')
				.a('div.akahuku_banner_container img', 'display:none')
				.a('div.akahuku_banner_container iframe', 'display:none')
				.a('div.akahuku_banner_container object', 'display:none');
			Akahuku.cap.css2_1Compat && style
				.a('td.chui > div[style]', 'height: auto !important')
				.a('a img[width="468"]', 'display:none');
		}

		// for opera 9.5
		if (window.opera && opera._verMatch(9.5)) 
			style.a('hr', 'color:silver')
				.a('table,td', 'border-color:silver');

		if (Akahuku.cap.css2_1Compat) 
			style.a('td[bgcolor="#F0E0D6"] a.del', 'visibility:hidden')
				.a('td[bgcolor="#F0E0D6"]:hover a.del', 'visibility:visible');

		// add common styles and apply all rules
		style.a('a:hover', 'color:#dd0000')
			.a('a.del', 'color:#800000;text-decoration:underline')
			.a('div.delform', 'float:right')
			.a('table.ama', 'width:468px;border:2px ridge silver')
			.a('div.ama', 'width:468px;border:2px ridge silver')
			.a('#akahuku_azad_inner', 'padding:0.5em;font-size:10pt;color:#800000;text-align:left')
			.a('#akahuku_azad_inner img', 'display:inline;margin:0 1em 0.5em 0;border:1px solid #f0f0f0')
			.a('#akahuku_azad_inner form', 'display:block;margin:0.5em 0 0 0')
			.a('#akahuku_azad_inner div', 'display:none')
			/* fix for drawing on may (2010.3) */
			.a('#oebtn', 'cursor:pointer;text-decoration:underline;')
			.a('#oe3', 'visibility:hidden;width:390px;height:135px;position:absolute;margin-top:0px;margin-left:1px;')
			/* fix for drawing on may (2010.3) */
			.a('table.deleted', 'display:none')
			.a('#ddel', 'display:none;font-size:10pt')
			.a('#ddbut', 'cursor:pointer;text-decoration:underline')
			.apply();
	},
	start: function () {
		this.stripDefaultStyles();
		var target = window.ActiveXObject ? document.body : document;
		$Event(document.body, 'click', this.handleBodyClick.$bind(this));
		$Event(target, 'keydown', this.handleDocumentKeydown.$bind(this), true);
		$Event(target, 'keypress', this.handleDocumentKeypress.$bind(this), true);

		// title modifying
		if (Akahuku.allowServerTitle) {
			var s = document.title;

			// ex. 'nijiura img'
			if (Akahuku.isNijiura)
				s = s.replace(
					/\u4E8C\u6B21\u5143\u88CF\uFF20\u3075\u305F\u3070/,
					'\u8679\u88CF ' + Akahuku.serverName);

			// ex. 'nijiura img [page 1]'
			if (Akahuku.isNormal && Akahuku.normalPageNumber > 0)
				s += ' [\u30DA\u30FC\u30B8 ' + Akahuku.normalPageNumber + ']';

			// ex. 'nijiura img [reply]'
			else if (Akahuku.isReply)
				s += ' [\u8FD4\u4FE1]';

			// ex. 'nijiura img [catalog]'
			else if (Akahuku.isCatalog)
				s += ' [\u30AB\u30BF\u30ED\u30B0]';

			document.title = s;
		}

		// sync base.href to location.href
		if (Akahuku.isReply) {
			var base = $T('base')[0];
			if (base) {
				var m = /^http:\/\/(cgi|zip)\./.exec(base.href);
				if (m && m[1] != Akahuku.serverName) {
					base.href = base.href.replace('http://' + m[1], 'http://' + Akahuku.serverName);
				}
			}
		}

		// go current position on reply
		if (Akahuku.allowGoCurrentOnReply && !this.allowBackgroundPostReply && Akahuku.isReply && Akahuku.allowUseCookie) {
			var lastReply = Akahuku.getData('akahukulasttop', {session:true});
			if (lastReply != '') {
				for (var i = 0, nodes = $N(lastReply); i < nodes.length; i++) {
					if (!nodes[i].type.toLowerCase() == 'checkbox' || nodes[i].value == 'delete') {
						var pa = $P(nodes[i], 'table');
						pa && pa.parentNode && Akahuku.allowRuleOnReply && 
							pa.parentNode.insertBefore(Akahuku.createNewReplyHeader(), pa.nextSibling);
						scrollTo(0, Math.max(0, Akahuku.getElementPosition(nodes[i]).y - 64));
						break;
					}
				}
				var headerNumber = $('akahuku_new_reply_header_number');
				if (headerNumber) {
					var count = 0, nodes = $T('input');
					for (var i = nodes.length - 1; i >= 0; i--)
						if (nodes[i].type.toLowerCase() == 'checkbox' &&
							nodes[i].value == 'delete') {
							if (parseInt(nodes[i].name) > parseInt(lastReply))
								count++
							else
								break;
						}
					if (count)
						headerNumber.innerHTML = '&nbsp;' + count + '&nbsp;\u4EBA\u304C';
					else
						headerNumber.parentNode.removeChild(headerNumber);
				}
			}

			Akahuku.removeData('akahukulasttop', {session:true});
		}

		// subtitle
		if (Akahuku.allowSubtitle && (Akahuku.isNormal || Akahuku.isReply)) {
			var fixUpText = function (txt) {
				txt = txt.replace(/<font[^>]*>(&gt;|>)*(.*?)<\/font>/ig, '$2');
				txt = txt.replace(/^\s*/, '').replace(/\s*$/, '');
				txt = $E(null, 'span', {innerHTML:txt}).innerText;

				if (/\u2501+\(\uFF9F\u2200\uFF9F\)\u2501+/.test(txt) && Akahuku.directoryName == 'b') {
					switch (Akahuku.serverName) {
					case 'dat':
						return '\u307f\u306a\u3082\u3061\u3083\u3093\u304b\u308f\u3044\u3044\uff01';
					case 'img':
						return '\u304A\u3061\u3093\u3061\u3093\u3089\u3093\u3069';
					case 'jun':
						return '\u3061\u304f\u308f\u3057\u304b\u6301\u3063\u3066\u306d\u3048';
					case 'may':
						return '\u304a\u3061\u3093\u3061\u3093\u30b9\u30ec';
					case 'nov':
						return '\u3046\u307e\u5473\u30b9\u30ec';
					}
				}
				return txt;
			},
			getText = function (element, searchdown, ellipsis, fromtail) {
				var innerHTML = element.innerHTML, a = innerHTML.split(/<br\/?>/i);
				if (a.length == 0) return '';

				var s = a[searchdown ? 0 : a.length - 1];
				for (var i = searchdown ? 0 : a.length - 1; i >= 0 && i < a.length; i += searchdown ? 1 : -1)
					if (a[i].length > 0 && !/<font[^>]*>/i.test(a[i]) && !/:\/\//.test(a[i])) {
						s = a[i];
						break;
					}

				s = fixUpText(s);

				if (s.length > 20) {
					s = fromtail ? s.substr(-20) : s.substring(0, 20);
					if (ellipsis)
						s += '...';
				}

				return s.replace(/[\u202a-\u202e]/g, '');
			};

			var bqnodes = $T('blockquote', 'threadsbox');
			if (bqnodes.length == 0) return;

			if (Akahuku.isReply)
				document.title = document.title.replace(/(\s+\[\u8FD4\u4FE1\])?$/, ' ' + getText(bqnodes[0], true, true) + '$&');
			else if (Akahuku.isNormal) {
				var rule = $T('hr', 'headerbox')[0], title = this.randomMergeReplies(bqnodes);

				$E(rule.parentNode, 'div', {
					innerHTML: '\u2500\u2500 ' + title.$he() + ' \u2500\u2500',
					style:{fontWeight:'bold', margin:'8px 0 0 0', textAlign:'center'}}, rule);

				document.title += ' \u2500\u2500 ' + title;
			}
		}

		// open new window by clicking link to catalog
		if ((Akahuku.isNormal || Akahuku.isReply)) {
			var nodes = $T('a', 'postbox');
			for (var i = 0; i < nodes.length; i++) {
				if (nodes[i].href.indexOf('futaba.php?mode=cat') < 0) continue;
				if (nodes[i].innerHTML.indexOf('\u30AB\u30BF\u30ED\u30B0') >= 0) 
					nodes[i].id = 'akahuku_cataloglink';
				if (Akahuku.allowCatalogNew) {
					nodes[i].target = '_blank';
					nodes[i].innerHTML += '*';
				}
			}
		}

		// go top on reload
		if (Akahuku.isNormal && Akahuku.allowGoTopOnReload) {
			$Event(window, (window.ActiveXObject || window.chrome ? 'beforeunload' : 'load'), this.handleWindowUnload.$bind(this));
		}

		// wheel reload
		if (Akahuku.allowReloadByBottomScroll ||
			Akahuku.allowReloadByBottomScrollReply ||
			Akahuku.allowReloadByBottomScrollCatalog) 
			$Event(window.chrome ? window : document.body, 'mousewheel', this.handleBodyMousewheel.$bind(this));

		// navigation helper
		if (Akahuku.isNormal) {
			var head = $T('head')[0];
			Akahuku.normalPageNumber > 0 && $E(head, 'link', {
				rel:'prev', href:Akahuku.normalPageNumber == 1 ? 'futaba.htm' : (Akahuku.normalPageNumber - 1) + '.htm'});
			$E(head, 'link', {rel:'next', href:(Akahuku.normalPageNumber + 1) + '.htm'});
			$E(head, 'link', {rel:'start', href:'futaba.htm'});
		}
		else if (Akahuku.isReply) {
			$E($T('head')[0], 'link', {rel:'next', href:'javascript:Akahuku.fn.window.forward()'});
		}
		else if (Akahuku.isCatalog) {
			$E($T('head')[0], 'link', {rel:'next', href:'javascript:Akahuku.fn.catalog.reload()'});
		}

		// amazon ad
		var centers = $T('center');

		if (centers.length) {
			var lastCenter = centers[centers.length - 1];
			var form = lastCenter.parentNode;
			var formParent = form && form.nodeName.toLowerCase() == 'form' ? form.parentNode : null;
			formParent && formParent.insertBefore(lastCenter, form.nextSibling);
		} else {
			centers = Akahuku.xpath('div[@align="center"]', document.body);
			if (centers.snapshotLength) {
				var lastCenter = centers.snapshotItem(centers.snapshotLength - 1);
				var form = lastCenter.parentNode;
				var formParent = form && form.nodeName.toLowerCase() == 'form' ? form.parentNode : null;
				formParent && formParent.insertBefore(lastCenter, form.nextSibling);
				lastCenter.className = 'akahuku_banner_container';
			}
		}

		var tmp, length, anchors = Akahuku.xpath('descendant::a[contains(@href,"amazon.")]', document.body);
		if (anchors) 
			length = anchors.snapshotLength;
		else {
			anchors = [];
			for (var nodes = $T('a'), i = nodes.length - 1, count = 0; i >= 0 && count < 20; i--,count++) 
				/amazon\.(?:co\.jp|com)/.test(nodes[i].href) && anchors.push(nodes[i]);
			length = anchors.length;
			anchors.snapshotItem = function(index){return this[index]};
		}

		if (length) {
			var node = $P(anchors.snapshotItem(length - 1), 'td');
			if (!node) node = $P(anchors.snapshotItem(length - 1), 'div');
			node.id = 'akahuku_azad_inner';
			node.lastChild && node.lastChild.nodeName.toLowerCase() == 'br' && node.removeChild(node.lastChild);

			var bq = $T('blockquote', node);
			if (bq.length) {
				for (bq = bq[0]; bq.firstChild;) 
					node.insertBefore(bq.firstChild, bq);
				bq.parentNode.removeChild(bq);
			}

			for (var j = 0, img = $T('img', node); j < img.length; j++) 
				img[j].removeAttribute('hspace');
		}

		// override behavior of del anchor: open delete form with a new window.
		window.del = function (no) {
			if (window.chrome)
				net.get('akahuku://open/http://' + Akahuku.serverName + '.2chan.net/del.php?b=' + Akahuku.directoryName + '&d=' + no);
			else
				window.open('/del.php?b=' + Akahuku.directoryName + '&d=' + no, '_blank');
		};

		// reply mode
		if (Akahuku.isReply) {
			this.initFirstThumbnail();
		}
	},

	randomMergeReplies: function (replies) {
		var result = '',
			goal_length = Math.floor(Math.random() * 31) + 1,
			term_count = 0;

		while (result.length < goal_length || ++term_count < 2) {
			var lineIndex = Math.floor(Math.random() * replies.length),
				textContent = (replies[lineIndex].textContent || replies[lineIndex].innerText).replace(/(?:\r\n)+|\r+|\n+/g, ' '),
				colIndex = Math.floor(Math.random() * textContent.length),
				charCode = textContent.charCodeAt(colIndex);

			// Latin-1
			if (charCode < 256) {
				while (--colIndex >= 0 && textContent.charCodeAt(colIndex) < 0xff);
				var s = (textContent.substring(colIndex + 1).match(/^([\u0020-\u00ff]{1,16})/) || ['', ''])[1];
				if (!/:\/\//.test(s))
					result += s;
			}
			// CJK Ideographics (+ following Hiragana)
			else if (charCode >= 0x4e00 && charCode < 0x9fff) {
				while (--colIndex >= 0 && textContent.charCodeAt(colIndex) >= 0x4e00 && textContent.charCodeAt(colIndex) < 0x9fff);
				result += textContent.substring(colIndex + 1).match(/^([\u4e00-\u9fff]+(?:[\u3040-\u309f]+)?)/)[1];
			}
			// Katakana (+ following Hiragana)
			else if (charCode >= 0x30a0 && charCode < 0x30ff) {
				while (--colIndex >= 0 && textContent.charCodeAt(colIndex) >= 0x30a0 && textContent.charCodeAt(colIndex) < 0x30ff);
				result += textContent.substring(colIndex + 1).match(/^([\u30a0-\u30ff]+(?:[\u3040-\u309f]+)?)/)[1];
			}
			// (CJK Ideographics +) Hiragana
			else if (charCode >= 0x3040 && charCode < 0x309f) {
				while (--colIndex >= 0 && textContent.charCodeAt(colIndex) >= 0x3040 && textContent.charCodeAt(colIndex) < 0x309f);
				colIndex++;
				while (--colIndex >= 0 && textContent.charCodeAt(colIndex) >= 0x4e00 && textContent.charCodeAt(colIndex) < 0x9fff);
				result += textContent.substring(colIndex + 1).match(/^((?:[\u4e00-\u9fff]+)?[\u3040-\u309f]+)/)[1];
			}
			// other: take random letters
			else {
				result += textContent.substring(colIndex, colIndex + Math.floor(Math.random() * 5) + 1);
			}
		}

		return result.replace(/>/g, '');
	},
	forward: function () {
		if (Akahuku.fn.reload)
			Akahuku.fn.reload.loadNewReplies();
		else
			location.reload(location.href);
	},
	stripDefaultStyles: function () {
		var strips = [];

		for (var nodes = $T('link'), i = 0; i < nodes.length ; i++) 
			(nodes[i].type || '').toLowerCase() == 'text/css' && strips.push(nodes[i]);

		for (var nodes = $T('style'), i = 0; i < nodes.length ; i++) 
			!nodes[i].id && strips.push(nodes[i]);

		for (var i = 0; i < strips.length; i++) 
			strips[i].parentNode.removeChild(strips[i]);
	},
	initFirstThumbnail: function () {
		for (var i = 0, nodes = $T('img'); i < nodes.length; i++) {
			if (!/^http:\/\/(?:[^.]+\.2chan\.net(?::\d+)?\/[^\/]+|(?:(?:apr|feb|dec|jan|mar|jul|aug|sep|rr[a-z])\.2chan\.net|112\.78\.198\.230|112\.78\.201\.90|112\.78\.200\.214)(?::\d+)?\/[^\/]+\/[^\/]+)\/thumb\/\d+s\.jpg$/.test(nodes[i].src) ||
				!nodes[i].parentNode ||
				nodes[i].parentNode.nodeName.toLowerCase() != 'a')
				continue;

			nodes[i].id = 'akahuku_thumbnail';

			if (Akahuku.cap.canvasEnabled && Akahuku.cap.dataSchemeEnabled) {
				var image = new Image();
				image.onload = function () {
					$E($T('head')[0], 'link', {rel:'icon', id:'akahuku_favicon', href:Akahuku.createIcon(this, 16, 3), type:'image/png'});
					this.onload = this.onerror = null;
					image = null;
				};
				image.onerror = function () {
					this.onload = this.onerror = null;
					image = null;
				};
				image.src = location.href.replace(/\/res\/.*/, (/\/thumb\/.+/.exec(nodes[i].src))[0]);
			}

			return nodes[i];
		}

		return null;
	},

	updateExpiration: function (expiration) {
		if (Akahuku.allowDispThreadInfoOnTitle)
			document.title = document.title.replace(/ \([^)]*\)$/, '') + ' (\uFF5E' + expiration.match(/\d+:\d+/)[0] + ')';
	},
	updateWarning: function (warning) {
		if (Akahuku.allowDispThreadInfoOnTitle)
			document.title = '[\u53E4]' + document.title.replace(/^\[\u53E4\]/, '');
	},
	updateAzad: function (content) {
		var re = /<(?:td|div)>(<a href="http:\/\/www\.amazon\.(?:.|\r|\n)+?)<\/div>/i.exec(content);
		re && setTimeout(function () {
			var td = $('akahuku_azad_inner');
			if (td) td.innerHTML = re[1]
				.replace(/<blockquote[^>]*>(.+?)<\/blockquote>/i, '$1')
				.replace(/<form\b/i, '$& target="_blank" ')
				.replace(/hspace\s*=\s*["']?\d+["']?/ig, '');
		}, 1000);
	},
	handleWindowUnload: function (e) {
		!this.causesUnloadAnchorClicked && scrollTo(0, 0);
	},
	handleBodyClick: function (e) {
		if (!e || !e.t) return;

		var n = e.t.nodeName.toLowerCase(), anchor = n == 'a' ? e.t :
			n == 'img' && e.t.parentNode.nodeName.toLowerCase() == 'a' ? e.t.parentNode : 
			null;
		if (!anchor) return;

		var imageInfo = Akahuku.isRelationalImage(anchor.href);

		/* fix for drawing on may (2010.3) */
		if (e.t.id == 'oebtn' && window.ChangeDraw) {
			e.p();
			ChangeDraw();
			return;
		}
		/* fix for drawing on may (2010.3) */

		if (e.t.nodeName.toLowerCase() == 'a' &&
			/^(?:|_(?:self|parent|top))$/i.test(e.t.target) &&
			!/^#/.test(e.t.getAttribute('href')))
			this.causesUnloadAnchorClicked = true;

		// dispatch with type of url
		if (anchor.className == 'akahuku_quote_anchor') {
			e.p();
			for (var o = anchor.nextSibling; o; o = o.nextSibling) {
				if (o.nodeName.toLowerCase() == 'blockquote') {
					Akahuku.doQuote(
						o.innerText.replace(/[\u202a-\u202e]/g, '').$hd().replace(/\r?\n/g, '\r\n'),
						true, true);
					break;
				}
			}
		}
		else if (anchor.className == 'akahuku_ddel') {
			var button = $('ddbut');
			if (button) {
				e.p();
				$click(button);
			}
		}
		else if (anchor.className == 'del' && window.chrome) {
			e.p();
			window.del(e.t.getAttribute('__delno') || e.t.__delno);
		}
		else {
			if (Akahuku.fn.reply && !Akahuku.isCatalog) {
				if (anchor.className == 'akahuku_inline_image_anchor') {
					Akahuku.fn.reply.doInlineImage(anchor) && e.p();
					return;
				}
				else if (anchor.className == 'akahuku_popup_target') {
					e.p();
					Akahuku.fn.popupQuotation.handleAnchorClick(anchor);
					return;
				}
				else if (anchor.id.match(/^akahuku_uttag_(.+)$/)) {
					e.p();
					Akahuku.fn.reply.fetchUT(anchor, RegExp.$1);
					return;
				}
				else if (anchor.id.match(/^akahuku_nicotag_(.+)$/)) {
					e.p();
					Akahuku.fn.reply.fetchNico2(anchor, RegExp.$1);
					return;
				}
				else if (imageInfo && !Akahuku.fn.reply.quickImageState && Akahuku.allowQuickImage) {
					e.p();
					Akahuku.fn.reply.displayQuickImage(anchor);
					return;
				}
			}

			// Opera, IE: do nothing if the anchor points the address inside futaba or akahuku external server or unite address
			// Chrome can seamless transition (because Chrome doesn't use indirect html).
			if (window.chrome) {
				if (/^http:\/\/tsumanne\.net(?::\d+)?\//.test(anchor.href)) return;
			}
			else {
				if (/^http:\/\/[^\.]+\.2chan\.net(?::\d+)?\//.test(anchor.href)) return;
				if (/^http:\/\/tsumanne\.net(?::\d+)?\//.test(anchor.href)) return;
				if (window.opera && anchor.href.indexOf(Akahuku.getUnitePrefix()) == 0) return;
				for (var i = 0; i < Akahuku.baseURLs.length; i++) 
					if (anchor.href.indexOf(Akahuku.baseURLs[i]) == 0) return;
			}

			if (imageInfo) {
				var localAnchor = anchor.cloneNode(false);
				localAnchor.href = Akahuku.getLocalProxiedUrl(localAnchor.href);
				Akahuku.doLink(localAnchor) && e.p() && e.s();
			}
			else
				Akahuku.doLink(anchor) && e.p() && e.s();
		}
	},
	handleBodyMousewheel: function (e) {
		var wheelDelta = Akahuku.allowInvertWheelDirection ? -e.wheelDelta : e.wheelDelta,
			scrollTop = windowScrollInfo.scrollTop(),
			scrollHeight = windowScrollInfo.scrollHeight(),
			clientHeight = windowScrollInfo.clientHeight(),
			prevented = false,
			setStatus = function (status) {
				$('akahuku_wheel_status').innerHTML = status;
			};

		if (wheelDelta >= 0 || scrollTop < scrollHeight - clientHeight) {
			this.delta = 0;
			setStatus('');
			return;
		}

		var now = new Date().getTime(), threshold = Akahuku.numberBottomScrollThreshold;

		if (threshold <= 0) 
			threshold = window.opera ? 7 : 3;

		threshold = -120 * threshold;

		if (now - this.loadTime >= 500) {
			this.loadTime = now;
			this.delta = 0;
			setStatus('');
		}
		this.delta += wheelDelta;

		if (this.delta < threshold) {
			this.loadTime = now;
			this.delta = 0;

			e.p();
			prevented = true;
			if (Akahuku.isNormal) {
				scrollTo(0, 0);
				$Unevent();
				window.opera && Math.random() <= 0.1 && opera.collect();
				location.replace(location.href);
			}
			else {
				if (now - this.lastReload < 5 * 1000) {
					setStatus('\u3061\u3087\u3063\u3068\u307E\u3063\u3066\u306D\u3002');
				}
				else {
					if (Akahuku.fn.reload) {
						Akahuku.fn.reload.loadNewReplies(false, true);
						setStatus('');
					}
					else if ($('akahuku_catalog_reloader_anchor')) {
						$click('akahuku_catalog_reloader_anchor');
						setStatus('');
					}
					else {
						$Unevent();
						window.opera && Math.random() <= 0.1 && opera.collect();
						location.replace(location.href);
					}
					this.lastReload = now;
				}
			}
		}
		else
			setStatus('\u30EA\u30ED\u30FC\u30C9\u3062\u304B\u3089\uff1a ' +
				parseInt(((this.delta / threshold) * 100) - 1) + '%');
	},

	// hotkey handlers.
	handleDocumentKeydown: function (e) {
		var handled = false;

		if (Akahuku.isTextInput(e.t)) {
			// quick post: [shift+enter]
			if (e.t.id == 'ftxa' && e.keyCode == 13 && e.shiftKey) {
				handled = true;
				$click('submitter');
			}

			// focus body: [esc]
			else if (!window.opera && e.keyCode == 27) {
				handled = true;
				document.body.focus();
			}
		}
		else {
			/*
			 * global hotkeys
			 */

			// focus comment text area: [ins], [i]
			if (e.keyCode == 45 || e.keyCode == 73) {
				handled = true;
				Akahuku.getSelection() != '' && $('akahuku_quote_akahuku') ?
					$click('akahuku_quote_akahuku') : Akahuku.ensureDispPostForm();
			}

			// reload: [r]
			else if (e.keyCode == 82 && !e.ctrlKey) {
				handled = true;
				if (Akahuku.isReply && Akahuku.fn.reload) {
					Akahuku.ensureDispLastReply();
					Akahuku.fn.reload.loadNewReplies();
				}
				else if (Akahuku.isCatalog && Akahuku.fn.catalog) {
					Akahuku.fn.catalog.reload();
				}
				else if (Akahuku.isNormal) {
					scrollTo(0, 0);
					//location.replace(location.href.replace(/#.*/, ''));
					window.opera && Math.random() <= 0.1 && opera.collect();
					location.reload(false);
				}
			}

			// jump to top of page: [g]
			// jump to bottom of page: [shift+g]
			else if (e.keyCode == 71 && !e.ctrlKey) {
				handled = true;
				scrollTo(0, e.shiftKey ? windowScrollInfo.scrollHeight() - windowScrollInfo.clientHeight() : 0);
			}
		}

		if (handled) {
			e.p();
			this.hotkeyPressed = true;
		}
	},
	handleDocumentKeypress: function (e) {
		if (this.hotkeyPressed) {
			// in IE, when keydown event is canceled, keypress event seems not to be raised,
			// but Opera is, both events are raised regardless of the cancelation.
			// therefore we'll cancel keypress event only in Opera.
			window.opera && e.p();
			this.hotkeyPressed = false;
		}
	}
});

/** AkahukuPostFormWork: postform enhancement */
(Akahuku.isNormal || Akahuku.isReply) && Akahuku.add({
	closeTimer: null,
	entered: false,
	commentWatchTimerID: null,
	blink: false,
	fieldFocused: false,
	canPostImage: false,
	signature: 'postForm',
	initialize: function () {
		var style = new StyleWrapperClass();

		// fix <center> tag behavior in CSS1compat mode for IE (it's seems to be available even in IE8...!)
		if (window.ActiveXObject)
			style.a('body center table', 'text-align:left');

		// fix horz scrollbar behavior for IE
		if (window.ActiveXObject && window.top != window.self)
			style.a('html', 'overflow-y:scroll');

		// fix background for *older* IE (it's necessary for position:fixed emulation)
		if (Akahuku.cap.isOlderIE && (Akahuku.isFloating() || Akahuku.allowThreadOperator))
			style.a('body', 'background:#ffffee url(http://0.0.0.0/noexistent.jpg) fixed');

		if (Akahuku.isNormal && Akahuku.allowHidePostForm ||
			Akahuku.isReply && Akahuku.allowHideReplyPostForm ||
			Akahuku.isFloating())
			style.a('body center form', 'display:none');

		if (Akahuku.isFloating()) {
			var w = Akahuku.numberFloatFormWidthPercent - 0;
			if (isNaN(w) || w < 20 || w > 100) w = 50;
			Akahuku.numberFloatFormWidthPercent = w;
			style.a('#postbox_container',
					'width:' + w + '%;font-size:80%;border:solid 2px #eeaa88;border-radius:4px;box-shadow:0 0 8px #404040;margin:0;padding:0;background-color:#ffffee;' +
					Akahuku.getFixedStyle(Akahuku.numberFloatFormPosition))
				.a('#postbox_container table', 'width:100%;font-size:100%;margin:0;padding:0')
				.a('#postbox', 'margin:0;padding:1px');
		}
		else {
			style.a('#posttable', 'margin:0 auto 0 auto');
		}

		// turn on IME when the comment box get focus, for IE
		if (window.ActiveXObject && Akahuku.allowActivateIMEonComment)
			style.a('#ftxa', 'ime-mode:active');

		style
			.a('#ftxa', 'padding:2px;color:#800000;' + (window.chrome ? '-webkit-' : '') + 'box-sizing:border-box')
			.a('#name', 'color:#117743;background-color:#ffffff;font-weight:bold')
			.a('#email', 'color:#0000ff;background-color:#ffffff')
			.a('#sub', 'color:#cc1105;background-color:#ffffff;font-weight:bold')
			/* fix for html restructuring on may (2010.2) */
			.a('#postnotice', 'margin:0 auto 0 auto;font-size:10pt')
			.a('td.ftdc', 'background-color:#eeaa88')
			/* fix for html restructuring on may (2010.2) */
			// fix for <li> without <ul> on img
			.a('#postnotice td small li', 'font-size:10pt')
			.apply();
	},
	start: function () {
		if (!this.assignIDs() || !this.recreateForm()) return;

		// float or hide or recreate for background posting reply
		Akahuku.isFloating() ? this.floatit() : this.shellit();

		// sage button
		if (Akahuku.allowSageButton) {
			var email = $('email'), par = email.parentNode;
			$TX(par, ' [');
			var tmp = $E(par, 'a', {id:'akahuku_sage_button', title:'sage \u306e\u5165\u529b (S)', accessKey:'s', style:{cursor:'pointer'}});
			$TX($E(tmp, 'u'), 's');
			$TX(tmp, 'age');
			$TX(par, ']');
			$Event(tmp, 'click', this.handleSageButtonClick.$bind(this));
		}

		// extend text fields
		if (Akahuku.allowExtendMailBox) {
			for (var i = 0, texts = ['name', 'email', 'sub']; i < texts.length; i++) {
				var tmp = $(texts[i]);
				if (!tmp) continue;

				var par = tmp.parentNode,
					table = $E(null, 'table', {style:{width:'100%', borderCollapse:'collapse'}}),
					tr = $E($E(table, 'tbody'), 'tr'),
					td = $E(tr, 'td');
				tmp.style.display = 'block';
				tmp.style.width = '98%';
				td.appendChild(tmp);

				var td = $E(tr, 'td', {innerHTML:'', style:{width:'3%', whiteSpace:'nowrap'}});
				while (par.firstChild) td.appendChild(par.firstChild);

				par.appendChild(table);
			}
		}

		// comment status
		if (Akahuku.allowCommentStatus) {
			var tmp = $E($('akahuku_com_container').parentNode, 'div', {id:'akahuku_commentstatus', style:{backgroundColor:'#ffffee', padding:'4px 2px 2px 2px'}});
			if (!Akahuku.isFloating() || window.ActiveXObject)
				tmp.style.fontSize = '80%';
			this.handleDispCommentLengthTimer();
		}

		// alternate thread creator
		if (Akahuku.isReply && Akahuku.allowAlterThread && !Akahuku.isDrawingBoard) {
			$('modebox').innerHTML =
				'<label for="akahuku_postmode_reply">' +
				'<input type="radio" id="akahuku_postmode_reply" name="akahuku_postmode" checked>' +
				'\u30EC\u30B9\u9001\u4FE1\u30E2\u30FC\u30C9</label>&nbsp;' +
				'<label for="akahuku_postmode_thread">' +
				'<input type="radio" id="akahuku_postmode_thread" name="akahuku_postmode">' +
				'<font style="font-size:80%;font-weight:normal">' +
				'\u65B0\u898F\u30B9\u30EC\u30C3\u30C9\u4F5C\u6210</font></label>';

			if (!$('upfile')) {
				for (var i = 0, trs = $T('tr', 'posttable'); i < trs.length; i++) {
					if (!/<b>\u524A\u9664\u30AD\u30FC<\/b>/i.test(trs[i].innerHTML)) continue;

					var tr = $E(trs[i].parentNode, 'tr', null, trs[i]),
						td1 = $E(tr, 'td', {innerHTML:'<b>\u6DFB\u4ED8File</b>', bgColor:'#eeaa88'}),
						td2 = $E(tr, 'td'),
						upfile = $E(td2, 'input', {type:'file', id:'upfile', name:'upfile', size:35, disabled:'disabled'});

					$TX(td2, ' [');
					var alabel = $E(td2, 'label');
					$E(alabel, 'input', {type:'checkbox', id:'textonly', name:'textonly', value:'on', disabled:'disabled'});
					$TX(alabel, '\u753B\u50CF\u306A\u3057');
					$TX(td2, ']');
					break;
				}
			}

			var tmp = this.handlePostModeClick.$bind(this);
			$Event('akahuku_postmode_reply', 'click', tmp);
			$Event('akahuku_postmode_thread', 'click', tmp);
		}

		// comment box height controller
		if (Akahuku.allowControlCommentHeight) {
			for (var nodes = $T('td', 'posttable'), i = 0; i < nodes.length; i++) {
				var html = nodes[i].innerHTML;
				if (!/\u30B3\u30E1\u30F3\u30C8/.test(html)) continue;

				var tmp =
					'<a id="akahuku_commentbox_incrementer" style="cursor:pointer">[+]</a> ' +
					'<a id="akahuku_commentbox_decrementer" style="cursor:pointer">[-]</a>';

				if (!Akahuku.isFloating() || Akahuku.numberFloatFormPosition >= 2) {
					nodes[i].innerHTML = ['<div style="margin:0 0 1em 0">', tmp, '</div>', html].join('');
					nodes[i].style.verticalAlign = 'top';
				}
				else {
					nodes[i].innerHTML = [html, '<div style="margin:1em 0 0 0">', tmp, '</div>'].join('');
					nodes[i].style.verticalAlign = 'bottom';
				}

				var mousedownHandler = this.handleCommentBoxSizeControllerMousedown.$bind(this),
					mouseupHandler = this.handleCommentBoxSizeControllerMouseup.$bind(this),
					incrementer = $('akahuku_commentbox_incrementer'),
					decrementer = $('akahuku_commentbox_decrementer');
				$Event(incrementer, 'mousedown', mousedownHandler);
				$Event(incrementer, 'mouseup', mouseupHandler);
				$Event(decrementer, 'mousedown', mousedownHandler);
				$Event(decrementer, 'mouseup', mouseupHandler);
				break;
			}
		}

		// bind event handlers
		// note: by the definition of w3c, focus/blur events does'nt bubble.
		// (however, the event model of use here is 'capturing phase', and
		// might be inconsiderable)
		// still, note that this code might not function on Opera in the future.
		var target = window.ActiveXObject ? document.body : document,
			focusevents = window.ActiveXObject ? ['activate', 'deactivate'] : ['focus', 'blur'];
		$Event(target, focusevents[0], this.handleDocumentFocus.$bind(this), true);
		$Event(target, focusevents[1], this.handleDocumentBlur.$bind(this), true);

		$Event('postbox', 'submit', this.handlePostFormSubmit.$bind(this));
		this.submitHooks.unshift(this.postFormDefaultHook.bind(this));
	},
	recreateForm: function () {
		var postboxOld = $('postbox');
		if (!postboxOld) return false;

		var postboxNew = $E(null, 'form', {
			id:'postbox', action:postboxOld.action, method:postboxOld.method, enctype:postboxOld.enctype,
			target:Akahuku.allowBackgroundPostReply ? 'akahuku_reply_target_frame' : '_self'});

		while (postboxOld.firstChild)
			postboxNew.appendChild(postboxOld.removeChild(postboxOld.firstChild));

		postboxOld.parentNode.replaceChild(postboxNew, postboxOld);

		for (var i = 0, scripts = $T('script', postboxNew); i < scripts.length; i++)
			scripts[i].parentNode.removeChild(scripts[i]);

		return true;
	},
	floatit: function () {
		var createModebox = function () {
			var modebox = $('modebox');
			if (modebox)
				modebox.id = 'modebox_org';

			return $E(null, 'div', {
				id:'modebox',
				style:{backgroundColor:'#e04000', color:'#ffffff', fontWeight:'bold', textAlign:'center', padding:'3px'},
				innerHTML:$('modebox_org') ? $('modebox_org').innerHTML : '\u3093\uFF1F'});
		},
		createIcon = function () {
			return $E(null, 'img', {
				id:'akahuku_floatpostform_footer_icon',
				style:{display:'block'},
				src:Akahuku.getResource('futaba')});
		},
		createNavibox = function () {
			var result = $E(null, 'div', {id:'akahuku_floatpostform_navibox'}),
				tr = $E($E($E(result, 'table'), 'tbody'), 'tr'),
				td = $E(tr, 'td', {style:{textAlign:'left'}});

			if (Akahuku.isNormal) {
				var maxpage = Akahuku.normalPageNumber, re = null;
				for (var nodes = $T('a'), i = nodes.length - 1; i >= 0 && !/\u8fd4\u4fe1/.test(nodes[i].innerHTML); i--) {
					if (re = /\/(\d+)\.htm$/.exec(nodes[i].href)) {
						var tmp = parseInt(re[1]);
						if (tmp > maxpage)
							maxpage = Math.min(tmp, 10);
					}
				}
				for (var i = 0; i <= maxpage; i++) 
					i == Akahuku.normalPageNumber ?
						$E(td, 'b', {innerHTML:'[' + i + ']'}) :
						$E(td, 'a', {innerHTML:'[' + i + ']', href:i == 0 ? 'futaba.htm' : i + '.htm'});
			}
			else
				td.innerHTML =
					'[<a href=futaba.htm>\u63B2\u793A\u677F\u306B\u623B\u308B</a>]' +
					($('akahuku_cataloglink') ? '['+$('akahuku_cataloglink').outerHTML+']':'');

			$E(tr, 'td', {
				innerHTML:
					'[<a id="akahuku_floatpostform_killer" href="#hide">\u6D88\u3059</a>]&nbsp;' +
					'<label for="akahuku_floatpostform_clipper"><input type=checkbox id="akahuku_floatpostform_clipper">' +
					'\u9069\u5F53\u306B\u96A0\u3059' +
					'</label>',
				style:{textAlign:'right'}});

			return result;
		};

		var postbox = $('postbox'),
			isHidden = (Akahuku.isNormal && Akahuku.allowHidePostForm || Akahuku.isReply && Akahuku.allowHideReplyPostForm),
			postboxContainer = $E(document.body, 'div', {id:'postbox_container'}),
			div = $E(null, 'div', {id:'akahuku_floatpostform_container', style:{display:isHidden ? 'none' : 'block'}});

		if (Akahuku.numberFloatFormPosition >= 2) {
			postbox.style.borderTop = '1px solid #eeaa88';

			postboxContainer.appendChild(createNavibox());
			postboxContainer.appendChild(div);
			div.appendChild(postbox);
			Akahuku.isReply && div.appendChild(createModebox());
			Akahuku.allowMinimizePostForm && postboxContainer.appendChild(createIcon());
		}
		else {
			postbox.style.borderBottom = '1px solid #eeaa88';

			postboxContainer.appendChild(div);
			Akahuku.isReply && div.appendChild(createModebox());
			div.appendChild(postbox);
			postboxContainer.appendChild(createNavibox());
			Akahuku.allowMinimizePostForm && postboxContainer.appendChild(createIcon());
		}

		if (Akahuku.allowMinimizePostForm) {
			$('akahuku_floatpostform_footer_icon').style.display = isHidden ? 'block' : 'none';
			$('akahuku_floatpostform_navibox').style.display = isHidden ? 'none' : 'block';
			postboxContainer.style.width = isHidden ? '27px' : Akahuku.numberFloatFormWidthPercent + '%';
		}

		$('ftxa').style.width = '100%';
		$('akahuku_floatpostform_clipper').checked = isHidden;
		Akahuku.allowFloatPostFormAlpha && Akahuku.setOpacity(postboxContainer, 0.3);

		$Event(document.body, 'mouseover', this.handleBodyMouseover.$bind(this));
		$Event('akahuku_floatpostform_killer', 'click', this.handleFloatPostFormKillerClick.$bind(this));
	},
	shellit: function () {
		var postbox = $('postbox');
		if (!postbox) return;

		var posttable = $('posttable'),
			container = $E(postbox.parentNode, 'div', { id:'postbox_container'}, postbox);

		if (Akahuku.isNormal && Akahuku.allowHidePostForm || Akahuku.isReply && Akahuku.allowHideReplyPostForm) {
			var div = $E(container, 'div', {style:{textAlign:'center', padding:'2px', margin:'4px'}});

			postbox.style.marginTop = '0';
			postbox.style.display = 'none';

			var a = $E(div, 'a', {
				id:'akahuku_postform_opener',
				href:'#dispform',
				innerHTML:(Akahuku.isNormal ? '\u30B9\u30EC\u7ACB\u3066\u308B' : '\u30EC\u30B9\u3059\u308B'),
				style:{backgroundColor:'#f0e0d6', border:'1px solid #eeaa88', fontWeight:'bold', padding:'2px'}});
			$Event(a, 'click', this.handleTogglePostFormVisibility.$bind(this));
		}

		container.appendChild(postbox);
	},
	assignIDs: function () {
		// find post form and thread-content form
		var postbox = null, threadsbox = null, forms = $T('form');
		for (var i = 0; i < forms.length; i++) {
			if (/futaba\.php/i.test(forms[i].action) && forms[i].method.toLowerCase() == 'post') {
				switch (forms[i].enctype.toLowerCase()) {
				case 'multipart/form-data':
					forms[i].id = 'postbox';
					postbox = forms[i];
					break;
				case 'application/x-www-form-urlencoded':
				case '':
					if ($T('blockquote', forms[i]).length > 0) {
						forms[i].id = 'threadsbox';
						threadsbox = forms[i];
					}
					break;
				}
			}
			else
				forms[i].style.display = 'block';
		}
		if (!threadsbox && postbox) {
			var hrs = $T('hr');
			threadsbox = $E(hrs[1].parentNode, 'form', {id:'threadsbox'}, hrs[1]);

			while (threadsbox.nextSibling) {
				var thenode = threadsbox.nextSibling,
					nodeName = thenode.nodeName.toLowerCase();
				if (nodeName == 'table') {
					if (thenode.align.toLowerCase() == 'left') break;

					var tds = $T('td', thenode);
					tds.length >= 2 && $E(tds[1], 'input', {type:'checkbox', value:'delete', name:'0'}, tds[1].firstChild);
				}
				else if (nodeName == 'font' && thenode.color == '#cc1105') 
					$E(threadsbox, 'input', {type:'checkbox', value:'delete', name:'0'});

				threadsbox.appendChild(thenode);
			}
		}
		if (!postbox) return false;

		// find table inside form and divide the table into form-fields table and post-notice table
		var tables = $T('table', postbox);
		if (tables.length > 0) {
			tables[0].id = 'posttable';

			for (var i = 0, cells = $T('td', tables[0]); i < cells.length; i++) {
				if (cells[i].bgColor != '')
					cells[i].style.whiteSpace = 'nowrap';

				/* fix for html restructuring on may (2010.2) */
				//else if (Akahuku.isFloating())
				//	cells[i].style.width = '100%';
				/* fix for html restructuring on may (2010.2) */

				if (cells[i].colSpan == '2') {
					$E($E($E($E(
						postbox.parentNode, 'table', {id:'postnotice'}, postbox.nextSibling), 'tbody'), 'tr'), 'td', {innerHTML:cells[i].innerHTML});
					cells[i].parentNode.removeChild(cells[i]);
				}
			}
		}

		// find text fields
		for (var i = 0, texts = ['name', 'email', 'sub']; i < texts.length; i++) {
			var tmp = $N(texts[i])[0];
			if (tmp && tmp.nodeName.toLowerCase() == 'input' && tmp.type.toLowerCase() == 'text')
				tmp.id = texts[i];
		}

		// find comment field
		var com = $N('com')[0];
		if (com && com.nodeName.toLowerCase() == 'textarea') {
			com.id = 'ftxa';
			com.style.display = 'block';
			com.style.padding = '0';
			com.style.border = 'none';
			com.style.backgroundColor = 'transparent';
			com.style.margin = '.5em 0 0 0';

			var comContainer = $E(null, 'div', {id:'akahuku_com_container', 
				innerHTML:Akahuku.allowCommentStatus ? '<label for="ftxa"><span>99/99/99(M)99:99:99</span> No.XXXXXXXX</label>' : '',
				style:{padding:'2px', border:'1px solid #eeaa88', backgroundColor:Akahuku.isReply ? '#f0e0d6' : '#ffffee'}});
			com.parentNode.replaceChild(comContainer, com);
			comContainer.appendChild(com);
		}

		// find file field
		var filebox = $N('upfile')[0];
		if (filebox && filebox.nodeName.toLowerCase() == 'input' && filebox.type.toLowerCase() == 'file') {
			filebox.id = 'upfile';
			this.canPostImage = Akahuku.isNormal || Akahuku.isReply;
		}

		// find submit button
		for (var inputs = $T('input', postbox), i = 0; i < inputs.length; i++) {
			if (inputs[i].type.toLowerCase() != 'submit') continue;
			inputs[i].id = 'submitter';
			break;
		}

		// find mode box
		for (var fonts = $T('font'), i = 0; i < fonts.length && i < 5; i++) {
			if (!/\u30EC\u30B9\u9001\u4FE1\u30E2\u30FC\u30C9/.test(fonts[i].innerHTML)) continue;
			fonts[i].id = 'modebox';
			$P(fonts[i], 'table', function (node) { node.id = 'modebox_outer_table'; });
			break;
		}

		// find viewers
		for (var lis = $T('li'), i = 0; i < lis.length; i++) {
			if (!/\u73FE\u5728\d+\u4EBA\u304F\u3089\u3044\u304C/.test(lis[i].innerHTML)) continue;
			lis[i].innerHTML = lis[i].innerHTML.replace(/\d+/, '<font id=viewers>$&</font>');
			break;
		}

		return true;
	},
	textFieldValidator: function (element, maxRows, maxByteLength) {
		var rows = 0,
			bytes = 0,
			rowsOvered = false,
			bytesOvered = false;

		function updateWarnText (context) {
			/* =============================
			THIS MESSAGE MIGHT LOOK STRANGE,
			BUT YOU SHOULD NOT CHANGE EASILY
			BECAUSE IT WAS DECIDED DEPENDING
			ON THE USERS OF NIJIURA, FUTABA.
			============================= */
			context.warnStatus = ' <font color="red" style="">[\u305D\u3093\u306A\u6C7A\u3081\u65B9\u3067\u3044\u3044\u306E\u304B\uFF01\uFF01\uFF1F]</font>';
		}

		this.update = function (context) {
			var txt = Akahuku.getRegalizedComment(element.value).replace(/[\r\n]+$/, ''),
				a = txt.split(window.chrome ? '\n' : '\r\n');

			if (a.length >= 1 && /^\s*$/.test(a[a.length - 1])) a.length--;

			rows = a.length;
			bytes = a.join('\r\n').replace(/[^\u0001-\u007f\uff61-\uff9f]/g, '__').length;
			rowsOvered = false;
			bytesOvered = false;

			if (rows > maxRows) {
				rowsOvered = true;
				updateWarnText(context);
			}
			if (bytes > maxByteLength) {
				bytesOvered = true;
				updateWarnText(context);
			}

			return this;
		};
		this.getRowsText = function () {
			return rowsOvered ? '<font color="red">' + rows + '</font>' : rows;
		};
		this.getBytesText = function () {
			return bytesOvered ? '<font color="red">' + bytes + '</font>' : bytes;
		};
	},

	handleBodyMouseover: function (e) {
		var form = $('postbox'),
			clipper = $('akahuku_floatpostform_clipper'),
			postformContainer = $('akahuku_floatpostform_container');

		if (!form || !clipper || !postformContainer) return;

		var insideForm = !!$P(
			Akahuku.getElementFromPoint(e.pageX, e.pageY), 
			function (node) { return node.id == 'postbox_container'; });

		if (insideForm) {
			if (clipper.checked) {
				if (this.closeTimer) {
					clearTimeout(this.closeTimer);
					this.closeTimer = null;
				}
				if (postformContainer.style.display != 'block')
					this.handleFloatPostFormOpenerClick();
			}
			Akahuku.allowFloatPostFormAlpha && Akahuku.setOpacity($('postbox_container'), 1.0);
			this.entered = true;
		}
		else if (postformContainer.style.display == 'block' && !this.closeTimer && this.entered) {
			this.closeTimer = setTimeout((function () {
				Akahuku.allowFloatPostFormAlpha && Akahuku.setOpacity($('postbox_container'), 0.3);
				if ($('akahuku_floatpostform_clipper').checked) {
					$('ftxa').blur();
					for (var i = 0, nodes = $T('input', form); i < nodes.length; i++)
						(nodes[i].type.toLowerCase() != 'hidden') && nodes[i].blur();
					this.handleFloatPostFormOpenerClick();
					this.fieldFocused = false;
				}
				this.closeTimer = null;
				this.entered = false;
			}).bind(this), 500);
		}
	},
	handleDocumentFocus: function (e) {
		if (Akahuku.isTextInput(e.t)) {
			if (/^(?:name|email|sub|ftxa)$/.test(e.t.id)) {
				if (!this.fieldFocused) 
					Akahuku.allowFloatPostFormAlpha && $('akahuku_floatpostform_container') && Akahuku.setOpacity($('postbox_container'), 1.0);
				if (Akahuku.allowCommentStatus && !this.commentWatchTimerID) {
					this.blink = true;
					this.handleDispCommentLengthTimer();
					this.commentWatchTimerID = setInterval(this.handleDispCommentLengthTimer.bind(this), 500);
				}
			}
			this.fieldFocused = true;
		}
	},
	handleDocumentBlur: function (e) {
		this.fieldFocused = false;
		if (this.commentWatchTimerID) {
			clearInterval(this.commentWatchTimerID);
			this.commentWatchTimerID = null;
			this.blink = true;
			this.handleDispCommentLengthTimer();
		}
	},

	// post form submit handler
	submitHooks: [],
	handlePostFormSubmit: function (e) {
		e.p();
		var commentbox = $('ftxa'),
			original = commentbox.value;
		try {
			Akahuku.setCurrentReplyToCookie();
			Akahuku.doLockSubmitter();
			commentbox.value = Akahuku.getRegalizedComment(commentbox.value);

			for (var i = 0; i < this.submitHooks.length; i++) {
				if (this.submitHooks[i](e.t)) break;
			}
		}
		finally {
			commentbox.value = original;
		}
	},
	resetForm: function () {
		var f = $E(null, 'form'),
			elements = [];

		for (var i = 0; i < arguments.length; i++) {
			var org = $(arguments[i]);
			if (!org || org.id != arguments[i]) continue;

			var clone = org.cloneNode(false);
			clone.id = 'clone_' + org.id;
			try { if (clone.value) clone.value = ''; } catch (e) {}
			org.parentNode.replaceChild(clone, org);

			elements.push(org);
			f.appendChild(org);
		}

		if (elements.length) {
			f.reset();

			for (var i = 0; i < elements.length; i++) {
				var clone = $('clone_' + elements[i].id);
				clone.parentNode.replaceChild(elements[i], clone);
				elements[i] = null;
			}
		}

		elements.length = 0;
		elements = f = null;
	},
	postFormDefaultHook: function (form) {
		var submitWithBlank = function () {
			var resto = $N('resto')[0],
				postform = $E(document.body, 'form', {
				action:form.action, method:form.method, enctype:form.enctype, target:'_blank', style:{display:'none'}});

			while (form.firstChild) postform.appendChild(form.removeChild(form.firstChild));
			if (resto) resto.disabled = true;
			postform.submit();
			postform.parentNode.removeChild(postform);

			while (postform.firstChild) form.appendChild(postform.removeChild(postform.firstChild));
			if (resto) resto.disabled = false;

		};
		if (Akahuku.isNormal && Akahuku.allowThreadNew) {
			submitWithBlank();
		}
		else if (Akahuku.isReply && $('akahuku_postmode_thread') && $('akahuku_postmode_thread').checked) {
			if (!confirm('\u30B9\u30EC\u7ACB\u3066\u3061\u3083\u3046\u3088\uFF1F\n\u305D\u308C\u3067\u3082\u3044\u3044\u306E\uFF1F')) return true;

			submitWithBlank();
			$click('akahuku_postmode_reply');
		}
		else
			form.submit();

		this.resetForm('ftxa', 'upfile', 'baseform');
		return true;
	},

	// various event handlers corresponding each elements as child of the form. 
	handleSageButtonClick: function (e) {
		var n = $('email');
		if (!n) return;
		n.focus();
		n.value = /\bsage\b/.test(n.value) ? n.value.replace(/\s*\bsage\b\s*/g, '') : 'sage ' + n.value;
		n.setSelectionRange && n.setSelectionRange(n.value.length, n.value.length);
	},
	handleDispCommentLengthTimer: function () {
		function rightNum (n, len) {
			if (!len) len = 2;
			n = '000000000' + n;
			return n.substr(n.length - len);
		}

		var statusdiv = $('akahuku_commentstatus');
		if (!statusdiv) return;

		var textStatus = [],
			context = {warnStatus: ''},
			texts = [
			{id:'ftxa', row:15, len:1000},
			{id:'name', head:'\u540d', len:100}, 
			{id:'email', head:'\u30e1', len:100},
			{id:'sub', head:'\u984c', len:100}
		];

		for (var i = 0; i < texts.length; i++) {
			var text = $(texts[i].id);
			if (!text) continue;
			var v = (new this.textFieldValidator(text, texts[i].row || 1, texts[i].len)).update(context);
			if (texts[i].row)
				textStatus.push([v.getRowsText(), '/', texts[i].row, '\u884C(', v.getBytesText(), '/', texts[i].len, ')'].join(''));
			else
				textStatus.push([texts[i].head, '\uff1a', v.getBytesText(), '/', texts[i].len].join(''));
		}

		textStatus = textStatus.join('\u3000');

		if (context.warnStatus != '') {
			if (this.blink) context.warnStatus = context.warnStatus.replace('style="', 'style="visibility:hidden');
			textStatus += context.warnStatus;
			this.blink = !this.blink;
		}

		if (statusdiv.innerHTML != textStatus)
			statusdiv.innerHTML = textStatus;

		var span = $('akahuku_com_container');
		if (span) {
			var now = new Date();
			now = 
				[rightNum(now.getFullYear()), rightNum(now.getMonth() + 1), rightNum(now.getDate())].join('/') +
				'(' + '\u65e5\u6708\u706b\u6c34\u6728\u91d1\u571f'.substr(now.getDay(), 1) + ')' +
				[rightNum(now.getHours()), rightNum(now.getMinutes()), 'XX'].join(':');
			span = $T('span', span)[0];

			if (span && span.innerText)
				span.innerText = now;
			else if (span && span.textContent)
				span.textContent = now;
		}
	},
	handleTogglePostFormVisibility: function (e) {
		e.p();
		var postbox = $('postbox');
		if (!postbox) return;
		if (postbox.style.display != 'block') {
			postbox.style.display = 'block';
			e.t.innerHTML = '\u9001\u4FE1\u30D5\u30A9\u30FC\u30E0\u3092\u96A0\u3059';
		}
		else {
			postbox.style.display = 'none';
			e.t.innerHTML = Akahuku.isNormal ? '\u30B9\u30EC\u7ACB\u3066\u308B' : '\u30EC\u30B9\u3059\u308B';
		}

		var commentbox = $('ftxa');
		commentbox.value = commentbox.value;
		commentbox.focus();
	},
	handleFloatPostFormOpenerClick: function (e) {
		var postformContainer = $('akahuku_floatpostform_container'),
			postformFooterIcon = $('akahuku_floatpostform_footer_icon'),
			postformNavibox = $('akahuku_floatpostform_navibox');

		if (!postformContainer) return;
		if (postformContainer.style.display == 'block') {
			postformContainer.style.display ='none';

			if (Akahuku.allowMinimizePostForm && postformFooterIcon) {
				postformNavibox.style.display ='none';
				postformFooterIcon.style.display = 'block';
				$('postbox_container').style.width = '27px';
			}

			// fix Opera 9 behavior - display:none'ed element doesn't actually disappear until scroll
			Akahuku.ensureRender();
		}
		else {
			if (Akahuku.allowMinimizePostForm && postformFooterIcon) {
				postformFooterIcon.style.display = 'none';
				$('postbox_container').style.width = Akahuku.numberFloatFormWidthPercent + '%';
				postformNavibox.style.display = 'block';
			}

			postformContainer.style.display = 'block';

			var commentbox = $('ftxa');
			commentbox.value = commentbox.value;
			commentbox.focus();
		}
	},
	handlePostModeClick: function (e) {
		var form = $('postbox'), tmp;
		switch (e.t.id) {
		case 'akahuku_postmode_reply':
			if (form)
				form.style.backgroundColor = '';
			if ((tmp = $('upfile')) && !this.canPostReply)
				tmp.disabled = $('textonly').disabled = true;
			if ((tmp = $('akahuku_com_container')))
				tmp.style.backgroundColor = '#f0e0d6';
			if ((tmp = $('akahuku_commentstatus')))
				tmp.style.backgroundColor = '#ffffee';
			break;
		case 'akahuku_postmode_thread':
			if (form)
				form.style.backgroundColor = '#f0e0d6';
			if ((tmp = $('upfile')))
				tmp.disabled = $('textonly').disabled = false;
			if ((tmp = $('akahuku_com_container')))
				tmp.style.backgroundColor = '#ffffee';
			if ((tmp = $('akahuku_commentstatus')))
				tmp.style.backgroundColor = '#f0e0d6';
			break;
		}
		Akahuku.ensureDispPostForm();
	},
	handleFloatPostFormKillerClick: function (e) {
		e.p();
		var postbox = $('postbox_container');
		if (!postbox) return;
		postbox.style.display = 'none';
	},

	commentSizeTimer: null,
	handleCommentBoxSizeControllerMousedown: function (e) {
		e.p();
		this.commentSizeTimer = setInterval(function () {
			function test (node) { 
				return /^(?:akahuku_commentbox_(?:inc|dec)rementer)$/.test(node.id); 
			}
			function doit (node) {
				var commentbox = $('ftxa');
				if (!commentbox) return;

				var rows = parseInt(commentbox.rows);
				switch (node.id) {
				case 'akahuku_commentbox_incrementer':
					if (rows < 15) {
						commentbox.rows = rows + 1;
						return;
					}
					break;
				case 'akahuku_commentbox_decrementer':
					if (rows > 4) {
						commentbox.rows = rows - 1;
						return;
					}
					break;
				}
			}

			var el = Akahuku.getElementFromPoint(Akahuku.pageX, Akahuku.pageY);
			el && (test(el) ? doit(el) : $P(el, test, doit));
		}, 50);
	},
	handleCommentBoxSizeControllerMouseup: function (e) {
		if (this.commentSizeTimer) {
			clearInterval(this.commentSizeTimer);
			this.commentSizeTimer = null;
		}
	},

	updateViewers: function (viewers) {
		var v = $('viewers');
		if (v) v.innerHTML = viewers;
	}
});

/** AkahukuThreadOperatorWork: thread operator */
if ((Akahuku.isNormal || Akahuku.isReply) && Akahuku.allowThreadOperator) {
	var ThumbnailPopupClass;
	(ThumbnailPopupClass = function (anchor, width, height, useOpacity) {
		this.state = 0;
		this.anchor = anchor;
		this.originalWidth = this.targetWidth = width;
		this.originalHeight = this.targetHeight = height;
		this.angle = 0;
		this.opacity = useOpacity ? 0.5 : 1.0;
	}).prototype = {
		run: function (state) {
			var oldstate = this.state;
			switch (this.state = state) {
			case 0:
				this.angle = 0;
				this.anchor.firstChild.width = this.anchor.firstChild.height = '1';
				this.setOpacity(this.opacity);
				switch (Akahuku.numberThropThumbnailSize) {
				case 0:
					this.targetWidth = this.originalWidth;
					this.targetHeight = this.originalHeight;
					break;
				case 1:
					this.targetWidth = parseInt(this.originalWidth * 0.5);
					this.targetHeight = parseInt(this.originalHeight * 0.5);
					break;
				}
				break;
			case 1:
				this.anchor.firstChild.style.display = 'inline';
				this.manager.addEffector(this, this.enlargeEffect);
				break;
			case 2:
			case 6:
				this.manager.removeEffector(this);
				this.angle = 90;
				break;
			case 3:
				this.manager.addEffector(this, this.shrinkEffect);
				break;
			case 4:
				this.angle = 0;
				this.anchor.firstChild.style.display = 'none';
				this.manager.removeEffector(this);
				break;
			case 5:
				this.setOpacity(1.0);
				switch (Akahuku.numberThropThumbnailSize) {
				case 0:
					this.state = oldstate;
					break;
				case 1:
					this.angle = 0;
					this.manager.addEffector(this, this.zoominEffect);
					break;
				}
				break;
			case 7:
				switch (Akahuku.numberThropThumbnailSize) {
				case 0:
					this.state = oldstate;
					this.setOpacity(this.opacity);
					break;
				case 1:
					this.manager.addEffector(this, this.zoomoutEffect);
					break;
				}
				break;
			}
		},
		queryPurge: function (state) {
			return false;
		},
		setOpacity: function (ratio) {
			Akahuku.setOpacity(this.anchor.firstChild, ratio);
		},
		enlargeEffect: function () {
			if (this.state != 1) return;
			if (this.angle < 90) {
				this.angle += 9;
				if (this.angle > 90) this.angle = 90;
				this.anchor.firstChild.width = this.targetWidth;
				this.anchor.firstChild.height = Math.sin(Math.PI / 180 * this.angle) * this.targetHeight;
			}
			else
				this.run(2);
		},
		shrinkEffect: function () {
			if (this.state != 3) return;
			if (this.angle > 0) {
				this.angle -= 9;
				if (this.angle < 0) this.angle = 0;
				this.anchor.firstChild.width = this.targetWidth;
				this.anchor.firstChild.height = Math.sin(Math.PI / 180 * this.angle) * this.targetHeight;
			}
			else
				this.run(4);
		},
		zoominEffect: function () {
			if (this.state != 5) return;
			if (this.angle < 90) {
				this.angle += 9;
				if (this.angle > 90) this.angle = 90;
				this.anchor.firstChild.width = Math.sin(Math.PI / 180 * this.angle) * (this.originalWidth - this.targetWidth) + this.targetWidth;
				this.anchor.firstChild.height = Math.sin(Math.PI / 180 * this.angle) * (this.originalHeight - this.targetHeight) + this.targetHeight;
			}
			else
				this.run(6);
		},
		zoomoutEffect: function () {
			if (this.state != 7) return;
			if (this.angle > 0) {
				this.angle -= 9;
				if (this.angle < 0) this.angle = 0;
				this.anchor.firstChild.width = Math.sin(Math.PI / 180 * this.angle) * (this.originalWidth - this.targetWidth) + this.targetWidth;
				this.anchor.firstChild.height = Math.sin(Math.PI / 180 * this.angle) * (this.originalHeight - this.targetHeight) + this.targetHeight;
			}
			else {
				this.setOpacity(this.opacity);
				this.run(2);
			}
		}
	};

	Akahuku.add({
		popupManager: new PopupManagerClass(40),
		thumbnailPopup: null,
		floatThumbnailTimerID: null,
		signature: 'throp',
		initialize: function () {
			(new StyleWrapperClass())
				.a('#akahuku_thread_operator',
					Akahuku.getFixedStyle(
						(Akahuku.isFloating() && Akahuku.numberFloatFormPosition == 2) ? 0 : 2,
						'margin:0;padding:0;text-align:right'))
				.a('#akahuku_thread_operator table',
					'margin:0 0 0 auto;border-collapse:collapse')
				.a('#akahuku_throp_thumbnail_container',
					'margin:0 0 0 auto')
				.a('#akahuku_throp_thumbnail',
					'border:none')
				.a('#akahuku_throp_header_container table',
					'background-color:#ffffee;color:#800000;border-collapse:separate;border-spacing:0;border:1px solid #eeaa88;border-radius:4px;box-shadow:0 0 8px #404040')
				.a('#akahuku_throp_header_container td',
					'padding:2px 4px 2px 4px;vertical-align:middle;font-size:10pt')
				.a('#akahuku_throp_header_container img',
					'margin:0;border:none;vertical-align:middle')
				.a('#akahuku_throp_header_container small',
					'color:#789922')
				.a('#akahuku_throp_uniteicons', 'margin:0 4px 0 0')
				.a('#akahuku_throp_menu_container', 
					'display:none')
				.a('#akahuku_throp_menu_container table',
					'margin:0 0 0 auto;border-collapse:collapse;background-color:#ffffff;' +
					'border-width:1px;border-style:solid;border-color:silver gray gray silver')
				.a('#akahuku_throp_menu_container td',
					'padding:4px;text-align:right;line-height:1.2;border-top:1px solid silver;font-size:10pt')
				.a('#akahuku_throp_menu_container td:hover',
					'background-color:#ffffee')
				.a('#akahuku_throp_bgreload_anchor',
					'font-weight:bold')
				.a('#akahuku_throp_bgreload_status',
					'font-size:70%')
				.a('#akahuku_thread_list',
					'margin:0;border-collapse:collapse;border:none !important;background-color:transparent !important')
				.a('#akahuku_thread_list img',
					'margin:0 2px 0 0;float:left')
				.a('#akahuku_thread_list td',
					'border:none;padding:0;text-align:left')
				.a('#akahuku_thread_list div',
					'font-size:xx-small;width:120px;height:50px;overflow:hidden;padding:1px')
				.a('#akahuku_thread_list div:hover',
					'background-color:#f0e0d6')
				.a('#akahuku_thread_list div span',
					'margin:0 4px 0 0;color:#789922')
				.apply();
		},
		start: function () {
			if ($T('form').length == 0 || $T('blockquote').length == 0) return;

			// create contents. order of contents can change by fixed position of thread operator,
			// therefore store into array to sort.
			var contents = [
				$E(null, 'div', {id:'akahuku_throp_thumbnail_container'}),
				(function () {
				 	var div = $E(null, 'div', {id:'akahuku_throp_header_container'}), html = '';

					if (Akahuku.isReply && Akahuku.allowUseUniteCache)
						html += '<font id="akahuku_throp_uniteicons"></font>';
					if (Akahuku.isReply)
						html += '<font id="akahuku_throp_number">' + ($T('blockquote', 'threadsbox').length - 1) + '<small>\uFF9A\uFF7D</small></font>';
					if (Akahuku.allowDispViewersOnThrop && $('viewers'))
						html += '<font id="akahuku_throp_viewers">&nbsp;' + $('viewers').innerText + '<small>\u4EBA</small></font>';
					if (Akahuku.allowDispThreadInfoOnThrop)
						html += '<font id="akahuku_throp_status"></font>';

					div.innerHTML =
						'<table><tr><td><nobr> ' + html + 
						'<font id="akahuku_scanner_status" title="\u30b9\u30ad\u30e3\u30f3\u4e2d..."></font>' +
						'<img id="akahuku_throp_menu_opener" style="margin:0 0 0 4px" src="' + Akahuku.getResource('throp1') + '">' +
						'</nobr></td></tr></table>';

					return div;
				})(),
				(function () {
				 	var div = $E(null, 'div', {id:'akahuku_throp_menu_container'}), menuitems = [];

					menuitems.push(
						'<nobr>[<a href="/">\u30DB\u30FC\u30E0</a>]' +
						'<br>[<a href="futaba.htm">\u63B2\u793A\u677F\u306B\u623B\u308B</a>]' +
						($('akahuku_cataloglink') ? '<br>[' + $('akahuku_cataloglink').outerHTML + ']' : '') + 
						'<br>[<a id="akahuku_throp_top" href="#pagetop" accesskey="a">\u30DA\u30FC\u30B8\u5148\u982D</a>]' +
						'<br>[<a id="akahuku_throp_bottom" href="#pagebottom" accesskey="z">\u30DA\u30FC\u30B8\u672B\u5C3E</a>]' +
						'</nobr>');
					Akahuku.isReply && menuitems.push(
						'<nobr><label for="akahuku_thumbnail_clipper">' +
						'<input type="checkbox" id="akahuku_thumbnail_clipper">' +
						'\u30B5\u30E0\u30CD\u56FA\u5B9A</label></nobr>');
					window.opera && Akahuku.allowUseUniteCache && menuitems.push(
						'[<a href="' + Akahuku.getUnitePrefix('logs/' + Akahuku.serverName + '/' + Akahuku.directoryName + (Akahuku.isReply ? '/res/' + Akahuku.threadNumber + '.htm' : '/')) + '" target="_blank">\u30ed\u30fc\u30ab\u30eb\u30ed\u30b0*</a>]' + 
						'<form action="' + Akahuku.getUnitePrefix('logs/' + Akahuku.serverName + '/' + Akahuku.directoryName + '/') + '" accept-charset="UTF-8" target="_blank">' +
						'<input name="q" style="border:1px solid silver;font-size:10pt;width:100px"><input type="submit" value="\u691c\u7d22" style="padding:0 2px">' +
						'</form>');
					Akahuku.isReply && Akahuku.allowBackgroundReload && menuitems.push(
						'<nobr>[&nbsp;<font id="akahuku_throp_bgreload_status"></font>&nbsp;]' +
						'<br><a id="akahuku_throp_bgreload_anchor" href="#reload">\u7D9A\u304D\u3092\u8AAD\u3080</a>' +
						(Akahuku.cap.messageingEnabled && Akahuku.allowIframeReload || !Akahuku.allowUseRangeHeader ?  '' :
							('<br><a id="akahuku_throp_bgfullreload_anchor" href="#full-reload">' +
							 '\u8AAD\u8FBC\u4F4D\u7F6E<br>\u30EA\u30BB\u30C3\u30C8</a>')
						) + '</nobr>');
					Akahuku.isNormal && menuitems.push(
						'<nobr>[<a id="akahuku_throp_reload" href="#reload" onclick="">\u30ea\u30ed\u30fc\u30c9</a>]</nobr>');
					Akahuku.isNormal && menuitems.push(
						'<table id="akahuku_thread_list"></table>');

					if (Akahuku.isFloating() && Akahuku.numberFloatFormPosition == 2)
						menuitems = menuitems.reverse();

					div.innerHTML =
						'<table><tr><td>' +
						menuitems.join('</td></tr><tr><td>') +
						'</td></tr></table>';

					return div;
				})()
			];

			// create thread operator
			var div = $E($('akahuku_additional_elements'), 'div', {id:'akahuku_thread_operator'});

			if (Akahuku.isFloating() && Akahuku.numberFloatFormPosition == 2)
				contents = contents.reverse();

			for (var i = 0; i < contents.length; i++) 
				contents[i] && div.appendChild(contents[i]);

			// modify some parts of content according to current state of thread
			var element = $('akahuku_thumbnail_clipper');
			if (element) {
				var thumb = $('akahuku_thumbnail');
				$Event(element, 'click', this.handleThumbnailClipperClick.$bind(this));
				thumb && Akahuku.allowFloatThumbnail && 
					(thumb.complete ? $click(element) : $Event(thumb, 'load', function(){$click('akahuku_thumbnail_clipper');}));
			}

			// assign event handlers
			$Event($('akahuku_throp_menu_opener'), 'mouseover', this.handleMenuOpenerMouseover.$bind(this));
			$Event($('akahuku_throp_menu_container'), 'mouseout', this.handleMenuMouseout.$bind(this));
			$Event($('akahuku_throp_top'), 'click', (function(e){scrollTo(0,0);e.p();}).$bind(this));
			$Event($('akahuku_throp_bottom'), 'click', (function(e){scrollTo(0,windowScrollInfo.scrollHeight()-windowScrollInfo.clientHeight());e.p();}).$bind(this));
			$Event($('akahuku_throp_reload'), 'click', (function(e){scrollTo(0,0);location.replace(location.href);e.p();}).$bind(this));
			$Event($('akahuku_throp_bgreload_anchor'), 'click', this.handleReloaderAnchorClick.$bind(this));
			$Event($('akahuku_throp_bgfullreload_anchor'), 'click', this.handleFullReloaderAnchorClick.$bind(this));
		},
		updateReplyNumber: function (number, deleted) {
			var o = $('akahuku_throp_number');
			if (o) {
				o.innerHTML = number + '<small>\uFF9A\uFF7D</small>';
				deleted && (o.innerHTML += '<small><a class="akahuku_ddel" style="cursor:pointer">(-' + deleted + ')</a></small>');
			}
		},
		updateExpiration: function (expiration) {
			if (Akahuku.allowDispThreadInfoOnThrop && $('akahuku_throp_status'))
				$('akahuku_throp_status').innerHTML = '&nbsp;' + expiration.match(/\d+:\d+/)[0] + '<small>\u9803</small>';
		},
		updateWarning: function (warning) {
			if (Akahuku.allowDispThreadInfoOnThrop && $('akahuku_throp_number')) {
				$('akahuku_throp_number').parentNode.style.color = 'red';
				$('akahuku_throp_number').parentNode.style.fontWeight = 'bold';
			}
		},
		updateViewers: function (viewers) {
			if ($('akahuku_throp_viewers'))
				$('akahuku_throp_viewers').innerHTML = '&nbsp;' + viewers + '<small>\u4EBA</small>';
		},
		handleMenuMouseout: function (e) {
			if (!$P(
				Akahuku.getElementFromPoint(e.pageX, e.pageY),
				function (node) { return node.id == 'akahuku_throp_menu_container'; }))
				$('akahuku_throp_menu_container').style.display = 'none';

		},
		handleMenuOpenerMouseover: function (e) {
			$('akahuku_throp_menu_container').style.display = 'block';

			var threadList = $('akahuku_thread_list');
			threadList && threadList.rows.length == 0 && this.createThreadList(threadList);
		},
		handleThumbnailClipperClick: function (e) {
			var thumb = $('akahuku_thumbnail');
			if (!thumb) return;
			$('akahuku_throp_menu_container').style.display = 'none';
			if (e.t.checked) {
				var floatThumbnail = $('akahuku_throp_thumbnail_anchor');
				if (!floatThumbnail) {
					var anchor = $('akahuku_throp_thumbnail_container').appendChild(thumb.parentNode.cloneNode(false));
					anchor.id = 'akahuku_throp_thumbnail_anchor';

					var img = $E(anchor, 'img', {id:'akahuku_throp_thumbnail', src:thumb.src, style:{display:'none'}});
					img.onmouseover = this.handleFloatThumbnailMouseover.$bind(this);
					img.onmouseout = this.handleFloatThumbnailMouseout.$bind(this);

					this.popupManager.addPopup(
						'thumbnail',
						this.thumbnailPopup = new ThumbnailPopupClass(
							anchor, thumb.width, thumb.height, Akahuku.allowFloatThumbnailAlpha));

					$Event(window, 'scroll', this.handleWindowScroll.$bind(this));
				}

				this.floatThumbnailTimerID = null;
				this.handleFloatThumbnailTimer();
			}
			else 
				this.thumbnailPopup && this.thumbnailPopup.run(3);
		},
		handleFloatThumbnailMouseover: function (e) {
			if (!this.thumbnailPopup) return;
			$('akahuku_throp_menu_container').style.display = 'none';
			this.thumbnailPopup.run(5);
		},
		handleFloatThumbnailMouseout: function (e) {
			if (!this.thumbnailPopup) return;
			this.thumbnailPopup.run(7);
		},
		handleWindowScroll: function (e) {
			if (!this.floatThumbnailTimerID)
				this.floatThumbnailTimerID = setTimeout(this.handleFloatThumbnailTimer.bind(this), 1000);
		},
		handleFloatThumbnailTimer: function () {
			var thumbnail = $('akahuku_thumbnail'), floatThumbnail = $('akahuku_throp_thumbnail_anchor');
			if (thumbnail && floatThumbnail && this.thumbnailPopup) {
				if (Akahuku.getElementPosition(thumbnail).y + thumbnail.offsetHeight < windowScrollInfo.scrollTop()) 
					(this.thumbnailPopup.state == 0 || this.thumbnailPopup.state == 4) && 
						$('akahuku_thumbnail_clipper').checked && 
						this.thumbnailPopup.run(1);
				else 
					this.thumbnailPopup.state == 2 && 
						this.thumbnailPopup.run(3);
			}
			this.floatThumbnailTimerID = null;
		},
		handleReloaderAnchorClick: function (e) {
			e.p();
			Akahuku.fn.reload && Akahuku.fn.reload.loadNewReplies(false, true);
		},
		handleFullReloaderAnchorClick: function (e) {
			e.p();
			Akahuku.fn.reload && Akahuku.fn.reload.loadNewReplies(true, true);
		},
		handleThreadListMouseOver: function (e) {
			setTimeout(function () {
				var input = $N(e.t.__thread_no);
				input && input.length && input[0].scrollIntoView && input[0].scrollIntoView(true);
			}, 0);
		},
		createThreadList: function (threadList) {
			function createCell (thread, thumb, text) {
				var div = $E(threadList.insertRow(threadList.rows.length).insertCell(0), 'div');

				div.__thread_no = thread.name;
				$Event(div, 'mouseover', handler);
				thumb && $E(div, 'img', {src:thumb.src.replace('/thumb/', '/cat/')});
				$E(div, 'span', {innerHTML:'[' + (thread.__replies || '0') + ']'});
				text && $TX(div, (text.textContent || text.innerText).substring(0, 32).replace(/(.)/g, '\u200b$1'));
			}
			function x () {
				if (!Akahuku.cap.xpathEnabled) return false;

				var threads = Akahuku.xpath('descendant::form/input[@type="checkbox"][@value="delete"]', document.body);
				if (threads) {
					for (var i = 0; i < threads.snapshotLength && i < 10; i++) {
						var thread = threads.snapshotItem(i),
							thumb = $T('img', thread.previousSibling)[0],
							text = Akahuku.xpath('following-sibling::blockquote[1]', thread);

						createCell(thread, thumb, text && text.snapshotLength ? text.snapshotItem(0) : null);
					}
				}

				return true;
			}
			function s () {
				if (!Akahuku.cap.selectorEnabled) return false;

				var threads = document.querySelectorAll('#threadsbox > input[type="checkbox"][value="delete"]'),
					texts = document.querySelectorAll('#threadsbox > blockquote');
				if (threads) {
					for (var i = 0; i < threads.length && i < 10; i++) {
						var thread = threads[i],
							thumb = $T('img', thread.previousSibling)[0],
							text = texts[i];

						createCell(thread, thumb, text);
					}
				}

				return true;
			}

			var handler = this.handleThreadListMouseOver.$bind(this);
			s() || x();
		}
	});
}

/** AkahukuThreadWork: thread walker */
(Akahuku.isNormal || Akahuku.isReply) && Akahuku.add({
	signature: 'thread',
	initialize: function () {
		var style = new StyleWrapperClass();

		if (Akahuku.allowNumbering) {
			style.a('font.akahuku_replynumber', 'font-size:80%;margin:0 0 0 4px');
		}

		// fix opera 9.5 beta behavior (experimental) -
		//	 in the case of reply with floating image, TD width is determined by the length of the first line,
		//	 and blockquote width follows it.
		//	 * NOTE that applying float to blockquote might occur a strange influence on surrounding elements. *
		if (window.opera && opera._verMatch(9.5))
			style.a('td[bgcolor="#F0E0D6"] a[target="_blank"] + blockquote', 'float:left;margin:1em 1em 1em 0');

		/*
		if (Akahuku.cap.css2_1Compat)
			style.a('a.del', 'font-size:small;color:blue;text-decoration:underline;content:"\u3053\u308d\u3053\u308d"');
		*/

		style.apply();
	},
	start: function () {
		var getParent = function (node, parentName) {
			for (var result = node.parentNode; result && result.nodeName.toLowerCase() != parentName; result = result.parentNode);
			return result;
		},
		addStatus = function (node, replies, expire, warning) {
			if (!node) return;

			var table = $E(null, 'table', {'class':'akahuku_thread_bottom_container', style:{width:'100%'}}),
				tbody = $E(table, 'tbody'),
				tr = $E(tbody, 'tr'),
				divId = '', replyNumberId = '', expireId = '', warningId = '';

			switch (node.nodeName.toLowerCase()) {
			case 'blockquote':
			case 'font':
				// node references thread owner's last element (blockquote or special font element). it means no replies (in normal mode)
				node.parentNode.insertBefore(table, node.nextSibling);
				break;
			case 'input':
				// node references last reply's <input>.
				var parentTable = getParent(node, 'table');
				if (parentTable)
					parentTable.parentNode.insertBefore(table, parentTable.nextSibling);
				else {
					// no replies (in reply mode)
					var hrs = $T('hr', 'threadsbox');
					if (hrs.length > 0) {
						var last = hrs[hrs.length - 1];
						if (last.previousSibling && last.previousSibling.nodeName.toLowerCase() == 'br')
							last = last.previousSibling;
						last.parentNode.insertBefore(table, last);
					}
				}
				break;
			}

			if (!table.parentNode) return;

			var replyNumberId = '', expireId = '', warningId = '', viewersId = '';
			if (Akahuku.isReply) {
				table.id = 'akahuku_thread_bottom_container';
				divId = ' id="akahuku_thread_status_container"';
				replyNumberId = ' id="akahuku_reply_number"';
				expireId = ' id="akahuku_expire"';
				warningId = ' id="akahuku_warning"';
				viewersId = ' id="akahuku_viewers"';
			}
			if (!Akahuku.allowBottomStatus && !Akahuku.allowBackgroundReload)
				table.style.display = 'none';

			$E(tr, 'td', {
				innerHTML:'\u2026',
				style:{width:'1em', visibility:'hidden'}});

			$E(tr, 'td', {
				innerHTML:
					'<div' + divId + ' style="font-size:80%;display:' + (Akahuku.allowBottomStatus && replies ? 'block' : 'none') + '">' +
					'<span' + replyNumberId + '>' + replies + '\u30EC\u30B9</span>' +
					(Akahuku.isReply && $('viewers') ? ('<span' + viewersId + '>&nbsp;/&nbsp;' + $('viewers').innerText + '\u4EBA\u304F\u3089\u3044</span>') : '') +
					(expire != '' ? ('<span' + expireId + '>&nbsp;/&nbsp;' + Akahuku.getExpirationDate(expire) + '</span>') : '') +
					'<div' + warningId + ' style="color:#f00000;font-weight:bold;display:' + (warning != '' ? 'block' : 'none') + '">' + warning + '</div></div>',
				style:{backgroundColor:'transparent'}});

			Akahuku.updateReplyNumber();
		},
		doManualNumbering = function (node) {
			var p = node.parentNode, f;
			if (window.ActiveXObject)
				f = $C('<font class="akahuku_replynumber">');
			else {
				f = $C('font');
				f.className = 'akahuku_replynumber';
			}
			p.insertBefore(f, p.firstChild).innerHTML = replies;
			return true;
		},
		hideTextOnlyThread = function (node) {
			while (node) {
				if (node.nodeType == 1 && node.nodeName.toLowerCase() == 'hr') break;
				node = node.previousSibling ? node.previousSibling : node.parentNode;
			}

			node = node.nextSibling;

			if (Akahuku.allowHideTextOnlyThread)
				node.previousSibling.parentNode.removeChild(node.previousSibling);
			else 
				$E(node.parentNode, 'p', {
					innerHTML:
						'\u3053\u306E\u30B9\u30EC\u306F\u6587\u5B57\u30B9\u30EC\u306A\u306E\u3067\u975E\u8868\u793A\u306B\u306A\u3063\u3066\u3044\u307E\u3059.',
					style:{fontSize:'80%', color:'red', margin:'0', padding:'0'}}, node);

			if (node.nodeType == 1 && node.nodeName.toLowerCase() == 'form')
				node = node.firstChild;

			while (node) {
				if (node.nodeType == 1 && node.nodeName.toLowerCase() == 'hr') break;
				node = node.nextSibling;
				node.previousSibling.parentNode.removeChild(node.previousSibling);
			}
		},
		addBackAnchor = function () {
			var rules = $T('hr');
			rules.length > 0 && $E(rules[rules.length - 1].parentNode, 'div', {
				innerHTML:'[<a href="futaba.htm">\u63B2\u793A\u677F\u306B\u623B\u308B</a>]',
				style:{styleFloat:'left'}}, rules[rules.length - 1].nextSibling);
		},
		textOnlyThreads = [],
		nodes = $T('input', 'threadsbox'),
		manualNumberer = Akahuku.allowNumbering && Akahuku.isNormal ? doManualNumbering : function(){return Akahuku.isNormal},
		replies, expire, warning, re, node, currentInput;

		for (var i = 0; i < nodes.length; i++) {
			if (nodes[i].type.toLowerCase() != 'checkbox') continue;
			if (nodes[i].value != 'delete') continue;

			// skip all replies, but count the number
			if (nodes[i].parentNode.nodeName.toLowerCase() == 'td') {
				node = nodes[i];
				replies++;
				if (!manualNumberer(nodes[i])) break;
				continue;
			}

			// now we are in front of the first checkbox of the thread.
			// first, create status box of thread immediately before
			addStatus(node, replies, expire, warning);
			currentInput && (currentInput.__replies = replies);

			// then, initialize vars...
			node = null;
			replies = 0;
			expire = '';
			warning = '';
			currentInput = nodes[i];

			// assign id to image anchor, if exists.
			if (Akahuku.isReply) {
				currentInput.id = 'akahuku_thread_checkbox';

				if (currentInput.previousSibling && currentInput.previousSibling.nodeName.toLowerCase() == 'a') 
					currentInput.previousSibling.id = 'akahuku_thread_image_anchor';
			}

			// traverse from thread owner`s checkbox to the first reply
			for (var n = nodes[i].nextSibling; n; n = n.nextSibling) {
				var nodeName = n.nodeName.toLowerCase();

				// about the element that causes to break the loop,
				// use if-statement
				if (nodeName == 'hr')
					break;
				else if (nodeName == 'table') {
					Akahuku.updateReplyPrefix(n);
					break;
				}

				// remainder... find a special elements, and assign ID
				switch (nodeName) {
				case 'blockquote':
					node = n;
					n.setAttribute('name', 'akahuku_thread_text');
					if (Akahuku.isReply) 
						n.id = 'akahuku_thread_text';
					break;
				case 'font':
					if (Akahuku.isReply && n.color == '#cc1105' && n.firstChild && n.firstChild.nodeName.toLowerCase() == 'b') {
						n.id = 'akahuku_thread_subject';
					}
					else if (Akahuku.isReply && n.color == '#117743') {
						if (n.firstChild && n.firstChild.nodeName.toLowerCase() == 'b') 
							n.id = 'akahuku_thread_name';
					}
					else if (re = n.innerHTML.match(/\u30EC\u30B9(\d+)\u4EF6\u7701\u7565/)) {
						node = n;
						replies = parseInt(re[1]);
					}
					else if (re = n.innerHTML.match(/<b>(\u3053\u306E\u30B9\u30EC\u306F[^<]+)<\/b>/i)) {
						node = n;
						warning = re[1];
						if (Akahuku.isReply) {
							n.id = 'akahuku_thread_warning';
							Akahuku.updateWarning(re);
						}
					}
					break;
				case 'small':
					if (re = n.innerHTML.match(/((?:\d{2}\u6708)?(?:\d{2}\u65E5)?\d{2}:\d{2}\u9803\u6D88\u3048\u307E\u3059)/)) {
						node = n;
						expire = n.innerHTML;
						if (Akahuku.isReply) {
							n.id = 'akahuku_thread_deletetime';
							Akahuku.updateExpiration(re);
						}
						else
							n.innerHTML = Akahuku.getExpirationDate(re[1]);
					}
					break;
				case 'a':
					if (Akahuku.isReply && (re = n.href.match(/^mailto:/))) {
						n.id = 'akahuku_thread_email';
					}
					else if ((n.textContent || n.innerText) == '\u8FD4\u4FE1') {
						node = n;
						if (Akahuku.allowReplyNew) {
							n.innerHTML += '*';
							n.target = Akahuku.getWindowName(n.href);
						}
					}
					break;
				case '#text':
					if (Akahuku.isReply && (re = n.nodeValue.match(/^\s*\d+\/\d+\/\d+\(.\)\d+:\d+:\d+/))) {
						$E(n.parentNode, 'font', {id:'akahuku_thread_date', innerHTML:re[0]}, n);
						n.nodeValue = n.nodeValue.replace(/^\s*\d+\/\d+\/\d+\(.\)\d+:\d+:\d+/, '');
					}
					break;
				}
			}

			// store the text only thread, whether it deletes it's decided later
			if (!window.Aima_Aimani &&
				Akahuku.isNormal &&
				(!nodes[i].previousSibling || nodes[i].previousSibling.nodeName.toLowerCase() != 'a'))
				textOnlyThreads.push(nodes[i]);
		}

		// create last status box
		if (Akahuku.isNormal) 
			addStatus(node, replies, expire, warning);
		else {
			replies = $T('blockquote', 'threadsbox').length - 1;
			addStatus(Akahuku.getLastReply(false), replies, expire, warning);
		}

		currentInput && (currentInput.__replies = replies);

		// hide text only thread, if need
		if (Akahuku.allowMarkTextOnlyThread && textOnlyThreads.length > 0) {
			for (var i = 0; i < textOnlyThreads.length; i++)
				hideTextOnlyThread(textOnlyThreads[i]);

			if (Akahuku.allowHideTextOnlyThread) {
				var nodes = $T('hr');
				nodes.length > 0 && $E(nodes[nodes.length - 1].parentNode, 'p', {
					innerHTML:textOnlyThreads.length + ' \u500B\u306E\u6587\u5B57\u30B9\u30EC\u3092\u96A0\u3057\u307E\u3057\u305F',
					style:{fontSize:'80%', color:'red', margin:'0', padding:'0', textAlign:'right'}}, nodes[nodes.length - 1]);
			}
		}

		// create back anchor on bottom of page
		if (Akahuku.isReply && Akahuku.allowBackOnBottom)
			addBackAnchor();
	},
	updateExpiration: function (expiration) {
		if ($('akahuku_expire'))
			$('akahuku_expire').innerHTML = '&nbsp;/&nbsp;' + expiration;
		if ($('akahuku_thread_deletetime'))
			$('akahuku_thread_deletetime').innerHTML = expiration;
	},
	updateReplyNumber: function (number, deleted) {
		var o = $('akahuku_reply_number');
		if (o) {
			o.innerHTML = number + ' \u30EC\u30B9';
			deleted && (o.innerHTML += ' <small><a class="akahuku_ddel" style="cursor:pointer">(-' + deleted + ')</a></small>');
		}
	},
	updateWarning: function (warning) {
		if (!Akahuku.isReply) return;

		var tt = $('akahuku_thread_text'), w = $('akahuku_warning');

		if (!$('akahuku_thread_warning') && tt) {
			var font = $E(tt.parentNode, 'font', {
				id:'akahuku_thread_warning',
				innerHTML:warning,
				style:{fontWeight:'bold', color:'#f00000'}}, tt.nextSibling);

			$E(tt.parentNode, 'br', null, font.nextSibling);
		}
		if (Akahuku.allowBottomStatus && w) {
			w.style.display = 'block';
			w.innerHTML = warning;
		}
	},
	updateViewers: function (viewers) {
		if ($('akahuku_viewers'))
			$('akahuku_viewers').innerHTML = '&nbsp;/&nbsp;' + viewers + '\u4EBA\u304F\u3089\u3044';
	}
});

/** AkahukuReplyWork: replies enhancement */
if (Akahuku.isValidPage) {
	var MatchPatternClass;
	(MatchPatternClass = function (pattern, enabled, replacer) {
		this.pattern = pattern;
		this.enabled = enabled;
		this.getReplacement = replacer;
		this.matchPosition = 0;
		this.nextPosition = 0;
		this.parens = null;
	}).prototype = {
		match: function (atxt) {
			if (this.enabled && (this.parens = atxt.match(this.pattern))) {
				this.matchPosition = RegExp.leftContext.length;
				this.nextPosition = this.matchPosition + this.parens[0].length;
			}
			else
				this.matchPosition = this.nextPosition = 65536;
		}
	};
	Akahuku.add({
		signature: 'reply',
		lastScannedReplyIndex: 0,
		replyScanTimerID: null,
		replyScanTopNode: null,
		currentReplyNumber: 0,
		uniteInfoLoaded: false,
		patterns: [
			new MatchPatternClass(
				/(h?t?t?p?)(:\/\/[^.]+\.wikipedia\.org\/wiki\/)([^\s<]+)/,
				Akahuku.allowAutoLink,
				function (work, allowInlineImage) {
					try {
						var path = this.parens[3], fragment = '';
						if (path.indexOf('#') >= 0) {
							fragment = ' #' + decodeURIComponent(path.match(/#(.*)/)[1].replace(/\.([0-9A-F][0-9A-F])/g, '%$1'));
							path = path.replace(/#.*/, '');
						}

						return (path.indexOf('%') >= 0 ? '<small>(' + decodeURIComponent(path + fragment).$he() + ')</small> ' : '') +
							'<a href="http' + this.parens[2] +
							(/[^\u0020-\u007f]/.test(path) ? encodeURIComponent(this.parens[3]) : this.parens[3]) +
							'" target="_blank">' +
							this.parens[0] + '</a>';
					}
					catch (e) {
						return '<a href="http' + this.parens[2] + this.parens[3] + '" target="_blank">' +
							this.parens[1] + this.parens[2] + this.parens[3] + '</a>';
					}
				}),
			new MatchPatternClass(
				/(file|ftp|mms|rtsp|h?t?t?p?s?)(:\/\/[\/a-zA-Z0-9-._~\uFF5E%!$&'()*+,=:@]+(?:\?[!"$->@-~]*)?(?:#[!"$-~]*)?)/,
				Akahuku.allowAutoLink,
				function (work, allowInlineImage) {
					var m = '';
					m += /^(?:file|ftp|mms|rtsp)$/.test(this.parens[1]) ? this.parens[1] : 'http' + (/s$/.test(this.parens[1]) ? 's' : '');
					m += this.parens[2].replace(/\uFF5E/g, '~');

					if (/:\/\/star\.ap\.teacup\.com\/aniotajinku\//.test(m))
						return '';
					else if (m == location.href && Akahuku.isReply)
						return '<small>(\u3053\u306E\u30B9\u30EC)</small> ' + m;
					else if (m.match(/^http(:\/\/(?:www|images)\.google\.[^\/]+\/(?:search|images)\?)(.+)/)) {
						var $1 = RegExp.$1,
							$2 = RegExp.$2,
							re = $2.match(/q=([^&]+)/);
						try {
							var $3 = (re && !/ie=shift_jis/i.test($2) && !/ie=euc-jp/i.test($2)) ?
								'<small>(' + decodeURIComponent(re[1].replace(/\+/g, ' ')).$he() + ')</small> ' : '';
							return $3 + '<a href="' + m + '" target="_blank">' +
								this.parens[1] + $1 + $2 + '</a>';
						}
						catch (e) {
							return '<a href="' + m + '" target="_blank">' +
								this.parens[1] + $1 + $2 + '</a>';
						}
					}
					else if (allowInlineImage &&
							 (m.match(/^http(:\/\/(?:[^.]+\.)?youtube\.com\/watch\?)(.*?v=([^&#]+).*)/) ||
							 m.match(/^http(:\/\/www\.youtube\.com\/)(v\/(.+))/))) {
						var $1 = RegExp.$1,
							$2 = RegExp.$2,
							$3 = RegExp.$3;
						try {
							return '<a href="' + m + '" target="_blank">' +
								this.parens[1] + $1 + $2 + '</a>' +
								' <small>[<a href="#fetchYouTube" id="akahuku_uttag_' + $3 +'">\u306A\u3093\u306E\u52D5\u753B\uFF1F</a>]</small>';
						}
						catch (e) {
							return '<a href="' + m + '" target="_blank">' +
								this.parens[1] + $1 + $2 + '</a>';
						}
					}
					else if (allowInlineImage &&
							 m.match(/^http(:\/\/www\.nicovideo\.jp\/watch\/)(..\d+)/)) {
						var $1 = RegExp.$1,
							$2 = RegExp.$2;
						try {
							return '<a href="' + m + '" target="_blank">' +
								this.parens[1] + $1 + $2 + '</a>' +
								' <small>[<a href="#fetchNico2" id="akahuku_nicotag_' + $2 +'">\u306A\u3093\u306E\u52D5\u753B\uFF1F</a>]</small>';
						}
						catch (e) {
							return '<a href="' + m + '" target="_blank">' +
								this.parens[1] + $1 + $2 + '</a>';
						}
					}
					else
						return '<a href="' + m + '" target="' + Akahuku.getWindowName(m) + '">' +
							this.parens[1] + this.parens[2] + '</a>' +
							work.createInlineAnchor(m, allowInlineImage);
				}),
			new MatchPatternClass(
				/\b(f\d{4,}(\.[_a-zA-Z0-9]+)?)/,
				Akahuku.allowAutoLinkF,
				function (work, allowInlineImage) {
					var m = 'http://dec.2chan.net/up/';
					m += this.parens[2] ? 'src/' + this.parens[1] : 'up.htm';
					return '<a href="' + m + '" target="_blank">' + this.parens[1] + '</a>' +
						work.createInlineAnchor(m, allowInlineImage);
				}),
			new MatchPatternClass(
				/\b(fu\d{4,}(\.[_a-zA-Z0-9]+)?)/,
				Akahuku.allowAutoLinkF,
				function (work, allowInlineImage) {
					var m = 'http://dec.2chan.net/up2/';
					m += this.parens[2] ? 'src/' + this.parens[1] : 'up.htm';
					return '<a href="' + m + '" target="_blank">' + this.parens[1] + '</a>' +
						work.createInlineAnchor(m, allowInlineImage);
				}),
			new MatchPatternClass(
				/\b(s[apsuq]\d{4,}(\.[_a-zA-Z0-9]+)?)/,
				Akahuku.allowAutoLinkS,
				function (work, allowInlineImage) {
					var m = '';
					switch (this.parens[1].substring(0, 2)) {
					case 'sa': m = 'http://www.nijibox6.com/futabafiles/001/'; break;
					case 'sp': m = 'http://www.nijibox2.com/futabafiles/003/'; break;
					case 'ss': m = 'http://www.nijibox5.com/futabafiles/kobin/'; break;
					case 'su': m = 'http://www.nijibox5.com/futabafiles/tubu/'; break;
					case 'sq': m = 'http://www.nijibox6.com/futabafiles/mid/'; break;
					}
					m += this.parens[2] ? 'src/' + this.parens[1] : 'index.html';
					return '<a href="' + m + '" target="_blank">' + this.parens[1] + '</a>' +
						work.createInlineAnchor(m, allowInlineImage);
				}),
			new MatchPatternClass(
				/\b(dec|jun|nov|may|img|dat|cgi|nne|id|jik|nar|oth)(\d{4,})(\.mht)?/,
				Akahuku.allowAutoLinkFutalog,
				function (work, allowInlineImage) {
					var m = 'http://www.nijibox2.com/futalog/';
					switch (this.parens[1]) {
					case 'oth': m += 'other/'; break;
					default:	m += this.parens[1] + '/'; break;
					}
					m += 'src/' + this.parens[1] + this.parens[2] + (this.parens[3] || '.mht');
					return '<a href="' + m + '" target="_blank">' +
						this.parens[1] + this.parens[2] + (this.parens[3] ? this.parens[3] : '') +
						'</a>' +
						work.createInlineAnchor(m, allowInlineImage);
				})
			/*new MatchPatternClass(
				/([^a-z0-9_]|^)(@([a-z0-9_]+))/i,
				Akahuku.allowAutoLink,
				function (work, allowInlineImage) {
					var m = 'http://twitter.com/' + this.parens[3];
					return this.parens[1] + '<a href="' + m + '" target="_blank">' + this.parens[2] + '</a>';
				}),*/
			/* add your pattern */
		],
		mowWork: {
			regex1: /[w\uFF57]+/,
			regex2: /(^|>)([^<]+)/g,
			regex3: /([wW\uFF57\uFF37]{4,}|[\uFF57\uFF37]{2,}|[w\uFF57]{2,}[\s\u3000]*$)|([\u0100-\uffff])([w\uFF57][w\uFF57]{2,})/g,
			replacement: Akahuku.stringVipperReplacement.$he()
		},
		initialize: function () {
			if (!Akahuku.isNormal && !Akahuku.isReply) return;

			var style = new StyleWrapperClass();
			style.a('a.akahuku_inline_image_anchor:visited', 'color:#eeaa88');

			var s = [];
			s.push('margin-top:1em;margin-bottom:1em;line-height:1.25');
			Akahuku.allowLimitReplyWidth && s.push(window.ActiveXObject ? 'word-break:break-all' : 'overflow:hidden');
			Akahuku.allowCuteFont && s.push('font-family:"\u3075\u3044\u5B57\uFF30","\u3053\u3068\u308A\u3075\u3049\u3093\u3068","\u3042\u304F\u3042\u30D5\u30A9\u30F3\u30C8"');
			s.length && style.a('blockquote', s.join(';'));

			var s = [];
			Akahuku.allowSorrowVipper && s.push('font-size:90%');
			Akahuku.allowSorrowVipper && Akahuku.allowMarkVipper && s.push('color:red');
			s.length && style.a('font.vipper', s.join(';'));

			Akahuku.allowShowMail &&
				style.a('font.akahuku_shown_mail',
					'margin-left:0.3em;margin-right:0.3em;color:blue;white-space:normal');
			Akahuku.isReply && Akahuku.allowDecoratePopupPointer &&
				style.a('font.akahuku_quote_pointer', 'text-decoration:underline');
			Akahuku.isReply &&
				style.a('a.akahuku_quote_anchor', 'color:#800000;cursor:pointer');

			if (Akahuku.allowQuickImage) {
				if (Akahuku.cap.css2_1Compat)
					style.a('#akahuku_quickimage',
							'position:fixed;width:100%;height:100%;text-align:right;left:0;top:0')
						.a('#akahuku_quickimage_i',
							'position:fixed;width:90%;height:90%;left:5%;top:5%;overflow:hidden;border:1px solid gray;text-align:center')
				else
					style.a('#akahuku_quickimage',
							'position:absolute;text-align:right' +
							';left:0' +
							';top:expression(eval(document.documentElement.scrollTop-0))' +
							';width:expression(eval(document.documentElement.clientWidth-0))' +
							';height:expression(eval(document.documentElement.clientHeight-0))')
						.a('#akahuku_quickimage_i',
							'position:absolute;overflow:hidden;border:1px solid silver' +
							';left:32px' +
							';top:expression(eval(document.documentElement.scrollTop-0+32))' +
							';width:expression(eval(document.documentElement.clientWidth-64))' +
							';height:expression(eval(document.documentElement.clientHeight-64))');
			}

			style.apply();
		},
		start: function () {
			this.mowWork.mowerPattern = this.createMower(this.mowWork.regex2, this.mowWork.regex3, this.mowWork.replacement);
			this.showMailPattern = this.createMailOpener();

			if (!Akahuku.isNormal && !Akahuku.isReply) return;

			Akahuku.allowShowMail && this.showMail($('threadsbox'));

			$Event(document.body, 'mouseover', this.handleBodyMouseover.$bind(this));

			this.startReplyScan();
		},
		mow: function (target) {
			if (!target) return;

			var nodes = $T('blockquote', target);
			if (nodes.length == 0) 
				nodes = [target];

			var length = nodes.length,
				innerHTML,
				regex1 = this.mowWork.regex1,
				f = this.mowWork.mowerPattern;

			for (var i = 0; i < length; i++) 
				if (regex1.test(innerHTML = nodes[i].innerHTML)) 
					nodes[i].innerHTML = f(innerHTML);
		},
		showMail: function (target) {
			if (!target) return;

			var p2pnodeRegex = /^mailto:=(?:PRXS|AKA)\/.*=$/, 
				nodes = Akahuku.xpath('descendant::a[starts-with(@href,"mailto:")]', target || document), 
				length, n, current;

			if (nodes) 
				length = nodes.snapshotLength;
			else {
				var tmp = $T('a', target);
				nodes = [];
				for (var i = 0; i < tmp.length; i++) 
					if (tmp[i].href.indexOf('mailto:') == 0) nodes.push(tmp[i]);
				length = nodes.length;
				nodes.snapshotItem = function(index){return this[index]};
				tmp = null;
			}

			for (var i = 0; i < length; i++) {
				current = nodes.snapshotItem(i);

				if (current.href.indexOf('netabare') >= 0) continue;
				if (p2pnodeRegex.test(current.href)) continue;

				n = current.parentNode.insertBefore($C('font'), current);
				n.innerHTML = current.innerHTML;

				n = current.parentNode.insertBefore($C('font'), current);
				n.className = 'akahuku_shown_mail';
				n.innerHTML = '[' + 
					this.showMailPattern(current) + 
					'\u202c]';

				current.parentNode.removeChild(current);
			}

		},
		startReplyScan: function (lastReply) {
			if (!this.replyScanTimerID) {
				this.replyScanTopNode = lastReply;
				this.handleReplyScanTimer();
				this.replyScanTimerID = setInterval(
					this.handleReplyScanTimer.bind(this), 
					Akahuku.cap.jsJitEnabled ? 150 : 500);
			}
		},
		handleReplyScanTimer: function () {
			var index = 0, bqs = $T('blockquote', 'threadsbox');

			while (index < 10 && this.lastScannedReplyIndex + index < bqs.length) {
				var bq = bqs[this.lastScannedReplyIndex + index];

				/* fix for html restructuring on may (2010.2) */
				bq.removeAttribute('style');
				/* fix for html restructuring on may (2010.2) */

				if (bq.getAttribute('name') == 'akahuku_thread_text' || bq.name == 'akahuku_thread_text') {
					this.handleBodyMouseover({t:bq});
					this.currentReplyNumber = 0;
				}
				else {
					$P(bq, 'td', [this, function (node) {
						if (Akahuku.isReply && Akahuku.allowNumbering) {
							var f = $C('font');
							f.className = 'akahuku_replynumber';
							node.insertBefore(f, node.firstChild).innerHTML = ++this.currentReplyNumber;
						}

						this.handleBodyMouseover({t:node});
					}]);
				}
				index++;
			}

			this.lastScannedReplyIndex += index;

			if (this.lastScannedReplyIndex >= bqs.length) {
				clearInterval(this.replyScanTimerID);
				this.replyScanTimerID = null;

				if ($('akahuku_scanner_status')) 
					$('akahuku_scanner_status').innerHTML = '';
				if (Akahuku.isReply && Akahuku.allowUseUniteCache && !this.uniteInfoLoaded) {
					this.uniteInfoLoaded = true;
					Akahuku.uniteHelper.getInfo();
				}
				/*
				if (window.chrome && Akahuku.cap.xpathEnabled) {
					var tables = this.replyScanTopNode ?
						Akahuku.xpath('following-sibling::table[@border="0"]', this.replyScanTopNode) :
						Akahuku.xpath('child::table[@border="0"]', $('threadsbox'));

					if (tables) {
						var a = [];
						for (var i = 0, goal = tables.snapshotLength; i < goal; i++) {
							a.push(tables.snapshotItem(i).outerHTML);
						}

						console.log(a.join('\n'));
					}
					else {
						console.log('tables node is null?');
					}

				}
				*/
				this.replyScanTopNode = null;
			}
			else {
				if ($('akahuku_scanner_status')) 
					$('akahuku_scanner_status').innerHTML = ' ' + (this.lastScannedReplyIndex / bqs.length * 100).toFixed(1) + '<small>%<\/small>';
			}
		},
		autoLink: function (target) {
			if (!target) return;
			var lines, updated, linkresult,
				nodes = $T('blockquote', target),
				wholeCheckerRegex = /:\/\/|[a-z]+\d+|\.(?:jpg|png|gif)|@/i,
				unlinkerRegex = /<a[^>]*>(?:[^<]+)<\/a>/gi,
				quoteCheckerRegex = /^\s*&gt;/i,
				splitterRegex = /<[^>]+>|[^<]*/gi;

			if (nodes.length == 0)
				nodes = [target];

			for (var i = nodes.length - 1; i >= 0; i--) {
				if (!wholeCheckerRegex.test(nodes[i].innerHTML)) continue;
				lines = nodes[i].innerHTML.replace(unlinkerRegex, '$1').match(splitterRegex);
				updated = false;
				for (var j = 0; j < lines.length; j++) {
					if (lines[j].substring(0, 1) == '<') continue;
					linkresult = this.getAutolinkedHTML(lines[j], !quoteCheckerRegex.test(lines[j]));
					if (linkresult.updated) {
						updated = true;
						lines[j] = linkresult.result;
					}
				}
				if (updated) 
					nodes[i].innerHTML = lines.join('');
			}
		},
		markQuotePointer: function (target) {
			if (!target) return;
			var re = target.innerHTML.match(/<a.*?<\/a>|<[^>]+>|[^<]*/ig),
				marked = false;
			for (var i = 0; i < re.length; i++) {
				if (re[i].substring(0, 1) != '<')
					re[i] = re[i].replace(/\d+/g, function () {
						if (parseInt(arguments[0]) >= Akahuku.threadNumber) {
							marked = true;
							return '<font class="akahuku_quote_pointer">' + arguments[0] + '</font>';
						}
						else
							return arguments[0];
					});
			}
			if (marked)
				target.innerHTML = re.join('');
		},
		markQuoteAnchor: function (target, reverse) {
			if (!target) return;
			for (var i = 0, m = null, o = reverse ? target.previousSibling : target.firstChild;
				o && i++ < 10;
				o = reverse ? o.previousSibling : o.nextSibling) {
				if (o.nodeType == 3 && (m = /(No\.\d+)(.*)/.exec(o.nodeValue))) {
					m && m[2] && $TX(o.parentNode, m[2], o.nextSibling);
					$E(o.parentNode, 'a', {'class':'akahuku_quote_anchor', innerHTML:m[1]}, o.nextSibling);
					o.nodeValue = o.nodeValue.replace(/No\.\d+.*/, '');
					break;
				}
			}
		},
		completeNijibox: function (anchor) {
			if (!/\/index\.html$/.test(anchor.href)) return;

			var id = anchor.textContent || anchor.innerText, key = id, jsonpId = 'jsonp_' + $T('script').length;
			anchor.id = 'akahuku_cntag_' + key;
			anchor.innerHTML += '<small>[\u62e1\u5f35\u5b50\u306e\u88dc\u5b8c\u4e2d...]</small>';
			net.jsonp(
				anchor.href.replace(/\/index\.html$/, '/jsonp/' + jsonpId + '_receiver/' + key + '/complete/' + id),
				{id:jsonpId, loaded:(function (obj) {
					var anchor = $('akahuku_cntag_' + obj.id);
					if (!anchor) return;

					anchor.removeAttribute('id');
					switch (obj.error) {
					case '':
						anchor.href = obj.url;
						anchor.innerHTML = /\/([^\/]+)$/.exec(obj.url)[1];

						var a = this.createInlineAnchor(obj.url, Akahuku.allowInlineImage);
						if (a != '') $TX(anchor.parentNode, ' ', $E(anchor.parentNode, 'small', {innerHTML:/<small>(.+)<\/small>/.exec(a)[1]}, anchor.nextSibling));
						break;
					case '404':
						var small = $T('small', anchor)[0];
						if (small) small.innerHTML = '(\u88dc\u5b8c\u5931\u6557)';
						break;
					default:
						var small = $T('small', anchor)[0];
						if (small) small.innerHTML = '(\u306a\u306b\u304b\u30a8\u30e9\u30fc)';
						break;
					}
				}).bind(this)});
		},
		createVideoInfo: function (type, key, url, title, desc, thumb, sec) {
			var anchor = $('akahuku_' + type + 'tag_' + key);
			if (!anchor) return;

			var elm = anchor.parentNode;
			if (!elm || !elm.parentNode) return;

			if (title) {
				switch (type) {
				case 'ut':
					title = '<a href="http://www.youtube.com/watch?v=' + key + '" target=_blank>' + title.$he() + '</a>' +
						'<br><a href="http://www.youtube.com/watch?v=' + key + '&fmt=18" target=_blank>[fmt 18]</a>' +
						' <a href="http://www.youtube.com/watch?v=' + key + '&fmt=22" target=_blank>[fmt 22]</a>';
					break;
				case 'nico':
					title = '<a href="' + url.$he() + '" target=_blank>' + title.$he() + '</a>';
					break;
				}
			}

			if (desc)
				desc = desc.$he();

			if (thumb)
				thumb = '<a href="' + url.$he() + '" target=_blank>' +
					'<img align=left style="border:none;margin:0 4px 0 0" src="' + thumb.$he() + '"></a>';

			var min = 0, len = '';
			if (/:/.test(sec)) 
				len = sec;
			else {
				if (sec > 60) {
					min = parseInt(sec / 60); 
					sec = sec % 60;
				}
				len = ('0' + min).substr(-2) + ':' + ('0' + sec).substr(-2);
			}

			elm.nextSibling && /^br$/i.test(elm.nextSibling.nodeName) && elm.nextSibling.parentNode.removeChild(elm.nextSibling);
			$E(elm.parentNode, 'div', {
				className:'akahuku_videinfo_container',
				style:{width:'95%', height:'110px', backgroundColor:'white', color:'black', padding:'2px',
					fontFamily:'"Arial"', border:'2px solid silver', 'overflow':'scroll'},
				innerHTML:thumb + '<small><b>' + title + '<br>' + len + '</b><br>' + desc + '</small>'}, elm);
			elm.parentNode.removeChild(elm);
		},
		fetchUT: function (anchor, key) {
			anchor.innerHTML = '\u30ED\u30FC\u30C9\u4E2D...';
			if (window.opera && Akahuku.allowUseUniteCache)
				net.jsonp(Akahuku.getUnitePrefix('$youtube'), {data:{q:key}, noImageHack:true, loaded:function (o) {
					Akahuku.fn.reply.createVideoInfo('ut', o.key, o.url, o.title, o.desc, o.thumb, o.sec);
				}});
			else if (window.chrome) 
				net.get('akahuku://youtube/' + key, {loaded:function (o) {
					Akahuku.fn.reply.createVideoInfo('ut', o.key, o.url, o.title, o.desc, o.thumb, o.sec);
				}});
			else 
				net.jsonp('http://gdata.youtube.com/feeds/api/videos/' + key, {charset:'UTF-8', data:{alt:'json-in-script'}, loaded:function (o) {
					var url, title, desc, thumb, sec;
					try {url =   'http://www.youtube.com/watch?v=' + key;   } catch (e) {url = ''}
					try {title = o.entry.media$group.media$title.$t;        } catch (e) {title = ''}
					try {thumb = o.entry.media$group.media$thumbnail[0].url;} catch (e) {thumb = ''}
					try {sec =   o.entry.media$group.yt$duration.seconds;   } catch (e) {sec = 0}
					try {desc =  o.entry.media$group.media$description.$t;  } catch (e) {desc = '?'}
					Akahuku.fn.reply.createVideoInfo('ut', key, url, title, desc, thumb, sec);
				}});
		},
		fetchNico2: function (anchor, key) {
			anchor.innerHTML = '\u30ED\u30FC\u30C9\u4E2D...';
			if (window.opera && Akahuku.allowUseUniteCache)
				net.jsonp(Akahuku.getUnitePrefix('$nico2'), {data:{q:key}, noImageHack:true, loaded:function (o) {
					Akahuku.fn.reply.createVideoInfo('nico', o.key, o.url, o.title, o.desc, o.thumb, o.sec);
				}});
			else if (window.chrome)
				net.get('akahuku://nico2/' + key, {loaded:function (o) {
					Akahuku.fn.reply.createVideoInfo('nico', o.key, o.url, o.title, o.desc, o.thumb, o.sec);
				}});
			else 
				net.jsonp(Akahuku.apiURL('api/utprox.php'), {charset:'UTF-8', data:{video_id:key, jsonp:1, type:'nico2'}, loaded:function (o) {
					var re,
						url =   (re = /<watch_url>(.+?)<\/watch_url>/i.exec(o.result)) ? re[1] : '#',
						title = (re = /<title>(.*?)<\/title>/i.exec(o.result)) ? re[1] : '?',
						desc =  (re = /<description>((.|[\r\n])*?)<\/description>/i.exec(o.result)) ? re[1] : '?',
						thumb = (re = /<thumbnail_url>(.*?)<\/thumbnail_url>/i.exec(o.result)) ? re[1] : '',
						sec =   (re = /<length>(.+?)<\/length>/i.exec(o.result)) ? parseInt(re[1]) : '?';
					Akahuku.fn.reply.createVideoInfo('nico', o.key, url, title, desc, thumb, sec);
				}});
		},
		doInlineImage: function (anchor) {
			if (!anchor || !anchor.href) return false;

			var sentinel = null;

			if ($P(anchor, function (node, name) { 
				return name == 'font' && node.className == 'akahuku_shown_mail';})) {
				for (var tmp = anchor.parentNode.parentNode.nextSibling;
					tmp && tmp.nodeName.toLowerCase() != 'blockquote';
					tmp = tmp.nextSibling) {/*empty statement*/}

				sentinel = tmp ? tmp.firstChild : null;
			}
			else {
				for (var tmp = anchor.parentNode;
					tmp && tmp.nodeName.toLowerCase() != 'br';
					sentinel = tmp, tmp = tmp.previousSibling) {/*empty statement*/}
			}

			if (!sentinel) return false;

			var inlineBox = null;
			if (sentinel.nodeName.toLowerCase() == 'div' && sentinel.className == 'akahuku_inline_image_box')
				inlineBox = sentinel;
			else {
				inlineBox = $E(sentinel.parentNode, 'div', {'class':'akahuku_inline_image_box'}, sentinel);

				$E(inlineBox.parentNode, 'div', {
					style:{clear:'both', height:'1px', marginBottom:'4px', overflow:'hidden'}}, inlineBox.nextSibling);
			}

			for (var i = 0; i < inlineBox.childNodes.length; i++) {
				if (inlineBox.childNodes[i].nodeName.toLowerCase() == 'a' &&
					inlineBox.childNodes[i].href == anchor.href) {
					anchor.parentNode.parentNode.removeChild(anchor.parentNode);
					return true;
				}
			}

			var thumbAnchor = $E(inlineBox, 'a', {
				href:'#', 
				innerHTML:
					'<div style="background-color:#800000;color:#ffffff;font-size:10pt">' +
					'<img style="vertical-align:top;border:none" src="' + Akahuku.getResource('loading') + '">' +
					' \u8aad\u307f\u8fbc\u307f\u4e2d...</div>', 
				style:{display:'block', width:'250px', height:'16px', overflow:'hidden'}});
			var img = $E(thumbAnchor, 'img', {
				title:anchor.href, 
				style:{margin:'0 4px 0 0', border:'none'}});

			img.onload = function () { 
				var size = (function getThumbnailSize (orgWidth, orgHeight, thumbWidth, thumbHeight) {
					if (orgWidth > 0 && orgHeight > 0) {
						var ratio = Math.min(thumbWidth / orgWidth, thumbHeight / orgHeight);
						return {
							width:ratio < 1.0 ? Math.floor(orgWidth * ratio) : orgWidth,
							height:ratio < 1.0 ? Math.floor(orgHeight * ratio) : orgHeight};
					}
					else 
						return {width: 0, height: 0};
				})(this.width, this.height, 250, 250);

				this.style.width = size.width + 'px';
				this.style.height = size.height + 'px';
				this.alt = this.src; 

				thumbAnchor.innerHTML = '';
				thumbAnchor.appendChild(this);
				thumbAnchor.href = anchor.title;
				thumbAnchor.style.display = 'inline';

				this.onload = this.onerror = emptyfunc;
			};
			img.onerror = function () { 
				thumbAnchor.innerHTML = this.alt = '\u8aad\u307f\u8fbc\u307f\u5931\u6557';
				this.onload = this.onerror = emptyfunc;
			};
			img.title = anchor.title;
			img.src = Akahuku.getLocalProxiedUrl(anchor.href);// + '?tick=' + new Date().getTime();

			anchor.parentNode.parentNode.removeChild(anchor.parentNode);

			return true;
		},
		getAutolinkedHTML: function (txt, allowInlineImage) {
			var updated = false, pieces = [], patterns = this.patterns;

			for (var i = 0; i < patterns.length; i++)
				patterns[i].match(txt);

			while (true) {
				var nearestIndex = 0;
				for (var i = 1; i < patterns.length; i++)
					if (patterns[i].matchPosition < patterns[nearestIndex].matchPosition)
						nearestIndex = i;

				if (patterns[nearestIndex].matchPosition == 65536) {
					pieces.push(txt);
					break;
				}
				else {
					updated = true;
					pieces.push(txt.substring(0, patterns[nearestIndex].matchPosition));
					pieces.push(patterns[nearestIndex].getReplacement(this, allowInlineImage));

					var nextPosition = patterns[nearestIndex].nextPosition;
					txt = txt.substring(nextPosition);
					for (var i = 0; i < patterns.length; i++)
						if (patterns[i].matchPosition < 65536) {
							patterns[i].matchPosition -= nextPosition;
							patterns[i].nextPosition -= nextPosition;
							if (patterns[i].matchPosition < 0)
								patterns[i].match(txt);
						}
				}
			}

			return {
				updated: updated,
				result: pieces.join('')
			};
		},
		getMowedHTML: function (txt) {
			return this.mowWork.mowerPattern(txt);
		},
		createInlineAnchor: function (url, allowInlineImage) {
			var imageInfo = Akahuku.isRelationalImage(url);

			return Akahuku.allowInlineImage && allowInlineImage && imageInfo ?
				' <small>[<a class="akahuku_inline_image_anchor"' +
				' href="' + imageInfo[0] + '"' +
				' title="' + url + '"' +
				'>\u898B\u308B</a>]</small>' : '';
		},
		createMower: function (regex2, regex3, replacement) {
			var r1 = null;
			switch (Akahuku.numberVipperMode) {
			case 1: // hide lawn
				r1 = function () {
					return arguments[2] ? 
						arguments[2] : ''; 
				};
				break;
			case 2: // replace lawn
				r1 = function () {
					return arguments[2] ?
						arguments[2] + '<font class=vipper>' + replacement + '</font>' : '<font class=vipper>' + replacement + '</font>';
				};
				break;
			default: // really mow a lawn
				r1 = function () {
					return arguments[2] ?
						arguments[2] + '<font class=vipper>..........</font>' : '<font class=vipper>..........</font>';
				};
				break;
			}

			var r2 = function(){return arguments[1] + arguments[2].replace(regex3, r1)};
			return function(s){return s.replace(regex2, r2)};
		},
		createMailOpener: function () {
			var f = null, code = 0;
			if (Akahuku.allowAutoLink || Akahuku.allowAutoLinkF ||
				Akahuku.allowAutoLinkS || Akahuku.allowAutoLinkFutalog) code |= 2;
			if (Akahuku.allowSorrowVipper) code |= 1;

			switch (code) {
			case 0: // no autolink, no mow
				f = function (anchor) {
					return unescape(anchor.getAttribute('href')).substring(7).$he(); /* '7' means length of 'mailto:' */
				};
				break;
			case 1:	// no autolink, but mow a lawn
				f = function (anchor) {
					return this.getMowedHTML(unescape(anchor.getAttribute('href')).substring(7).$he());
				};
				break;
			case 2:	// autolink, no mow
				f = function (anchor) {
					return this.getAutolinkedHTML(
						unescape(anchor.getAttribute('href')).substring(7).$he(), 
						Akahuku.allowInlineImage).result;
				};
				break;
			case 3:	// autolink, mow
				f = function (anchor) {
					return this.getAutolinkedHTML(
						this.getMowedHTML(unescape(anchor.getAttribute('href')).substring(7).$he()),
						Akahuku.allowInlineImage).result;
				};
				break;
			}
			return f;
		},
		handleBodyMouseover: function (e) {
			e && e.t && $P(e.t, 'form', [this, function (form) {
				if (form.id != 'threadsbox') return;

				var nodeName = e.t.nodeName.toLowerCase();
				var name = e.t.getAttribute('name') || e.t.name;
				var className = e.t.getAttribute('class') || e.t.className;
				var reparsed = (e.t.getAttribute('__reparsed') || e.t.__reparsed) - 0;

				if (nodeName == 'td' && $T('input', e.t).length && $T('blockquote', e.t).length && !reparsed) {
					Akahuku.allowSorrowVipper && this.mow(e.t);
					Akahuku.allowAutoLink && this.autoLink(e.t);
					Akahuku.isReply && Akahuku.allowPopupQuote && this.markQuotePointer($T('blockquote', e.t)[0]);
					Akahuku.isReply && this.markQuoteAnchor(e.t);

					reparsed = true;
				}
				else if (nodeName == 'blockquote' && name == 'akahuku_thread_text' && !reparsed) {
					Akahuku.allowSorrowVipper && this.mow(e.t);
					Akahuku.allowAutoLink && this.autoLink(e.t);
					Akahuku.isReply && Akahuku.allowPopupQuote && this.markQuotePointer(e.t);
					Akahuku.isReply && this.markQuoteAnchor(e.t, true);

					reparsed = true;
				}
				else if (nodeName == 'font' && className == 'akahuku_shown_mail' && !reparsed) {
					Akahuku.isReply && this.markQuotePointer(e.t);

					reparsed = true;
				}
				else if (nodeName == 'a' && Akahuku.allowAutoLinkS &&
					/^s[apusq]\d{4,}$/.test(e.t.textContent || e.t.innerText)) {
					this.completeNijibox(e.t);
				}
				else if (nodeName == 'a' && window.chrome && className == 'del' && typeof e.t.onclick == 'function') {
					var no = /del\((\d+)\)/.exec(e.t.onclick);
					if (no) {
						e.t.onclick = null;
						e.t.setAttribute('__delno', no[1]);
					}
				}

				if (reparsed) {
					if (nodeName == 'td') {
						e.t.setAttribute('__reparsed', '1');
					}
					else {
						var flagged = false;

						$P(e.t, 'td', [this, function (td) {
							td.setAttribute('__reparsed', '1');
							flagged = true;
						}]);

						!flagged && e.t.setAttribute('__reparsed', '1');
					}
				}
			}]);
		},

		quickImageState: 0,
		quickImageRequest: null,
		quickImage: null,
		quickImageScrollInfo: null,
		quickImageOrigSize: null,
		quickImageFadeTimer: null,
		quickImageFadeValue: 1,
		setQuickImageMessage: function (message, eraseImage) {
			var o = $('akahuku_quickimage_status');
			if (o) {
				o.innerHTML = message;
				Akahuku.ensureRender();
			}
			if (eraseImage && (o = $('akahuku_quickimage_status_image'))) 
				o.style.visibility = 'hidden';
		},
		displayQuickImage: function (arg) {
			var result = false;

			switch (this.quickImageState) {
			case 0:
				var anchor = arg;
				if (anchor && anchor.href && anchor.className != 'akahuku_inline_image_anchor') {
					var pane = $E(document.body, 'div', {
						id:'akahuku_quickimage',
						innerHTML:
							'<div style="background-color:#800000;color:white;font-size:80%;padding:2px;float:right">' +
							'<font id=akahuku_quickimage_status style="margin-left:16px"></font>' +
							'<img id=akahuku_quickimage_status_image src="' + Akahuku.getResource('loading') + '">' +
							'</div>'});
					pane.onclick = this.handlePaneClick.$bind(this);
					Akahuku.setOpacity(pane, 0.9);

					var src = '';
					if (/\.htm$/i.test(anchor.href)) {
						$('akahuku_quickimage_status').innerHTML = 'Loading Image Redirector...';
						this.quickImageState = 1;

						/* Opera 9 does mysterious operation.
						 * when redirector html is loaded, Opera 9 treats it as xml in the cache.
						 * of course, because the redirector is not xml, Opera 9 fails in the parsing and rendering.
						 * therefore, we'll add query parameter to URL to prevent Opera from reusing cache.
						 * note that it's a dis-adventage in the point to the server load.
						 */
						this.quickImageRequest = net.get(
							anchor.href, {mimeType: 'text/html', finished: this.handleQuickImageRequestFinished.bind(this) });
					}
					else {
						this.quickImageState = 1;
						this.displayQuickImage(anchor.href);
					}
					result = true;
				}
				break;
			case 1:
				var src = arg;

				this.quickImageState = 2;
				this.setQuickImageMessage('Loading Image: "' + src + '"...');

				var innerPane = $E(document.body, 'div', {id:'akahuku_quickimage_i'});
				if (Akahuku.cap.css2_1Compat)
					innerPane.style.borderColor = 'transparent';

				this.quickImage = $E(innerPane, 'img');
				//var coralPostfix = '.nyud.net:8080';
				this.quickImage.onload = this.handleQuickImageLoaded.$bind(this);
				this.quickImage.onerror = this.handleQuickImageLoadFailed.$bind(this);
				this.quickImage.style.cursor = 'pointer';
				this.quickImage.style.background = Akahuku.getResource('gridbg');
				this.quickImage.style.display = 'none';
				this.quickImage.alt = src;
				this.quickImage.src = Akahuku.getLocalProxiedUrl(src);
				//this.quickImage.src = src.match(/^http/) ?
				//	src.replace(/^http:\/\/[^\/]+/, '$&' + coralPostfix) :
				//	('http://' + location.host + coralPostfix + '/' + Akahuku.directoryName + '/' + src);

				$E(innerPane, 'div', {style:{width:'2000px'}});
				setTimeout((function(){
					if (this.quickImage) this.quickImage.style.display = 'inline';
				}).bind(this), 3000);

				result = true;
				break;
			case 2:
				this.quickImageState = 3;

				var pane = $('akahuku_quickimage'), innerPane = $('akahuku_quickimage_i');
				innerPane.style.textAlign = 'left';
				this.quickImage.nextSibling && innerPane.removeChild(this.quickImage.nextSibling);
				this.fadeQuickImageScreen();

				this.quickImage.style.display = 'inline';
				this.quickImageOrigSize = {width:this.quickImage.width, height:this.quickImage.height};
				this.quickImageScrollInfo = null;
				this.quickImage.onmousedown = this.handleQuickImageMousedown.$bind(this);
				this.quickImage.onmousemove = this.handleQuickImageMousemove.$bind(this);
				this.quickImage.onmouseup = this.handleQuickImageMouseup.$bind(this);
				this.quickImage.onmousewheel = this.handleQuickImageMousewheel.$bind(this);

				this.setQuickImageMessage(
					(this.updateQuickImagePlacement() ?
						'[<a id="akahuku_quickimage_resize_anchor" href="#resize" style="color:yellow" unselectable="on">\u30b5\u30a4\u30ba\u5207\u308a\u66ff\u3048</a>]' : '') +
					' <a id="akahuku_original_image_anchor" href="' + this.quickImage.src + '" style="color:yellow" target=_blank>' + this.quickImage.alt + '</a>' +
					', ' + this.quickImageOrigSize.width + 'x' + this.quickImageOrigSize.height,
					true);
				result = true;
				break;
			case 3:
				if (this.quickImageRequest) {
					this.quickImageRequest.abort();
				}
				this.quickImageRequest = null;

				if (this.quickImage)
					this.quickImage.onload = this.quickImage.onerror = this.quickImage.onmousedown =
					this.quickImage.onmousemove = this.quickImage.onmouseup = this.quickImage.onclick =
					this.quickImage.onmousewheel = emptyfunc;
				this.quickImage = null;

				var pane = $('akahuku_quickimage');
				if (pane) {
					while (pane.firstChild) pane.removeChild(pane.firstChild);
					pane.parentNode.removeChild(pane);
				}

				var innerPane = $('akahuku_quickimage_i');
				if (innerPane) {
					while (innerPane.firstChild) innerPane.removeChild(innerPane.firstChild);
					innerPane.parentNode.removeChild(innerPane);
				}

				this.quickImageState = 0;
				Akahuku.ensureRender();
				result = true;
				break;
			}
			return result;
		},
		updateQuickImagePlacement: function () {
			var innerPane = $('akahuku_quickimage_i'), needScroll = 0;

			if (innerPane.offsetWidth > this.quickImage.width) {
				this.quickImage.style.marginLeft = parseInt((innerPane.offsetWidth - this.quickImage.width) / 2) + 'px';
				innerPane.scrollLeft = 0;
			}
			else {
				this.quickImage.style.marginLeft = '0';
				innerPane.scrollLeft = parseInt(this.quickImage.width / 2 - innerPane.offsetWidth / 2);
				needScroll |= 1;
			}
			if (innerPane.offsetHeight > this.quickImage.height) {
				this.quickImage.style.marginTop = parseInt((innerPane.offsetHeight - this.quickImage.height) / 2) + 'px';
				innerPane.scrollTop = 0;
			}
			else {
				this.quickImage.style.marginTop = '0';
				innerPane.scrollTop = 0;
				needScroll |= 2;
			}
			this.quickImage.style.cursor = ['pointer', 'w-resize', 'n-resize', 'move'][needScroll];

			return needScroll;
		},
		fadeQuickImageScreen: function () {
			var pane = $('akahuku_quickimage');
			Akahuku.setOpacity(pane, 0);
			pane.style.backgroundColor = 'black';

			if (Akahuku.allowUIAnimation) {
				if (this.quickImageFadeTimer) {
					clearInterval(this.quickImageFadeTimer);
					this.quickImageFadeTimer = null;
				}

				this.quickImageFadeValue = 0;
				this.quickImageFadeTimer = setInterval((function () {
					this.quickImageFadeValue += 0.2;
					if (this.quickImageFadeValue >= 0.75) {
						this.quickImageFadeValue = 0.75;
						clearInterval(this.quickImageFadeTimer);
						this.quickImageFadeTimer = null;
						$('akahuku_quickimage_i').style.border = '1px solid gray';
					}

					Akahuku.setOpacity($('akahuku_quickimage'), this.quickImageFadeValue);

				}).bind(this), 50);
			}
			else {
				Akahuku.setOpacity(pane, 0.75);
				$('akahuku_quickimage_i').style.border = '1px solid gray';
			}
		},
		handleQuickImageRequestFinished: function (o) {
			var message = '';
			switch (o.status) {
			case 200:
				var content = o.responseText.replace(/[\r\n]/g, ''), re;
				if ((re = content.match(/URL=(http:\/\/.*?\.(?:gif|jpg|png))/i)) ||
					(re = content.match(/URL=.*?\/(src\/.*?\.(?:gif|jpg|png))/i))) {
					this.displayQuickImage(re[1]);
					return;
				}
				else if (content.match(/<script[^>]*>(.+?)<\/script/i)) {
					var orgScript = RegExp.$1, componentDeclaration, buildStatement;

					if (re = orgScript.match(/[a-z_][a-z0-9_]*\s*=\s*(:?'[^']*'|"[^"]*")/ig)) {
						componentDeclaration = 'var ' + re.join(',') + ';';
					}
					if (re = orgScript.match(/window\s*\.\s*open\s*\(\s*(.+?)\s*,\s*['"]_self['"]/i)) {
						buildStatement = re[1];
					}
					if (componentDeclaration && buildStatement) {
						this.displayQuickImage((new Function (componentDeclaration + '; return ' + buildStatement))());
						return;
					}
				}
				message = '\u30D5\u30A1\u30A4\u30EB\u5F62\u5F0F\u304C\u4E0D\u660E\u3067\u3059\u3002';
				break;
			case 404:
				message = '\u30D5\u30A1\u30A4\u30EB\u304C\u306A\u3044\u3088\u3002';
				break;
			}

			this.quickImageState = 3;
			this.displayQuickImage();
			alert(message != '' ? message: '\u30D5\u30A1\u30A4\u30EB\u304C\u306A\u3044\uFF08\u304B\u3082\uFF1F\uFF09');
		},
		handleQuickImageLoaded: function (e) {
			if (this.quickImageState == 2) {
				this.displayQuickImage();
			}
		},
		handleQuickImageLoadFailed: function (e) {
			if (this.quickImageState == 2) {
				var src = this.quickImage.src;
				this.quickImageState = 3;
				this.displayQuickImage();
				alert(
					'\u753B\u50CF\u3092\u8AAD\u307F\u8FBC\u3081\u307E\u305B\u3093:\n' + src +
					'\n*\u5869\u8F9B\u3084\u3075\u305F\u30ED\u30B0\u3067\u306F' +
					'\u77ED\u6642\u9593\u306B\u4F55\u5EA6\u3082\u30A2\u30AF' +
					'\u30BB\u30B9\u3059\u308B\u3068\u30D6\u30ED\u30C3\u30AF' +
					'\u3055\u308C\u307E\u3059\u300230\u79D2\u5F85\u3064\u3079' +
					'\u3057*'
				);
			}
		},
		handleQuickImageMousedown: function (e) {
			e.s();
			if (!this.quickImageScrollInfo) {
				var innerPane = $('akahuku_quickimage_i'),
					needScroll = this.quickImage.width > innerPane.offsetWidth || this.quickImage.height > innerPane.offsetHeight;
				(needScroll || window.opera) && e.p();
				this.quickImageScrollInfo = {
					pageX: e.pageX,
					pageY: e.pageY,
					scrollLeft: innerPane.scrollLeft,
					scrollTop: innerPane.scrollTop,
					tick: 0,
					moved: false,
					needScroll: needScroll
				};
			}
		},
		handleQuickImageMousemove: function (e) {
			var o = this.quickImageScrollInfo;
			if (!o || !o.needScroll) return;
			e.p();
			if (new Date().getTime() - o.tick > 50) {
				var innerPane = $('akahuku_quickimage_i');
				if (innerPane.firstChild.width > innerPane.offsetWidth) {
					var x = o.scrollLeft - (e.pageX - o.pageX);
					if (x < 0) x = 0;
					else if (x > innerPane.firstChild.width - innerPane.offsetWidth) x = innerPane.firstChild.width - innerPane.offsetWidth;
					innerPane.scrollLeft = x;
				}
				if (innerPane.firstChild.height > innerPane.offsetHeight) {
					var y = o.scrollTop - (e.pageY - o.pageY);
					if (y < 0) y = 0;
					else if (y > innerPane.firstChild.height - innerPane.offsetHeight) y = innerPane.firstChild.height - innerPane.offsetHeight;
					innerPane.scrollTop = y;
				}
				o.moved = true;
				o.tick = new Date().getTime();
			}
		},
		handleQuickImageMouseup: function (e) {
			var o = this.quickImageScrollInfo;
			if (e.leftPress && o && o.pageX == e.pageX && o.pageY == e.pageY && !o.moved) {
				this.quickImageState = 3;
				this.displayQuickImage();
			}
			else
				this.quickImageScrollInfo = null;
		},
		handleQuickImageMousewheel: function (e) {
			e.p();
			e.s();
			var innerPane = $('akahuku_quickimage_i');
			if (innerPane.firstChild.height > innerPane.offsetHeight) {
				var y = innerPane.scrollTop - (Akahuku.allowInvertWheelDirection ? -e.wheelDelta : e.wheelDelta);
				if (y < 0) y = 0;
				else if (y > innerPane.firstChild.height - innerPane.offsetHeight) y = innerPane.firstChild.height - innerPane.offsetHeight;
				innerPane.scrollTop = y;
			}
		},
		handlePaneClick: function (e) {
			if (e.t.id == "akahuku_quickimage_resize_anchor") {
				e.p();

				var qi = this.quickImage, origSize = this.quickImageOrigSize;
				if (qi.width == origSize.width && qi.height == origSize.height) {
					var innerPane = $('akahuku_quickimage_i');
						ratio = Math.min(
						innerPane.offsetWidth / origSize.width,
						innerPane.offsetHeight / origSize.height);
					qi.width = parseInt(origSize.width * ratio);
					qi.height = parseInt(origSize.height * ratio);
					this.updateQuickImagePlacement();
				}
				else {
					qi.width = origSize.width;
					qi.height = origSize.height;
					this.updateQuickImagePlacement();
				}
				Akahuku.ensureRender();
			}
			else if (e.t.nodeName.toLowerCase() != 'a') {
				e.p();
				this.quickImageState = 3;
				this.displayQuickImage();
			}
		}
	});
}

/** AkahukuPopupQuotationWork: quoted reply popup */
Akahuku.isReply && Akahuku.allowPopupQuote && Akahuku.add({
	timerID: null,
	popups: [],
	pageX: -1, pageY: -1,
	signature: 'popupQuotation',
	initialize: function () {
		(new StyleWrapperClass())
			.a('div.akahuku_reply_popup',
				'position:absolute;border:1px solid #eeaa88;padding:2px;background-color:#ffffee')
			.a('div.akahuku_reply_popup th',
				'font-size:80%;font-weight:normal;vertical-align:top')
			.a('div.akahuku_reply_popup td.akahuku_reply_popup_td',
				'font-size:80%;background-color:#F0E0D6;padding:2px;text-align:left;white-space:nowrap')
			.a('div.akahuku_reply_popup td.akahuku_reply_popup_td2',
				'font-size:80%;padding:2px;text-align:left;white-space:nowrap')
			.a('div.akahuku_reply_popup blockquote',
				'margin:0.75em;white-space:normal')
			.a('div.akahuku_reply_popup img',
				'float:left;border:none;vertical-align:top;margin:0.75em 10px 0.75em 20px')
			.a('div.akahuku_reply_popup .akahuku_inline_image',
				'float:left;border:none;vertical-align:top;margin:0.75em 10px 0.75em 20px')
			.a('div.akahuku_reply_popup .akahuku_popup_target',
				'font-weight:bold')
			.apply();
	},
	start: function () {
		$Event(document.body, 'mousemove', this.handleMouseMove.$bind(this));
	},
	removePopup: function (sentinelTd) {
		var a = this.popups;
		while (a.length > 0 && $T('td', a[a.length - 1])[0] != sentinelTd) {
			var p = a.pop();
			p && p.parentNode && p.parentNode.removeChild(p);
		}
	},
	handleMouseMove: function (e) {
		if (this.pageX == e.pageX && this.pageY == e.pageY)
			return;

		this.pageX = e.pageX;
		this.pageY = e.pageY;

		if (!this.timerID) {
			this.timerID = setTimeout(
				this.handlePopupWaitTimeout.bind(this),
				parseInt(1000 * 0.3));
		}
	},
	handleAnchorClick: function (e) {
		try {
			var id = e.href.match(/#(_\d+)/)[1], target = $(id);
			if (target) {
				target.style.backgroundColor = 'Highlight';
				target.style.color = 'HighlightText';

				var y = Akahuku.getElementPosition(target).y - 64;

				y < windowScrollInfo.scrollTop() && scrollTo(0, Math.max(0, y));
				this.removePopup();

				setTimeout(function() {
					var target = $(id);
					if (target) {
						target.style.backgroundColor = 'transparent';
						target.style.color = '';
					}
				},
				2000);
			}
		}
		finally {
			return false;
		}
	},
	getParent: function (element, tagName, className) {
		for (; element; element = element.parentNode) {
			if (element.nodeType != 1) continue;

			if (className && element.nodeName.toLowerCase() == tagName && element.className == className) break;
			if (!className && element.nodeName.toLowerCase() == tagName) break;
		}
		return element;
	},
	getQuoteFont: function (element) {
		var result = this.getParent(element, 'font');
		return (result && (/^#?789922$/.test(result.color) || result.className == 'akahuku_quote_pointer')) ? result : null;
	},
	getThreadOwnersHTML: function (element) {
		var result = '';
		while (element) {
			if (element.nodeType == 1 &&
				element.nodeName.toLowerCase() == 'input' &&
				element.type == 'checkbox')
				break;

			if (element.outerHTML)
				result = element.outerHTML + result;
			else if (element.nodeValue)
				result = element.nodeValue + result;
			element = element.previousSibling;
		}
		return result;
	},
	getPopupContent: function (html) {
		return html
			.replace(/<small[^>]*>(\[<a[^>]*>[^<]*<\/a>\])?(\d+:\d+\u9803\u6D88\u3048\u307E\u3059)?<\/small>/ig, '')
			.replace(/<br\/?>( |&nbsp;|\u00a0)+<a/ig, '<br><a')
			.replace(/(<img[^>]*>)/ig,
				function () {
					if (Akahuku.allowImageInPopupQuote)
						return arguments[0]
							.replace(/(width|height)=[\'"]?(\d+)[\'"]?/ig, function(){return arguments[1] + '=' + parseInt(arguments[2] / 4)})
							.replace(/[vh]space=[\'"]?\d+[\'"]?/ig, '');
					else
						return '';
				})
			.replace(/<font[^>]*>\d+<\/font>/i, '')
			.replace(/<input[^>]*>/i, '');
	},
	getQuoteOriginal: function (quoted, sentinelBlockQuote, sentinelTableData, singleLine) {
		var re;

		if (quoted.__quote_original &&
			(re = quoted.__quote_original.match(/^(_\d+)\|(\d+)$/))) {
			return [re[2], $(re[1])];
		}
		else if (re = quoted.innerText.match(/^(\d+)$/)) {
			var quotedNo = re[1], replyIndex = 0, nodes = $T('input', 'threadsbox');
			for (var i = 0; i < nodes.length; i++) {
				if (nodes[i].type.toLowerCase() != 'checkbox') continue;
				if (nodes[i].value != 'delete') continue;

				var t = '', bq = null;
				for (var node = nodes[i].nextSibling; node; node = node.nextSibling) {
					if (node.nodeType == 1 && /^(?:hr|table)$/i.test(node.nodeName))
						break;
					if (node.nodeType == 1 && node.nodeName.toLowerCase() == 'blockquote') {
						bq = node;
						break;
					}
					t += node.innerText || node.nodeValue || '';
				}
				if (bq && bq.innerHTML == sentinelBlockQuote.innerHTML)
					return null;

				if (t.indexOf(quotedNo) >= 0 && bq)
					return [replyIndex, bq];

				replyIndex++;
			}
		}
		else {
			var quotedText = quoted.innerText.replace(/[\s\u3000]*$/, ''),
				quotedTexts = sentinelBlockQuote.innerText.split('\n');
			for (var i = 0; i < quotedTexts.length; i++)
				if (quotedTexts[i].replace(/[\s\u3000]*$/, '') == quotedText) {
					for (var j = i - 1, goal = singleLine ? i : 0; j >= goal && /^(>|&gt;)/.test(quotedTexts[j]); j--)
						quotedText = quotedTexts[j] + '\n' + quotedText;

					quotedText = quotedText.replace(/^(>|&gt;)/, '').replace(/\n(>|&gt;)/g, '\n');

					var nodes = $T('blockquote', 'threadsbox');
					for (var j = 0; j < nodes.length && nodes[j].innerHTML != sentinelBlockQuote.innerHTML; j++)
						if (nodes[j].innerText.indexOf(quotedText) >= 0)
							return [j, nodes[j]];
				}
		}
		return null;
	},
	handlePopupWaitTimeout: function () {
		this.timerID = null;

		var element = Akahuku.getElementFromPoint(this.pageX, this.pageY),
			q = this.getQuoteFont(element),
			td = this.getParent(q, 'td'),
			bq = td ? $T('blockquote', td)[0] : null;

		if (q && bq && td && Akahuku.getSelection().length == 0) {
			for (var i = 0; i < 2; i++) {
				var quoteOriginal = this.getQuoteOriginal(q, bq, td, i == 1);
				if (quoteOriginal) {
					this.removePopup(
						/^akahuku_reply_popup_td2?$/.test(td.className) ? td : null);

					var td = this.getParent(quoteOriginal[1], 'td'),
						div = $E(null, 'div', {'class':'akahuku_reply_popup'});

					if (Akahuku.fn.reply)
						Akahuku.fn.reply.handleBodyMouseover({target:td});

					if (quoteOriginal[0] > 0) {
						var no = td.innerHTML.match(/No\.(\d+)/i) || ['', '0'];
						div.innerHTML =
							'<table><tbody><tr><th>\u2026</th>' +
							'<td class="akahuku_reply_popup_td">' +
							'<a class="akahuku_popup_target" href="' + location.href + '#_' + no[1] + '">' + quoteOriginal[0] + '</a> ' +
							this.getPopupContent(td.innerHTML) +
							'</td></tr></tbody></table>';
					}
					else
						div.innerHTML =
							'<table><tbody><tr>' +
							'<td class="akahuku_reply_popup_td2">' +
							this.getPopupContent(this.getThreadOwnersHTML(quoteOriginal[1])) +
							'</td></tr></tbody></table>';

					div.style.left = (this.pageX + 8) + 'px';
					div.style.top = (this.pageY + 8) + 'px';

					quoteOriginal[1].id = '_' + div.innerHTML.match(/No\.(\d+)/)[1];
					q.__quote_original = quoteOriginal[1].id + '|' + quoteOriginal[0];
					this.popups.push(div);
					$('threadsbox').appendChild(div);
					return;
				}
			}
		}

		var elementParent;
		if (element && (elementParent = this.getParent(element.parentNode, 'div', 'akahuku_reply_popup'))) {
			this.removePopup($T('td', elementParent)[0]);
			return;
		}

		this.removePopup();
	}
});

/** AkahukuQuickQuoteWork: quick quote */
(Akahuku.isNormal || Akahuku.isReply) && Akahuku.allowQuickQuote && Akahuku.add({
	selection: '',
	editableElementClicked: false,
	signature: 'quickQuote',
	initialize: function () {
		(new StyleWrapperClass())
			.a('#akahuku_quotebox',
				'position:absolute;' +
				'width:auto;' +
				'border:1px solid #800000;' +
				'background-color:#ffffee;' +
				'z-index:2')
			.a('#akahuku_quotebox a',
				'display:block;padding:4px 8px 4px 16px;white-space:nowrap')
			.a('#akahuku_quotebox a:hover',
				'background-color:#f0e0d6;color:#800000;')
			.a('#akahuku_quotebox div.rule',
				'border:none;' +
				'border-top:1px solid silver;' +
				'height:2px;' +
				'margin:2px 0 0 0;padding:0;overflow:hidden')
			.apply();
	},
	start: function () {
		var createQuoteMenuItem = function (aid, content) {
			for (var i = 0; i < arguments.length; i += 2) {
				var result = $E(quotebox, 'a', {
					id:arguments[i],
					innerHTML:arguments[i + 1],
					href:'#' + aid});
				result.onclick = self.handleMenuItemClick.$bind(self);
			}
		},
		createRule = function () {
			$E(quotebox, 'div', {'class':'rule'});
		},
		self = this,
		quotebox = $E($('akahuku_additional_elements'), 'div', {id:'akahuku_quotebox', style:{display:'none'}});

		createQuoteMenuItem(
			'akahuku_quote_akahuku', '\u5F15\u7528',
			'akahuku_quote_ohuku_mail', '\u30E1\u30FC\u30EB\u6B04\u3078',
			'akahuku_quote_ohuku', '\u30B3\u30E1\u30F3\u30C8\u3078');

		if (window.ActiveXObject) {
			createRule();
			createQuoteMenuItem(
				'akahuku_quote_selection_copy', '\u30B3\u30D4\u30FC',
				'akahuku_quote_selection_quote_copy', '\u5F15\u7528\u7B26\u3064\u304D\u30B3\u30D4\u30FC');
		}

		if (!Akahuku.isFloating()) {
			createRule();
			createQuoteMenuItem(
				'akahuku_quote_akahuku_nofocus', '\u5F15\u7528 - \u9023\u7D9A',
				'akahuku_quote_ohuku_mail_nofocus', '\u30E1\u30FC\u30EB\u6B04\u3078 - \u9023\u7D9A',
				'akahuku_quote_ohuku_nofocus', '\u30B3\u30E1\u30F3\u30C8\u3078 - \u9023\u7D9A');
		}

		createRule();
		createQuoteMenuItem(
			'akahuku_quote_google', '\u3050\u3050\u308B',
			'akahuku_quote_google_image', '\u30A4\u30E1\u3050\u3050\u308B',
			'akahuku_quote_amazon', '\u30A2\u30DE\u30BE\u308B',
			'akahuku_quote_wikipedia', '\u30A6\u30A3\u30AD\u30DA\u30C9\u308B',
			'akahuku_quote_youtube', '\u3088\u3046\u3064\u3079\u308b');

		createRule();
		createQuoteMenuItem(
			'akahuku_quote_cancel', '\u3084\u3081\u3066');

		$Event(document.body, 'mousedown', this.handleBodyMousedown.$bind(this));
		$Event(document.body, 'mouseup', this.handleBodyMouseup.$bind(this));
	},
	handleBodyMousedown: function (e) {
		var element = Akahuku.getElementFromPoint(e.pageX, e.pageY);
		this.editableElementClicked = Akahuku.isTextInput(element);
	},
	handleBodyMouseup: function (e) {
		if (this.editableElementClicked) return;

		var element = Akahuku.getElementFromPoint(e.pageX, e.pageY);
		if (element) {
			if (Akahuku.isTextInput(element)) return;
			if (!$P(element, function (node) { return node.id == 'threadsbox'; })) return;
		}

		var quotebox = $('akahuku_quotebox');
		if (e.leftPress && quotebox.style.display == 'none') {
			var s = Akahuku.getSelection();

			if (s != '') {
				this.selection = s;
				quotebox.style.display = 'block';
				quotebox.style.left = Math.max(0, Math.min(
					e.pageX + 2, 
					windowScrollInfo.scrollLeft() + windowScrollInfo.clientWidth() - quotebox.offsetWidth)) + 'px';
				quotebox.style.top = Math.max(0, Math.min(
					e.pageY + 2, 
					windowScrollInfo.scrollTop() + windowScrollInfo.clientHeight() - quotebox.offsetHeight)) + 'px';
			}
		}
		else
			$('akahuku_quotebox').style.display = 'none';
	},
	handleMenuItemClick: function (e) {
		var go = function (href) {
			if (Akahuku.allowReportRefererOnQuickQuote) {
				e.t.href = href;
				e.t.target = '_blank';
				needPrevent = false;
			}
			else 
				Akahuku.doLink($E(null, 'a', {href:href, target:'_blank', innerHTML:href}));
		};
		var s = this.selection,
			needPrevent = true;

		switch (e.t.id) {
		case 'akahuku_quote_akahuku':
			Akahuku.doQuote(s, true, true);
			break;
		case 'akahuku_quote_ohuku':
			Akahuku.doQuote(s, false, true);
			break;
		case 'akahuku_quote_akahuku_nofocus':
			Akahuku.doQuote(s, true, false);
			break;
		case 'akahuku_quote_ohuku_nofocus':
			Akahuku.doQuote(s, false, false);
			break;
		case 'akahuku_quote_ohuku_mail':
			Akahuku.doQuoteToMailBox(s, true);
			break;
		case 'akahuku_quote_ohuku_mail_nofocus':
			Akahuku.doQuoteToMailBox(s, false);
			break;
		case 'akahuku_quote_selection_copy':
			Akahuku.doCopyToClipboard(s);
			break;
		case 'akahuku_quote_selection_quote_copy':
			Akahuku.doCopyToClipboard('>' + s.replace(/(\r?\n)/g, '$1>'));
			break;
		case 'akahuku_quote_google':
			go('http://www.google.com/search?hl=ja&q=' + encodeURIComponent(s).replace(/%20/g, '+'));
			break;
		case 'akahuku_quote_google_image':
			go('http://www.google.com/images?hl=ja&q=' + encodeURIComponent(s).replace(/%20/g, '+'));
			break;
		case 'akahuku_quote_amazon':
			var f = $E(document.body, 'form', {action:'/amascan.php', method:'POST', target:'_blank', style:{display:'none'}}),
				p = $E(f, 'input', {type:'text', name:'p', value:s});
			f.submit();
			f.parentNode.removeChild(f);
			//go('http://www.amazon.co.jp/exec/obidos/external-search?mode=blended&field-keywords=' + encodeURIComponent(s).replace(/%20/g, '+'));
			break;
		case 'akahuku_quote_wikipedia':
			go('http://ja.wikipedia.org/wiki/%E7%89%B9%E5%88%A5:Search?search=' + encodeURIComponent(s).replace(/%20/g, '+') + '&go=%E8%A1%A8%E7%A4%BA');
			break;
		case 'akahuku_quote_youtube':
			go('http://www.youtube.com/results?search_query=' + encodeURIComponent(s).replace(/%20/g, '+') + '&search=Search');
		}
		needPrevent && e.p();
		$('akahuku_quotebox').style.display = 'none';
	}
});

/** AkahukuReloadWork: differential reloader */
Akahuku.isReply && Akahuku.allowBackgroundReload && Akahuku.add({
	nextPosition: 0,
	replying: false,
	totalLoadedBytesVirtual: 0,
	totalLoadedBytesReal: 0,
	loadCount: 0,
	reloadRequest: null,
	replying: false,
	silent: false,
	reloadCount: 0,
	setStatus: Akahuku.createStatusIndicator('akahuku_reloader_status', 'akahuku_throp_bgreload_status'),

	signature: 'reload',
	start: function () {
		$E($T('td', 'akahuku_thread_bottom_container')[1], 'div', {
			innerHTML:
				'<a id="akahuku_reloader_anchor" style="font-weight:bold" href="#reload" accesskey="r" title="\u7D9A\u304D\u3092\u8AAD\u3080 (R)">' +
				'\u7D9A\u304D\u3092\u8AAD\u3080</a>' +
				(Akahuku.cap.messagingEnabled && Akahuku.allowIframeReload || !Akahuku.allowUseRangeHeader ?  '' :
					('<a id="akahuku_fullreloader_anchor" style="font-size:80%;margin-left:1em" href="#full-reload">' +
					 '\u8AAD\u307F\u8FBC\u307F\u4F4D\u7F6E\u3092\u30EA\u30BB\u30C3\u30C8</a>')) +
				'&nbsp;<font id="akahuku_reloader_status" style="font-size:80%"></font>',
			style:{margin:'8px 0 16px 0'}});

		$Event('akahuku_reloader_anchor', 'click', this.handleReload.$bind(this));
		$Event('akahuku_fullreloader_anchor', 'click', this.handleFullreload.$bind(this));

		if (Akahuku.allowBackgroundPostReply && Akahuku.fn.postForm)
			Akahuku.fn.postForm.submitHooks.unshift(this.handlePostFormSubmit.bind(this));
	},
	createPostTargetIframe: function (form, onloadHandler) {
		var result = '',
			frameKey = 'akahuku_reply_target_frame',
			attributes = {
			name:frameKey, id:frameKey,
			width:16, height:16, frameBorder:0, scrolling:'no',
			style:{display:'block', position:'absolute', left:0, top:0}};

		if (window.ActiveXObject) {
			result = $E(null, 'iframe', attributes);
			result.attachEvent('onload', onloadHandler);
		}
		else {
			form.target = frameKey;
			attributes.src = 'data:text/html,<html><head><title>!</title></head><body>?</body></html>'; 
			result = $E(null, 'iframe', attributes);
			result.addEventListener('load', onloadHandler, false);
		}
		return result;
	},
	createTable: function (response) {
		var re = /<table\s+border=['"]?0['"]?[^>]*>(?:<tbody>)?<tr><td[^>]*>([^<]+)<\/td><td[^>]+bgcolor=([^ >]+)>/i.exec(response),
			table = $C('table'),
			tr = table.appendChild($C('tbody')).appendChild($C('tr')),
			td = tr.appendChild($C('td'));

		table.border = '0';

		// lead cell
		td.noWrap = 'nowrap';
		td.align = 'right';
		td.vAlign = 'top';
		td.innerHTML = re ? re[1] : '\u8230';

		// reply cell
		td = tr.appendChild($C('td'));
		td.bgColor = re && re[2] ? re[2].replace(/^["']|["']$/g, '') : '#F0E0D6';

		return table;
	},
	getStrippedResponse: function (response) {
		return response
			.replace(/<!DOCTYPE[^>]*>\n/ig, '')
			.replace(/<script[^>]*>(document\.write)?.*?(<\/script>)/ig, '');
	},
	getShiftJISOffset: function (response, charOffset) {
		return response.substring(0, charOffset).replace(/[^\u0001-\u007f\uff61-\uff9f]/g, '__').length;
	},
	getNextPosition: function (response) {
		response = this.getStrippedResponse(response);
		var index = response.lastIndexOf('<td bgcolor=#F0E0D6>');
		return index >= 0 ? this.getShiftJISOffset(response, index) : 0;
	},
	handleReload: function (e) {
		e.p();
		this.loadNewReplies();
	},
	handleFullreload: function (e) {
		e.p();
		this.loadNewReplies(true);
	},
	loadNewReplies: function (full, silent) {
		if (this.replying || !$('akahuku_thread_bottom_container')) return;
		if (window.opera) (this.loadCount = (this.loadCount + 1) & 7) == 0 && opera.collect();
		if (this.reloadRequest) {
			this.reloadRequest.abort();
			this.reloadRequest = null;
			this.setStatus('\u4E2D\u65AD\u3055\u308C\u307E\u3057\u305F');
			return;
		}
		if (full) this.nextPosition = 0;
		this.silent = silent;
		if (Akahuku.cap.messagingEnabled && Akahuku.allowIframeReload) {
			this.reloadRequest = net.bogoGet(
				location.href,
				{prepare:(function () {
					this.setStatus('\u30ED\u30FC\u30C9\u4E2D...', true);
				 }).bind(this),
				 loaded:(function (result) {
					this.handleReloadRequestFinished({
						readyState: 4,
						status: /<TITLE>404 File Not Found<\/TITLE>/i.test(result) ? 404 : 200,
						headers: [],
						getResponseHeader: function (header) {
							for (var i = 0; i < this.headers.length; i++) {
								if (this.headers[i].indexOf(header) == 0)
									return this.headers[i].substring(header.length).replace(/^:\s*/, '');
							}
							return '';
						},
						responseText: result
					});
				 }).bind(this)});
		}
		else {
			this.reloadRequest = net.get(
				location.href,
				{mimeType:'text/plain;charset=Shift_JIS', noCache:true, 
				 step:(function (state) {this.setStatus('\u30ED\u30FC\u30C9\u4E2D(' + state + ')...', true);}).bind(this),
				 finished:this.handleReloadRequestFinished.bind(this)});
		}
	},
	handleReloadRequestFinished: function (o) {
		switch (o.status) {
		case 200:
		case 206:
			var lastReply = Akahuku.getLastReply(true);
			var newReplies = this.appendNewReplies(o.responseText, lastReply);
			var newDeletes = this.applyDeletedReplies(o.responseText, lastReply);
			var contentRange = o.getResponseHeader('Content-Range');

			contentRange = contentRange ? contentRange.match(/(\d+)-(\d+)\/(\d+)/) : null;

			if (window.ddrefl) 
				ddrefl();
			if (contentRange) {
				this.totalLoadedBytesVirtual += parseInt(re[3]);
				this.totalLoadedBytesReal += (re[2] - re[1] + 1);
			}
			if (newReplies > 0 || this.nextPosition == 0) {
				var loadRate = 100;

				if (Akahuku.allowUseRangeHeader) {
					this.nextPosition += this.getNextPosition(o.responseText);

					var headerStatus = $('akahuku_new_reply_header_status');
					if (contentRange && headerStatus) {
						loadRate = ((re[2] - re[1] + 1) / re[3] * 100).toFixed(2);
						headerStatus.innerHTML = '\uFF08' + (loadRate == 100 ? 'full reload' : loadRate + '%') + '\uFF09';
						if (this.totalLoadedBytesVirtual > 0) {
							headerStatus.title =
								'Total ' +
								(this.totalLoadedBytesReal / 1024).toFixed(2) + '\/' +
								(this.totalLoadedBytesVirtual / 1024).toFixed(2) + 'KB' +
								'\uFF08' + (this.totalLoadedBytesReal / this.totalLoadedBytesVirtual * 100).toFixed(2) + '%\uFF09';
						}
					}
				}
				if ($('akahuku_new_reply_header_number'))
					$('akahuku_new_reply_header_number').innerHTML = '&nbsp;' + newReplies + '&nbsp;\u4EBA\u304C';

				Akahuku.updateViewers(o.responseText.match(
					/<li>\u73FE\u5728(\d+)\u4EBA/i));
				Akahuku.updateWarning(o.responseText.match(
					/<font color="?#f00000"?><b>(\u3053\u306E\u30B9\u30EC\u306F\u53E4\u3044\u306E\u3067[^<]+)<\/b><\/font>/i));
				Akahuku.updateExpiration(o.responseText.match(
					/<small>((?:\d{2}\u6708)?(?:\d{2}\u65E5)?\d{2}:\d{2}\u9803\u6D88\u3048\u307E\u3059)<\/small>/i));
				Akahuku.updateReplyNumber();
			}
			if (newReplies > 0) {
				this.setStatus('\u65B0\u7740\u30EC\u30B9: ' + newReplies);
				if ($('akahuku_thread_status_container'))
					$('akahuku_thread_status_container').style.display = 'block';
				Akahuku.fn.reply && Akahuku.fn.reply.startReplyScan(lastReply.tableElement);
				!this.silent && this.scrollToNewReplies();
			}
			else
				this.setStatus('\u65B0\u7740\u30EC\u30B9\u306A\u3057');
			break;
		case 304:
			this.setStatus('\u65B0\u7740\u30EC\u30B9\u306A\u3057');
			break;
		case 404:
			this.setStatus('Not Found. \u30B9\u30EC\u30C3\u30C9\u304C\u6D88\u3048\u305F\u3088\u3046\u3067\u3059\u3002', true);
			break;
		default:
			this.setStatus('load error: ' + o.status + (o.statusText ? ' [' + o.statusText + ']' : ''), true);
			break;
		}
		this.reloadRequest = null;
	},
	scrollToNewReplies: function () {
		var header = $('akahuku_new_reply_header');
		if (!header) return;

		var s = document.body.currentStyle || document.defaultView.getComputedStyle(document.body, ''),
			m = windowScrollInfo.scrollTop() + parseInt(windowScrollInfo.clientHeight() / 2),
			diff = Akahuku.getElementPosition(header.nextSibling).y + parseInt(s.marginTop, 10) - m,
			step = diff / 8;
		if (diff <= 0) return;

		if (Akahuku.allowUIAnimation)
			setTimeout(function () {
				if (diff <= 0) {diff = step = null; return;}
				scrollTo(0, parseInt(windowScrollInfo.scrollTop() + step));
				diff -= step;
				setTimeout(arguments.callee, 1);
			}, 10);
		else
			scrollTo(0, windowScrollInfo.scrollTop() + diff);
	},
	applyDeletedReplies: function (response, lastReply) {
		var re, re2, re3, input, total = 0, delta = 0, 
			dispdel = window.dispdel != undefined ? window.dispdel : 1,
			lastInputName = lastReply.inputElement.getAttribute('name') - 0,
			regex1 = /(<table[^>]+\bclass=["']?deleted["']?[^>]*>)((?:.|\r|\n)+?)<\/table>/ig,
			regex2 = /<input[^>]+\bname=['"]?(\d+)['"]?[^>]*>/i,
			regex3 = /<blockquote[^>]*>((?:.|\r|\n)+?)<\/blockquote>/i,
			f = function (table) {
				total++;
				if (/\bdeleted\b/.test(table.getAttribute('class'))) return;

				delta++;
				table.setAttribute('class', ((table.getAttribute('class') || '') + ' deleted').replace(/^\s+|\s+$/g, ''));
				table.style.display = dispdel ? 'table' : 'none';

				var bq;
				if (input.getAttribute('name') - 0 <= lastInputName && (re3 = regex3.exec(re[2])) && (bq = $T('blockquote', table)[0])) {
					bq.innerHTML = '<del>' + bq.innerHTML + '</del><br>' + re3[1];
					//TODO: extract sub, name, email
				}
			};

		while ((re = regex1.exec(response))) 
			(re2 = regex2.exec(re[2])) && (input = $N(re2[1])[0]) && $P(input, 'table', f);

		if (total) {
			$('ddel') && ($('ddel').style.display = 'inline');
			$('ddnum') && ($('ddnum').innerHTML = total);
		}

		return {total:total, delta:delta};
	},
	appendNewReplies: function (response, lastReply) {
		var fragment = document.createDocumentFragment(),
			replyStartTag = '',
			replyEndTag = '',
			newReplies = 0,
			index = response.search(new RegExp('<input.+?name="?' + lastReply.inputElement.name + '"?')),
			index2 = 0,
			firstIndex = 0,
			terminator = $('akahuku_thread_bottom_container'),
			//pos = {left: windowScrollInfo.scrollLeft(), top: windowScrollInfo.scrollTop()},

			currentReplyTable = null,
			currentReplyTd = null,
			newReplyHeader = null,

			showMailHandler = Akahuku.allowShowMail && Akahuku.fn.reply ?
				Akahuku.fn.reply.showMail.bind(Akahuku.fn.reply) : emptyfunc,
			mowHandler = Akahuku.allowSorrowVipper && Akahuku.fn.reply ?
				Akahuku.fn.reply.mow.bind(Akahuku.fn.reply) : emptyfunc,

			hideNGWordHandler = (window.Aima_Aimani && Aima_Aimani.hideNGWordHandler) ?
				Aima_Aimani.hideNGWordHandler : emptyfunc,
			hideNGNumberHandler = (window.Aima_Aimani && Aima_Aimani.hideNGNumberHandler) ?
				Aima_Aimani.hideNGNumberHandler : emptyfunc;

		// find comment wrapper tag
		if (/(<td\s+bgcolor=["']?#f0e0d6["']?\s*>)(?:.|\r|\n)+?(<\/td>)/i.exec(response)) {
			replyStartTag = RegExp.$1;
			replyEndTag = RegExp.$2;
		}
		else {
			replyStartTag = '<td bgColor=#f0e0d6>';
			replyEndTag = '</td>';
		}

		// new reply header
		newReplyHeader = $('akahuku_new_reply_header');
		if (newReplyHeader) {
			/*
			if (newReplyHeader.style.display == 'block' && 
				Akahuku.getElementPosition(newReplyHeader).y < pos.top) {

				var s = newReplyHeader.currentStyle || 
					document.defaultView.getComputedStyle(newReplyHeader, '');

				pos.top -= 
					newReplyHeader.offsetHeight + 
					parseInt(s.marginTop, 10) +
					parseInt(s.marginBottom, 10);
			}
			*/
			newReplyHeader.parentNode.removeChild(newReplyHeader);
		}

		// set up the last reply table
		lastReply.tableElement = lastReply.tableElement ? lastReply.tableElement.cloneNode(true) : this.createTable(response);
		lastReply.tableElement.removeAttribute('class');
		$T('td', lastReply.tableElement)[1].removeAttribute('__reparsed');
		Akahuku.updateReplyPrefix(lastReply.tableElement);

		// append new replies. if the last reply exists in the reponse text, 
		// it's OK that a new replies from the following of the last reply to the end is only appended.
		// otherwise, it's necessary to loop while testing if the number of each replies is larger than
		// the number of the last reply.
		var needStrictScan = index < 0;
		var numberRegex = /name=['"]?(\d+)/;
		var lastReplyName = parseInt(lastReply.inputElement.name);
		var nullReply = [-1, -1];

		for (firstIndex = index = response.indexOf(replyStartTag, index); 
			(index >= 0) && ((index2 = response.indexOf(replyEndTag, index)) >= 0); 
			index = response.indexOf(replyStartTag, index2)) {

			var currentReplyText = response.substring(index + replyStartTag.length, index2);

			if (needStrictScan && parseInt((numberRegex.exec(currentReplyText) || nullReply)[1]) <= lastReplyName) 
				continue;

			if (newReplies++ == 0) 
				terminator.parentNode.insertBefore((newReplyHeader || Akahuku.createNewReplyHeader()), terminator);

			currentReplyTable = lastReply.tableElement.cloneNode(true);
			currentReplyTd = $T('td', currentReplyTable)[1];
			currentReplyTd.innerHTML = currentReplyText;

			showMailHandler(currentReplyTd);
			hideNGNumberHandler (currentReplyTd);
			hideNGWordHandler (currentReplyTd);

			fragment.appendChild(currentReplyTable);
		}

		terminator.parentNode.insertBefore(fragment, terminator);
		//scrollTo(pos.left, pos.top);
		newReplies && Akahuku.fn.window.updateAzad(response);

		if ((newReplies || this.reloadCount < 3) && window.opera && Akahuku.allowUseUniteCache) {
			if (this.reloadCount == 0)
				Akahuku.uniteHelper.notifyReplies(response);
			else if (firstIndex >= 0 && index2 >= 0)
				Akahuku.uniteHelper.notifyReplies(response.substring(firstIndex, index2 + replyEndTag.length));
			else 
				Akahuku.uniteHelper.notifyReplies('');
		}

		this.reloadCount++;

		return newReplies;
	},
	handlePostFormSubmit: function (form) {
		if (Akahuku.isReply && (!Akahuku.allowAlterThread || $('akahuku_postmode_reply').checked)) {
			var iframe = this.createPostTargetIframe(form, this.handlePostIframeLoad.$bind(this));
			document.body.appendChild(iframe);

			// first, scroll to bottom of page
			Akahuku.ensureDispLastReply();

			// just submit.
			// onload event handler added to the iframe does remaining things.
			this.setStatus('\u30EC\u30B9\u9001\u4FE1\u4E2D...', true);
			this.replying = true;
			form.submit();
			return true;
		}
	},
	getBody: function (s) {
		var re = (s || '').match(/<body[^>]*>(.*)$/i);
		return (re ? re[1].replace(/<\/body>.*$/i, '') : s.replace(/<!DOCTYPE[^>]+>\r?\n?/i, '')) || '\u306a\u3093\u304b\u5909\u3067\u3059';
	},
	handlePostIframeLoad: function (e) {
		var iframeDocument = null;

		do {
			try { 
				if (e.t && e.t.contentDocument && e.t.contentDocument.location &&
					/^http:\/\/[^.]+\.2chan\.net(?::\d+)?\//.test(e.t.contentDocument.location.href)) {
					iframeDocument = e.t.contentDocument;
					break; 
				}
			} catch (ex) {}

			try { 
				if (e.t && e.t.contentWindow && e.t.contentWindow.document && e.t.contentWindow.document.location &&
					/^http:\/\/[^.]+\.2chan\.net(?::\d+)?\//.test(e.t.contentWindow.document.location.href)) {
					iframeDocument = e.t.contentWindow.document;
					break; 
				}
			} catch (ex) {}
		} while (false);

		if (!iframeDocument) return;

		// clear flag
		this.replying = false;

		// get html source, and jump to blank page at once to prevent refreshing
		var htmlsrc = iframeDocument.documentElement.outerHTML.replace(/\r\n|\r|\n/g, '\t');
		e.t.src = 'about:blank';

		// seems to have succeeded ?
		if (/\u5207\u308A\u66FF\u3048\u307E\u3059/.test(htmlsrc)) {
			this.setStatus(
				'\u30EC\u30B9\u9001\u4FE1\u4E2D(' +
				this.getBody(htmlsrc).replace(/<br\/?>/ig, ' ') +
				')...', true);

			// if exists php warning, log it.
			/warning/i.test(htmlsrc) && Akahuku.log(htmlsrc);

			// according to behavior of refreshing html,
			// do differential reload after it waits for a few moment.
			// in the futaba servers, keep-alive seems to be a very short value.
			// perhaps, it's about a second. then, we shorten the waiting time to
			// reload than the default.
			setTimeout(function () {
				var anchor = $('akahuku_reloader_anchor');
				$click(anchor);

				Akahuku.fn.postForm.resetForm('ftxa', 'upfile', 'baseform');

				if ($('akahuku_floatpostform_container') &&
					$('akahuku_floatpostform_container').style.display == 'block' &&
					$('akahuku_floatpostform_clipper').checked &&
					Akahuku.fn.postForm) {
					Akahuku.fn.postForm.handleFloatPostFormOpenerClick();
					Akahuku.fn.postForm.fieldFocused = false;
					Akahuku.allowFloatPostFormAlpha && Akahuku.setOpacity($('postbox_container'), 0.3);
				}
			}, 500);
		}
		// something error ? (ex. missing comment, length overed, and so on)
		else if (/<font[^>]*><b>(.*?)(?:<br\s*\/?>)+<a[^>]*>\u30EA\u30ED\u30FC\u30C9<\/a>/i.test(htmlsrc)) {
			this.setStatus('', true);
			var s = RegExp.$1
				.replace(/<br\s*\/?>/ig, '\n')
				.replace(/<[^>]+>/ig, ' ')
				.replace(/(\s|\t|\n)+/g, ' ');
			Akahuku.log(s);
			alert(s);
		}
		// server's fatal error ? (ex. full viewers, and so on)
		else {
			this.setStatus('', true);
			var s = this.getBody(htmlsrc)
				.replace(/<br\s*\/?>/ig, '\n')
				.replace(/<[^>]+>/ig, '')
				.replace(/(\s|\t|\n)+/g, ' ');
			Akahuku.log(s);
			alert(s);
		}

		// release itself from dom tree
		e.t.parentNode.removeChild(e.t);
	}
});

/** AkahukuCatalogWork: catalog enhancement */
if (Akahuku.isCatalog) {
	MergeItemClass = function (td, innerHTML, index, threadId, currentReplyNumber, oldReplyNumber) {
		this.td = td;
		this.innerHTML = innerHTML;
		this.index = index;
		this.threadId = threadId;
		this.currentReplyNumber = currentReplyNumber;
		this.oldReplyNumber = oldReplyNumber;
	};
	var PopupClass;
	(PopupClass = function (targetImage) {
		this.state = 0;
			/* state number means:
			 *	 0: waiting zooming in
			 *	 1: zooming in
			 *	 2: active
			 *	 3: zooming out
			 *	 4: realeased all references and waiting to delete
			 */
		this.targetImage = targetImage;
		this.manager = null;
		this.key = '';
		this.popup = null;
		this.zoomFactor = 0;
		this.timerID = null;
		this.targetImageGeometry = null;
	}).prototype = {
		updateImageGeometry: function () {
			var pos = Akahuku.getElementPosition(this.targetImage);
			return {
				'left' : pos.x - (window.opera ? 1 : 0),
				'top' : pos.y - (window.opera ? 1 : 0),
				'width' : parseInt(this.targetImage.width),
				'height' : parseInt(this.targetImage.height)
			};
		},
		updatePopupGeometry: function (size) {
			var targetImageGeometry = this.targetImageGeometry;
			if (targetImageGeometry) {
				var w = parseInt(targetImageGeometry.width),
					h = parseInt(targetImageGeometry.height),
					pw = parseInt(size * (h > w ? (w / h) : 1)),
					ph = parseInt(size * (w > h ? (h / w) : 1));

				this.popup.firstChild.firstChild.width = pw;
				this.popup.firstChild.firstChild.height = ph;
				this.popup.style.left = (targetImageGeometry.left + parseInt(w / 2) - parseInt(pw / 2)) + 'px';
				this.popup.style.top = (targetImageGeometry.top + parseInt(h / 2) - parseInt(ph / 2)) + 'px';
			}
		},
		zoomin: function () {
			if (this.state != 1) return;
			if (this.zoomFactor < 90) {
				this.zoomFactor += 7;
				if (this.zoomFactor > 90) this.zoomFactor = 90;
				this.updatePopupGeometry(Math.sin(Math.PI / 180 * this.zoomFactor) * (Akahuku.numberCatalogZoomSize - 50) + 50);
			}
			else
				this.run(2);
		},
		zoomout: function () {
			if (this.state != 3) return;
			if (this.zoomFactor > 0) {
				this.zoomFactor -= 7;
				if (this.zoomFactor < 0) this.zoomFactor = 0;
				this.updatePopupGeometry(Math.sin(Math.PI / 180 * this.zoomFactor) * (Akahuku.numberCatalogZoomSize - 50) + 50);
			}
			else
				this.run(4);
		},
		queryPurge: function () {
			var result = false;

			switch (this.state) {
			case 0:
				this.run(4);
				/* FALLTHRU */
			case 4:
				// returning true, means 'purge me'
				result = true;
				break;
			case 1:
			case 2:
				this.run(3);
				break;
			}

			return result;
		},
		run: function (state) {
			var self = this;

			if (this.timerID) {
				clearTimeout(this.timerID);
				this.timerID = null;
			}

			switch (this.state = state) {
			case 0:
				this.targetImageGeometry = this.updateImageGeometry();
				this.timerID = setTimeout(function () {
					var element = Akahuku.getElementFromPoint(Akahuku.pageX, Akahuku.pageY);
					if (element && element == self.targetImage) {
						self.popup = $E(document.body, 'div', {style:{position:'absolute'}});

						var cached = true, image = self.manager.cacheImages.getCache(self.key);
						if (!image) {
							image = $E(null, 'img', {
								src:(self.targetImage.src || self.targetImage.longDesc).replace('/cat/', '/thumb/'),
								style:{border:'1px solid #0040e0'}});

							self.manager.cacheImages.register(self.key, image);
							cached = false;
						}
						var anchor = self.targetImage.parentNode.cloneNode(false);
						anchor.style.display = 'block';
						self.popup.appendChild(anchor).appendChild(image);
						self.updatePopupGeometry(50);
						self.zoomFactor = 0;

						if ((cached || image.complete) && !image.__errored)
							self.run(1);
						else
							if (image.__errored)
								self.run(2);
							else {
								image.onload = function () {
									this.onload = null;
									self.run(1);
								};
								image.onerror = function () {
									this.onload = this.onerror = null;
									this.__errored = true;
									this.removeAttribute('src');
									self.run(2);
								};
							}
					}
					else
						self.run(4);
				},
				!this.manager.cacheImages.exists(self.key) && Akahuku.numberCatalogZoomTimeout < 1000 ? 1000 : Akahuku.numberCatalogZoomTimeout);
				break;
			case 1:
				this.manager.addEffector(this, this.zoomin);
				break;
			case 2:
				this.manager.removeEffector(this);
				var targetAnchor = null;
				for (var tmp = this.targetImage; tmp; tmp = tmp.parentNode)
					if (tmp.nodeName.toLowerCase() == 'a')
						targetAnchor = tmp;
					else if (tmp.nodeName.toLowerCase() == 'td') {
						var innerHTML = '',
							className = 'akahuku_zoomedpopup_anchor';

						if ($T('img', this.popup)[0].__errored) {
							innerHTML = '\u30D5\u30A1\u30A4\u30EB\u304C\u7121\u3044\u3088';
							className = 'akahuku_zoomedpopup_errored_anchor';
						}
						else {
							var fonts = $T('font', tmp);
							if (fonts && fonts[0])
								innerHTML += fonts[0].innerHTML;
							var divs = $T('div', tmp);
							if (divs && divs[0])
								innerHTML += '(' + divs[0].innerHTML + ')';
						}

						if (innerHTML != '' && targetAnchor) {
							var anchor = targetAnchor.cloneNode(false);
							anchor.className = className;
							anchor.innerHTML = innerHTML;
							this.popup.appendChild(anchor);
						}
						break;
					}
				break;
			case 3:
				var anchors = $T('a', this.popup);
				if (anchors && anchors[1])
					anchors[0].parentNode.removeChild(anchors[1]);
				this.manager.addEffector(this, this.zoomout);
				break;
				break;
			case 4:
			default:
				this.manager.removeEffector(this);
				if (this.popup) {
					this.popup.parentNode.removeChild(this.popup);
					this.popup = this.popup.firstChild.firstChild.onload = this.popup.firstChild.firstChild.onerror = null;
				}
				this.manager = this.targetImage = null;
				break;
			}
		}
	};
	Akahuku.add({
		request: null,
		defaultColumns: 15,
		columns: 15,
		order: 'akahuku_catalog_reorder',
		latestThread: 0,
		setStatus: Akahuku.createStatusIndicator('akahuku_catalog_reloader_status'),
		signature: 'catalog',
		initialize: function () {
			var style = new StyleWrapperClass();
			style
				.a('#cat td a font', 'color:#800000;')
				.a('#cat td a small', 'color:#789922;')
				.a('#cat td a small.akahuku_celltext', 'display:block;color:blue;width:50px;overflow:hidden;cursor:pointer')
				.a('#cat td a', 'text-decoration:none');
			if (Akahuku.allowCatalogReorder)
				style.a('#cat th', 'padding-left:8px;padding-right:8px');
			if (Akahuku.allowCatalogHilightVisited)
				style.a('#cat td a:visited', 'background-color:#eeaa88')
					.a('#cat td a:visited font', 'color:#008000;background-color:#eeaa88');
			if (Akahuku.allowBackgroundLoadCatalog)
				style.a('div.akahuku_cell', 'margin:0;padding:0;font-size:80%;color:#cc1105');
			if (Akahuku.allowCatalogZoom) {
				style.a('a.akahuku_zoomedpopup_anchor', 'background-color:#0040e0;color:#ffffff;font-size:80%;padding:0 4px 0 4px')
					.a('a.akahuku_zoomedpopup_errored_anchor', 'background-color:#ffffee;color:red;border:1px solid red;font-size:80%;padding:0 4px 0 4px');
				if (Akahuku.allowCatalogHilightVisited)
					style.a('a.akahuku_zoomedpopup_anchor:visited', 'background-color:#e04000');
			}
			style.apply();
		},
		start: function () {
			var table = $T('table')[1];
			if (!table) return;
			table.id = 'cat';

			var lastRule = null;
			for (var node = table.nextSibling; node; node = node.nextSibling)
				if (node.nodeName.toLowerCase() == 'hr') {
					lastRule = node;
					break;
				}
			if (!lastRule) return;

			var nodes = $T('tr', table);
			if (nodes && nodes[0]) 
				this.defaultColumns = this.columns = $T('td', nodes[0]).length;

			var nodes = $T('td', table);
			for (var i = 0; i < nodes.length; i++) {
				var anchors = $T('a', nodes[i]), fonts = $T('font', nodes[i]);
				if (anchors.length == 0 || fonts.length == 0) continue;
				nodes[i].__original_index = i;
				nodes[i].__thread_id = this.getThreadNumber(anchors[0].href);
				nodes[i].__reply_number = fonts[0].innerHTML;

				this.updateCellInnerHTML(nodes[i]);

				if (parseInt(nodes[i].__thread_id) > this.latestThread)
					this.latestThread = parseInt(nodes[i].__thread_id);
			}
			if (Akahuku.allowBackgroundLoadCatalog) {
				var div = $E(table.parentNode, 'div', {
					innerHTML:
						'[<a id="akahuku_catalog_reloader_anchor" href="#reload">\u6700\u65B0\u306B\u66F4\u65B0</a>]&nbsp;' +
						'<font id="akahuku_catalog_reloader_status" style="font-size:80%"></font>',
					style:{margin:'0.25em 0 0.25em 0'}}, table);

				var div2 = lastRule.parentNode.insertBefore(div.cloneNode(true), lastRule);
				div2.innerHTML =
					'[<a id="akahuku_catalog_reloader_anchor2" href="#reload">\u6700\u65B0\u306B\u66F4\u65B0</a>]&nbsp;';

				var handler = this.handleReloadClick.$bind(this);
				$Event('akahuku_catalog_reloader_anchor', 'click', handler);
				$Event('akahuku_catalog_reloader_anchor2', 'click', handler);
			}
			if (Akahuku.allowCatalogReorder) {
				var font = $E($T('font', $T('table')[0])[0], 'font', {
						id:'akahuku_catalog_mode_indicator',
						style:{fontSize:'80%', color:'white', fontWeight:'normal', marginLeft:'8px'}}),
					handler = this.handleReorderClick.$bind(this),
					div = $E(table.parentNode, 'div', {style:{textAlign:'center', fontSize:'80%', margin:'4px'}}, table.nextSibling);

				var createSortOrderAnchor = function (aid, content, hash) {
					var anchor = $E(div, 'a', {
						id:aid,
						href:'#' + hash,
						innerHTML:content,
						style:{marginLeft:'1em'}});
					$Event(anchor, 'click', handler);
				};

				createSortOrderAnchor(
					'akahuku_catalog_reorder',
					'\u66F4\u65B0\u9806\u306B' + this.defaultColumns + '\u305A\u3064',
					'sort_');
				createSortOrderAnchor(
					'akahuku_catalog_reorder_10',
					'\u66F4\u65B0\u9806\u306B10\u305A\u3064',
					'sort_10');
				createSortOrderAnchor(
					'akahuku_catalog_reorder_reply',
					'\u30EC\u30B9\u306E\u591A\u3044\u9806\u306B10\u305A\u3064',
					'sort_reply');
				createSortOrderAnchor(
					'akahuku_catalog_reorder_createtime',
					'\u30B9\u30EC\u306E\u7ACB\u3063\u305F\u9806\u306B10\u305A\u3064',
					'sort_createtime');
				Akahuku.allowReplyNumberDelta && createSortOrderAnchor(
					'akahuku_catalog_reorder_delta',
					'\u30EC\u30B9\u306E\u5897\u52A0\u5206\u3067' + this.defaultColumns + '\u305A\u3064',
					'sort_delta');

				if (location.href.match(/#sort_([a-z0-9]+)/))
					$click('akahuku_catalog_reorder_' + RegExp.$1);
			}
			if (Akahuku.allowCatalogZoom) {
				if (Akahuku.numberCatalogZoomTimeout <= 0)
					Akahuku.numberCatalogZoomTimeout = 10;
				if (Akahuku.numberCatalogZoomSize == 0)
					Akahuku.numberCatalogZoomSize = 96;
				if (Akahuku.numberCatalogZoomSize < 50)
					Akahuku.numberCatalogZoomSize = 50;
				if (Akahuku.numberCatalogZoomSize > 250)
					Akahuku.numberCatalogZoomSize = 250;

				$Event(document.body, 'mouseover', this.handleBodyMouseover.$bind(this));
			}
			$Event(document.body, 'click', this.handleBodyClick.$bind(this));
		},
		replaceTable: function (oldTable, mergedItems) {
			var createRowHeader = function (order, tr, i) {
				if (order == 'akahuku_catalog_reorder_10') {
					var pageno = parseInt(i / 10);
					$E(tr, 'th', {
						innerHTML:
							'<a href="' + (pageno == 0 ? 'futaba' : pageno) + '.htm' +
							'" target="_blank">' + pageno + '</a>'});
				}
			};
			var newTable = oldTable.cloneNode(false),
				tbody = $E(newTable, 'tbody'),
				tr = null,
				columns = this.columns;

			newTable.id = 'tmp';
			oldTable.parentNode.insertBefore(newTable, oldTable);
			oldTable.style.display = 'none';
			var latestThread = parseInt(mergedItems[0].threadId);

			for (var i = 0; i < mergedItems.length; i++) {
				if (i % columns == 0) {
					tr = $E(tbody, 'tr');
					createRowHeader(this.order, tr, i);
				}

				if (parseInt(mergedItems[i].threadId) > latestThread)
					latestThread = parseInt(mergedItems[i].threadId);

				var td = null;
				if (mergedItems[i].td) {
					td = mergedItems[i].td;
					if (mergedItems[i].oldReplyNumber != undefined)
						td.__old_reply_number = mergedItems[i].oldReplyNumber;
				}
				else {
					td = $E(null, 'td', {innerHTML:
						this.getReplyNumberDelta(
							parseInt(mergedItems[i].threadId) <= this.latestThread ? 'up' : 'new', true) +
						mergedItems[i].innerHTML});

					this.updateCellInnerHTML(td);
				}

				td.__original_index = mergedItems[i].index;
				td.__reply_number = mergedItems[i].currentReplyNumber;
				td.__thread_id = mergedItems[i].threadId;
				tr.appendChild(td);
			}

			// now a new table was completed.
			// replace this with an old table
			this.latestThread = latestThread;
			oldTable.parentNode.removeChild(oldTable);
			newTable.id = 'cat';

			// perhaps, if innerHTML is modified, room for throwing away the image will be given to IE.
			// therefore, only merge previously, and update innerHTML after completing the replacement
			// of the table.
			setTimeout((function () {
				for (var i = 0, nodes = $T('td', newTable), goal = nodes.length; i < goal; i++) {
					if (!nodes[i].__old_reply_number || nodes[i].__old_reply_number == '') continue;

					if (Akahuku.allowReplyNumberDelta) {
						var div = $T('div', nodes[i]),
							delta = this.getReplyNumberDelta(
							parseInt(nodes[i].__reply_number) - parseInt(nodes[i].__old_reply_number));

						div = div && div.length ? div[0] : null;

						if (delta == '')
							div && div.parentNode.removeChild(div);
						else {
							if (!div) div = $E(nodes[i], 'div', {'class':'akahuku_cell'}, nodes[i].firstChild);
							div.innerHTML = delta;
						}
					}

					nodes[i].__old_reply_number = '';
					nodes[i].removeAttribute('__old_reply_number');

					var fonts = $T('font', nodes[i]);
					if (fonts && fonts.length) {
						fonts[fonts.length - 1].innerHTML = nodes[i].__reply_number;
					}
				}
			}).bind(this), 50);
		},
		getReplyNumberDelta: function (delta, tag) {
			if (Akahuku.allowReplyNumberDelta) {
				if (!isNaN(delta))
					if (delta > 0) delta = '+' + delta; else if (delta == 0) delta = '';
				return delta == '' ? delta : tag ? '<div class="akahuku_cell">' + delta + '</div>' : delta;
			}
			else
				return '';
		},
		getThreadNumber: function (s) {
			var re;
			if (re = s.match(/[^\/]+\/(\d+)\.html?/)) return re[1] - 0;
			if (re = s.match(/\?[^?]*res=(\d+)/)) return re[1] - 0;
			return 0;
		},
		updateCellInnerHTML: function (tdElement) {
			var anchor = $T('a', tdElement)[0];
			if (anchor) {
				if (Akahuku.allowWindowNaming)
					anchor.setAttribute('target', Akahuku.getWindowName(anchor.href));
				if (Akahuku.allowCatalogFullClickable &&
					/^(?:<small>)?[\s\u3000]*(?:<\/small>)?$/i.test(anchor.innerHTML)) {
					anchor.innerHTML = '(\u7A7A\u767D)';
					anchor.style.fontSize = '80%';
					anchor.style.color = 'red';
				}
				if ($T('img', anchor).length == 0) {
					if (Akahuku.allowMarkTextOnlyThread) {
						anchor.title = anchor.innerText;

						if (Akahuku.allowHideTextOnlyThread)
							tdElement.innerHTML = '<br>';
						else {
							anchor.innerHTML = '\u6587\u5B57<br>\u975E\u8868\u793A';
							anchor.style.fontSize = '80%';
							anchor.style.color = 'red';
						}
					}
					else if (Akahuku.allowSorrowVipper)
						anchor.innerHTML = Akahuku.fn.reply.getMowedHTML(anchor.innerHTML);

					var tmp = $T('small', anchor);
					if (tmp[0]) tmp[0].className = 'akahuku_celltext';
				}
				else /*if (Akahuku.allowCatalogHilightVisited)*/ {
					var tmp;
					while (tmp = anchor.nextSibling) {
						if (tmp.nodeType == 1 && tmp.nodeName.toLowerCase() != 'a' || tmp.nodeType == 3)
							anchor.appendChild(tmp);
						else
							tmp.parentNode.removeChild(tmp);
					}
				}

				if (/^(?:may|dec)$/.test(Akahuku.serverName)) {
					var tmp = $T('small', tdElement)[0];
					if (tmp) 
						tmp.innerHTML = tmp.innerHTML.replace(/.\/small(?:>|&gt;)/, '');
				}
			}
		},
		sort: function (mergedItems, sortId) {
			if (!sortId)
				sortId = this.order;

			var columns = 10;

			switch (sortId) {
			case 'akahuku_catalog_reorder':
				columns = this.defaultColumns;
				/* FALLTHRU */
			case 'akahuku_catalog_reorder_10':
				mergedItems.sort(function (x, y) {
					return x.index - y.index;
				});
				break;
			case 'akahuku_catalog_reorder_reply':
				mergedItems.sort(function (x, y) {
					var result = y.currentReplyNumber - x.currentReplyNumber;
					return result ? result : y.threadId - x.threadId;
				});
				break;
			case 'akahuku_catalog_reorder_createtime':
				mergedItems.sort(function (x, y) {
					return y.threadId - x.threadId;
				});
				break;
			case 'akahuku_catalog_reorder_delta':
				var latestThread = this.latestThread - 0;
				columns = this.defaultColumns;

				// divide mergedItems array into:
				//	first:	- the thread which increased or decreased of replies.
				//			- the new thread.
				//
				//	  * first array sorted by reply delta, replies, neutral index.
				//	  * in the case of the new thread, treat the number of replies for reply delta.
				//
				//	second: - the thread which NOT increased and decreased of replies.
				//			- the thread which floated up.
				//
				//	  * second array sorted by replies, neutral index.
				var t1 = [], t2 = [];

				for (var i = 0; i < mergedItems.length; i++) {
					// new thread
					if (isNaN(parseInt(mergedItems[i].oldReplyNumber)) && parseInt(mergedItems[i].threadId) > latestThread)
						t1.push(mergedItems[i]);
					// thread which increased/decreased of replies
					else if (!isNaN(parseInt(mergedItems[i].oldReplyNumber)) && mergedItems[i].currentReplyNumber != mergedItems[i].oldReplyNumber)
						t1.push(mergedItems[i]);
					// other
					else
						t2.push(mergedItems[i]);
				}

				t1.sort(function (x, y) {
					var 
					deltay = isNaN(parseInt(y.oldReplyNumber))
						? (y.currentReplyNumber)
						: (y.currentReplyNumber - y.oldReplyNumber),
					deltax = isNaN(parseInt(x.oldReplyNumber))
						? (x.currentReplyNumber)
						: (x.currentReplyNumber - x.oldReplyNumber),

					result = deltay - deltax;
					if (result) return result;

					result = y.currentReplyNumber - x.currentReplyNumber;
					if (result) return result;

					result = x.index - y.index;
					return result;
				});

				t2.sort(function (x, y) {
					return y.currentReplyNumber - x.currentReplyNumber;
					//return x.index - y.index;
				});

				// bad code
				t1 = t1.concat(t2);
				for (i = 0; i < t1.length; i++)
					mergedItems[i] = t1[i];

				break;
			}
			return columns;
		},
		mergeCellNodes: function (oldTable, response) {
			var index = 0,
				index2 = 0,
				mergedItems = [],
				oldCells = [],
				count = 0,
				startTag = '<td>',
				endTag = '</td>',
				re = /<(table)\s+border\s*=\s*['"]?\d+['"]?\s+align\s*=\s*['"]?\w+['"]?[^>]*>/i.exec(response);

			if (re) {
				index = response.indexOf(re[0]);

				if (re[1] == 'TABLE') {
					startTag = startTag.toUpperCase();
					endTag = endTag.toUpperCase();
				}
			}

			// make hash table to get TD element by which the thread number becomes a key
			for (var i = 0, nodes = $T('td', oldTable); i < nodes.length; i++)
				oldCells[nodes[i].__thread_id] = nodes[i];

			for (index = response.indexOf(startTag, index); index >= 0; index = response.indexOf(startTag, index2)) {
				index2 = response.indexOf(endTag, index);
				if (index2 < 0) break;

				var currentTdText = response.substring(index + startTag.length, index2),
					replyNumber = currentTdText.match(/<font[^>]*>(\d+)<\/font>/i),
					threadId = this.getThreadNumber(currentTdText);

				if (replyNumber && threadId) {
					replyNumber = replyNumber[1];

					if (oldCells[threadId])
						mergedItems.push(new MergeItemClass(
							oldCells[threadId], '', count++, threadId, replyNumber, oldCells[threadId].__reply_number));
					else
						mergedItems.push(new MergeItemClass(
							null, currentTdText, count++, threadId, replyNumber));
				}
			}

			return mergedItems;
		},
		handleReorderClick: function (e) {
			var getMergedItems = function () {
				var mergedItems = [],
					oldCells = $T('td', oldTable),
					oldReplyNumber;

				for (var i = 0; i < oldCells.length; i++) {
					oldReplyNumber = $T('div', oldCells[i])[0];
					oldReplyNumber = (!oldReplyNumber || isNaN(parseInt(oldReplyNumber.innerHTML)))
						? undefined
						: (oldCells[i].__reply_number - parseInt(oldReplyNumber.innerHTML));
					mergedItems.push(new MergeItemClass(
						oldCells[i], '', oldCells[i].__original_index, oldCells[i].__thread_id, oldCells[i].__reply_number, oldReplyNumber));
				}
				return mergedItems;
			};

			var oldTable = $('cat');
			if (!oldTable) return;

			var mergedItems = getMergedItems();
			if (mergedItems.length > 0) {
				this.columns = this.sort(mergedItems, e.t.id);
				this.order = e.t.id;
				this.replaceTable(oldTable, mergedItems);

				var indicator = $('akahuku_catalog_mode_indicator');
				if (indicator)
					indicator.innerHTML = '[' + e.t.innerHTML + ']';
			}
		},
		reload: function () {
			$click('akahuku_catalog_reloader_anchor');
		},
		handleReloadClick: function (e) {
			e.p();
			var oldTable = $('cat');
			if (!oldTable) return;

			var rbracket = e.t.nextSibling;
			if (rbracket &&
				(!rbracket.nextSibling || rbracket.nextSibling.nodeName.toLowerCase() != 'font')) {
				var status = $('akahuku_catalog_reloader_status');
				status.parentNode.removeChild(status);
				rbracket.parentNode.insertBefore(status, rbracket.nextSibling);
			}
			if (this.request) {
				this.request.abort();
				this.request = null;
				this.setStatus('\u4E2D\u65AD\u3055\u308C\u307E\u3057\u305F');
				return;
			}
			if (Akahuku.cap.messagingEnabled && Akahuku.allowIframeReload) {
				this.request = net.bogoGet(
					location.href.replace(/#[^#]*/, ''),
					{prepare:(function() {this.setStatus('\u30ED\u30FC\u30C9\u4E2D...', true);}).bind(this),
					 finished:(function(result) {
						this.handleReloadRequestFinished({
							readyState: 4, status: 200,
							getResponseHeader: function (header) { return null; },
							responseText: result});
						}).bind(this)});
			}
			else {
				this.request = net.get(
					location.href.replace(/#[^#]*/, '') + '&' + new Date().getTime(),
					{mimeType:'text/plain;charset=Shift_JIS', noCache:true,
					 step:(function (state) {this.setStatus('\u30ED\u30FC\u30C9\u4E2D(' + state + ')...', true);}).bind(this),
					 finished:this.handleReloadRequestFinished.bind(this)});
			}
		},
		handleReloadRequestFinished: function (o) {
			if (o.status == 200) {
				var oldTable = $('cat');
				if (oldTable) {
					var mergedItems = this.mergeCellNodes(oldTable, o.responseText);
					if (mergedItems instanceof Array && mergedItems.length > 0) {
						this.sort(mergedItems);
						this.replaceTable(oldTable, mergedItems);
						this.setStatus('\u5B8C\u4E86\u3057\u307E\u3057\u305F');
						Akahuku.fn.window.updateAzad(o.responseText);
					}
					else {
						this.setStatus('\u30DE\u30FC\u30B8\u5931\u6557: ' + o.responseText.substring(0, 64), true);
						alert(o.responseText);
					}
				}
			}
			else {
				this.setStatus('load error: ' + o.status, true);
				//Akahuku.log(['*** load error: catalog reload: ', o.status]);
				//Akahuku.log(o.getAllResponseHeaders());
			}
			this.request = null;
		},

		popupManager: new PopupManagerClass(),
		handleBodyMouseover: function (e) {
			if (e.t && e.t.nodeName.toLowerCase() == 'img') {
				if (e.t.parentNode && e.t.parentNode.nodeName.toLowerCase() == 'a' &&
					e.t.src.match(/cat\/(\d+)s\.jpg$/))
					this.popupManager.addPopup(RegExp.$1, new PopupClass(e.t));
			}
			else
				this.popupManager.removeActivePopups();
		},

		handleBodyClick: function (e) {
			e.t.nodeName.toLowerCase() == 'img ' && $P(e.t, 'td', [this, function () {
				this.popupManager.removeActivePopups();
			}]);
		}
	});
}

if (document.readyState == 'loaded' || document.readyState == 'complete') 
	Akahuku.materialize2();

else if (window.ActiveXObject) 
	(Akahuku.pageManager = new DOMWatcherClass('page')).add(Akahuku.materialize2.bind(Akahuku)).start();

else {
	if (Akahuku.cap.DOMContentLoadedEnabled) 
		$Event(document, 'DOMContentLoaded', Akahuku.materialize2.bind(Akahuku));
	else 
		(Akahuku.pageManager = new DOMWatcherClass('page', function () {
			for (var nodes = $T('a'), i = nodes.length - 1; i >= 0 && i >= nodes.length - 10; i--)
				if (nodes[i].href == 'http://www.2chan.net/' && nodes[i].innerHTML == 'futaba') return true;
			return false;
		})).add(Akahuku.materialize2.bind(Akahuku)).start();
}

})(window, document);
}
/* vim: set noexpandtab foldmethod=marker foldmarker={{{,}}} ts=4 sw=4: */

